################################################################################
#
# Copyright 2020 OpenHW Group
# 
# Licensed under the Solderpad Hardware Licence, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     https://solderpad.org/licenses/
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SPDX-License-Identifier:Apache-2.0 WITH SHL-2.0
# 
################################################################################
# Script-generated, brute force and ignorance approach to running all legal CSR
# instructions for the MSCRATCH CSR. Implements all 6 real (not pseudo) CSR
# access instructions.  THIS TEST IS NOT SELF CHECKING: you must run against a
# reference model to check results.
################################################################################
.include "user_define.h"
.section .text.start
.globl _start
.section .text
#.include "user_init.s"
.type _start, @function

_start:
    j _start_main

.globl _start_main
.section .text
_start_main:

  #ifdef NO_PULP
  #define EXP_MISA 0x40001104
  #else
  #define EXP_MISA 0x40801104
  #endif

# CSR 0x340 is a 32-bit R/W scratch-pad
  # Immediates
  csrrci x0,    0x340, 0x0
  csrrsi x0,    0x340, 0x0
  csrrwi x0,    0x340, 0x0
  csrrci x0,    0x340, 0x1
  csrrsi x0,    0x340, 0x1
  csrrwi x0,    0x340, 0x1
  csrrci x0,    0x340, 0x2
  csrrsi x0,    0x340, 0x2
  csrrwi x0,    0x340, 0x2
  csrrci x0,    0x340, 0x3
  csrrsi x0,    0x340, 0x3
  csrrwi x0,    0x340, 0x3
  csrrci x0,    0x340, 0x4
  csrrsi x0,    0x340, 0x4
  csrrwi x0,    0x340, 0x4
  csrrci x0,    0x340, 0x5
  csrrsi x0,    0x340, 0x5
  csrrwi x0,    0x340, 0x5
  csrrci x0,    0x340, 0x6
  csrrsi x0,    0x340, 0x6
  csrrwi x0,    0x340, 0x6
  csrrci x0,    0x340, 0x7
  csrrsi x0,    0x340, 0x7
  csrrwi x0,    0x340, 0x7
  csrrci x0,    0x340, 0x8
  csrrsi x0,    0x340, 0x8
  csrrwi x0,    0x340, 0x8
  csrrci x0,    0x340, 0x9
  csrrsi x0,    0x340, 0x9
  csrrwi x0,    0x340, 0x9
  csrrci x0,    0x340, 0xa
  csrrsi x0,    0x340, 0xa
  csrrwi x0,    0x340, 0xa
  csrrci x0,    0x340, 0xb
  csrrsi x0,    0x340, 0xb
  csrrwi x0,    0x340, 0xb
  csrrci x0,    0x340, 0xc
  csrrsi x0,    0x340, 0xc
  csrrwi x0,    0x340, 0xc
  csrrci x0,    0x340, 0xd
  csrrsi x0,    0x340, 0xd
  csrrwi x0,    0x340, 0xd
  csrrci x0,    0x340, 0xe
  csrrsi x0,    0x340, 0xe
  csrrwi x0,    0x340, 0xe
  csrrci x0,    0x340, 0xf
  csrrsi x0,    0x340, 0xf
  csrrwi x0,    0x340, 0xf
  csrrci x0,    0x340, 0x10
  csrrsi x0,    0x340, 0x10
  csrrwi x0,    0x340, 0x10
  csrrci x0,    0x340, 0x11
  csrrsi x0,    0x340, 0x11
  csrrwi x0,    0x340, 0x12
  csrrci x0,    0x340, 0x12
  csrrsi x0,    0x340, 0x12
  csrrwi x0,    0x340, 0x12
  csrrci x0,    0x340, 0x13
  csrrsi x0,    0x340, 0x13
  csrrwi x0,    0x340, 0x13
  csrrci x0,    0x340, 0x14
  csrrsi x0,    0x340, 0x14
  csrrwi x0,    0x340, 0x14
  csrrci x0,    0x340, 0x15
  csrrsi x0,    0x340, 0x15
  csrrwi x0,    0x340, 0x15
  csrrci x0,    0x340, 0x16
  csrrsi x0,    0x340, 0x16
  csrrwi x0,    0x340, 0x16
  csrrci x0,    0x340, 0x17
  csrrsi x0,    0x340, 0x17
  csrrwi x0,    0x340, 0x17
  csrrci x0,    0x340, 0x18
  csrrsi x0,    0x340, 0x18
  csrrwi x0,    0x340, 0x18
  csrrci x0,    0x340, 0x19
  csrrsi x0,    0x340, 0x19
  csrrwi x0,    0x340, 0x19
  csrrci x0,    0x340, 0x1a
  csrrsi x0,    0x340, 0x1a
  csrrwi x0,    0x340, 0x1a
  csrrci x0,    0x340, 0x1b
  csrrsi x0,    0x340, 0x1b
  csrrwi x0,    0x340, 0x1b
  csrrci x0,    0x340, 0x1c
  csrrsi x0,    0x340, 0x1c
  csrrwi x0,    0x340, 0x1c
  csrrci x0,    0x340, 0x1d
  csrrsi x0,    0x340, 0x1d
  csrrwi x0,    0x340, 0x1d
  csrrci x0,    0x340, 0x1e
  csrrsi x0,    0x340, 0x1e
  csrrwi x0,    0x340, 0x1e
  csrrci x0,    0x340, 0x1f
  csrrsi x0,    0x340, 0x1f
  csrrwi x0,    0x340, 0x1f

  csrrci x1,    0x340, 0x0
  csrrsi x1,    0x340, 0x0
  csrrwi x1,    0x340, 0x0
  csrrci x1,    0x340, 0x1
  csrrsi x1,    0x340, 0x1
  csrrwi x1,    0x340, 0x1
  csrrci x1,    0x340, 0x2
  csrrsi x1,    0x340, 0x2
  csrrwi x1,    0x340, 0x2
  csrrci x1,    0x340, 0x3
  csrrsi x1,    0x340, 0x3
  csrrwi x1,    0x340, 0x3
  csrrci x1,    0x340, 0x4
  csrrsi x1,    0x340, 0x4
  csrrwi x1,    0x340, 0x4
  csrrci x1,    0x340, 0x5
  csrrsi x1,    0x340, 0x5
  csrrwi x1,    0x340, 0x5
  csrrci x1,    0x340, 0x6
  csrrsi x1,    0x340, 0x6
  csrrwi x1,    0x340, 0x6
  csrrci x1,    0x340, 0x7
  csrrsi x1,    0x340, 0x7
  csrrwi x1,    0x340, 0x7
  csrrci x1,    0x340, 0x8
  csrrsi x1,    0x340, 0x8
  csrrwi x1,    0x340, 0x8
  csrrci x1,    0x340, 0x9
  csrrsi x1,    0x340, 0x9
  csrrwi x1,    0x340, 0x9
  csrrci x1,    0x340, 0xa
  csrrsi x1,    0x340, 0xa
  csrrwi x1,    0x340, 0xa
  csrrci x1,    0x340, 0xb
  csrrsi x1,    0x340, 0xb
  csrrwi x1,    0x340, 0xb
  csrrci x1,    0x340, 0xc
  csrrsi x1,    0x340, 0xc
  csrrwi x1,    0x340, 0xc
  csrrci x1,    0x340, 0xd
  csrrsi x1,    0x340, 0xd
  csrrwi x1,    0x340, 0xd
  csrrci x1,    0x340, 0xe
  csrrsi x1,    0x340, 0xe
  csrrwi x1,    0x340, 0xe
  csrrci x1,    0x340, 0xf
  csrrsi x1,    0x340, 0xf
  csrrwi x1,    0x340, 0xf
  csrrci x1,    0x340, 0x10
  csrrsi x1,    0x340, 0x10
  csrrwi x1,    0x340, 0x10
  csrrci x1,    0x340, 0x11
  csrrsi x1,    0x340, 0x11
  csrrwi x1,    0x340, 0x11
  csrrci x1,    0x340, 0x12
  csrrsi x1,    0x340, 0x12
  csrrwi x1,    0x340, 0x12
  csrrci x1,    0x340, 0x13
  csrrsi x1,    0x340, 0x13
  csrrwi x1,    0x340, 0x13
  csrrci x1,    0x340, 0x14
  csrrsi x1,    0x340, 0x14
  csrrwi x1,    0x340, 0x14
  csrrci x1,    0x340, 0x15
  csrrsi x1,    0x340, 0x15
  csrrwi x1,    0x340, 0x15
  csrrci x1,    0x340, 0x16
  csrrsi x1,    0x340, 0x16
  csrrwi x1,    0x340, 0x16
  csrrci x1,    0x340, 0x17
  csrrsi x1,    0x340, 0x17
  csrrwi x1,    0x340, 0x17
  csrrci x1,    0x340, 0x18
  csrrsi x1,    0x340, 0x18
  csrrwi x1,    0x340, 0x18
  csrrci x1,    0x340, 0x19
  csrrsi x1,    0x340, 0x19
  csrrwi x1,    0x340, 0x19
  csrrci x1,    0x340, 0x1a
  csrrsi x1,    0x340, 0x1a
  csrrwi x1,    0x340, 0x1a
  csrrci x1,    0x340, 0x1b
  csrrsi x1,    0x340, 0x1b
  csrrwi x1,    0x340, 0x1b
  csrrci x1,    0x340, 0x1c
  csrrsi x1,    0x340, 0x1c
  csrrwi x1,    0x340, 0x1c
  csrrci x1,    0x340, 0x1d
  csrrsi x1,    0x340, 0x1d
  csrrwi x1,    0x340, 0x1d
  csrrci x1,    0x340, 0x1e
  csrrsi x1,    0x340, 0x1e
  csrrwi x1,    0x340, 0x1e
  csrrci x1,    0x340, 0x1f
  csrrsi x1,    0x340, 0x1f
  csrrwi x1,    0x340, 0x1f

  csrrci x2,    0x340, 0x0
  csrrsi x2,    0x340, 0x0
  csrrwi x2,    0x340, 0x0
  csrrci x2,    0x340, 0x1
  csrrsi x2,    0x340, 0x1
  csrrwi x2,    0x340, 0x1
  csrrci x2,    0x340, 0x2
  csrrsi x2,    0x340, 0x2
  csrrwi x2,    0x340, 0x2
  csrrci x2,    0x340, 0x3
  csrrsi x2,    0x340, 0x3
  csrrwi x2,    0x340, 0x3
  csrrci x2,    0x340, 0x4
  csrrsi x2,    0x340, 0x4
  csrrwi x2,    0x340, 0x4
  csrrci x2,    0x340, 0x5
  csrrsi x2,    0x340, 0x5
  csrrwi x2,    0x340, 0x5
  csrrci x2,    0x340, 0x6
  csrrsi x2,    0x340, 0x6
  csrrwi x2,    0x340, 0x6
  csrrci x2,    0x340, 0x7
  csrrsi x2,    0x340, 0x7
  csrrwi x2,    0x340, 0x7
  csrrci x2,    0x340, 0x8
  csrrsi x2,    0x340, 0x8
  csrrwi x2,    0x340, 0x8
  csrrci x2,    0x340, 0x9
  csrrsi x2,    0x340, 0x9
  csrrwi x2,    0x340, 0x9
  csrrci x2,    0x340, 0xa
  csrrsi x2,    0x340, 0xa
  csrrwi x2,    0x340, 0xa
  csrrci x2,    0x340, 0xb
  csrrsi x2,    0x340, 0xb
  csrrwi x2,    0x340, 0xb
  csrrci x2,    0x340, 0xc
  csrrsi x2,    0x340, 0xc
  csrrwi x2,    0x340, 0xc
  csrrci x2,    0x340, 0xd
  csrrsi x2,    0x340, 0xd
  csrrwi x2,    0x340, 0xd
  csrrci x2,    0x340, 0xe
  csrrsi x2,    0x340, 0xe
  csrrwi x2,    0x340, 0xe
  csrrci x2,    0x340, 0xf
  csrrsi x2,    0x340, 0xf
  csrrwi x2,    0x340, 0xf
  csrrci x2,    0x340, 0x10
  csrrsi x2,    0x340, 0x10
  csrrwi x2,    0x340, 0x10
  csrrci x2,    0x340, 0x11
  csrrsi x2,    0x340, 0x11
  csrrwi x2,    0x340, 0x11
  csrrci x2,    0x340, 0x12
  csrrsi x2,    0x340, 0x12
  csrrwi x2,    0x340, 0x12
  csrrci x2,    0x340, 0x13
  csrrsi x2,    0x340, 0x13
  csrrwi x2,    0x340, 0x13
  csrrci x2,    0x340, 0x14
  csrrsi x2,    0x340, 0x14
  csrrwi x2,    0x340, 0x14
  csrrci x2,    0x340, 0x15
  csrrsi x2,    0x340, 0x15
  csrrwi x2,    0x340, 0x15
  csrrci x2,    0x340, 0x16
  csrrsi x2,    0x340, 0x16
  csrrwi x2,    0x340, 0x16
  csrrci x2,    0x340, 0x17
  csrrsi x2,    0x340, 0x17
  csrrwi x2,    0x340, 0x17
  csrrci x2,    0x340, 0x18
  csrrsi x2,    0x340, 0x18
  csrrwi x2,    0x340, 0x18
  csrrci x2,    0x340, 0x19
  csrrsi x2,    0x340, 0x19
  csrrwi x2,    0x340, 0x19
  csrrci x2,    0x340, 0x1a
  csrrsi x2,    0x340, 0x1a
  csrrwi x2,    0x340, 0x1a
  csrrci x2,    0x340, 0x1b
  csrrsi x2,    0x340, 0x1b
  csrrwi x2,    0x340, 0x1b
  csrrci x2,    0x340, 0x1c
  csrrsi x2,    0x340, 0x1c
  csrrwi x2,    0x340, 0x1c
  csrrci x2,    0x340, 0x1d
  csrrsi x2,    0x340, 0x1d
  csrrwi x2,    0x340, 0x1d
  csrrci x2,    0x340, 0x1e
  csrrsi x2,    0x340, 0x1e
  csrrwi x2,    0x340, 0x1e
  csrrci x2,    0x340, 0x1f
  csrrsi x2,    0x340, 0x1f
  csrrwi x2,    0x340, 0x1f

  csrrci x3,    0x340, 0x0
  csrrsi x3,    0x340, 0x0
  csrrwi x3,    0x340, 0x0
  csrrci x3,    0x340, 0x1
  csrrsi x3,    0x340, 0x1
  csrrwi x3,    0x340, 0x1
  csrrci x3,    0x340, 0x2
  csrrsi x3,    0x340, 0x2
  csrrwi x3,    0x340, 0x2
  csrrci x3,    0x340, 0x3
  csrrsi x3,    0x340, 0x3
  csrrwi x3,    0x340, 0x3
  csrrci x3,    0x340, 0x4
  csrrsi x3,    0x340, 0x4
  csrrwi x3,    0x340, 0x4
  csrrci x3,    0x340, 0x5
  csrrsi x3,    0x340, 0x5
  csrrwi x3,    0x340, 0x5
  csrrci x3,    0x340, 0x6
  csrrsi x3,    0x340, 0x6
  csrrwi x3,    0x340, 0x6
  csrrci x3,    0x340, 0x7
  csrrsi x3,    0x340, 0x7
  csrrwi x3,    0x340, 0x7
  csrrci x3,    0x340, 0x8
  csrrsi x3,    0x340, 0x8
  csrrwi x3,    0x340, 0x8
  csrrci x3,    0x340, 0x9
  csrrsi x3,    0x340, 0x9
  csrrwi x3,    0x340, 0x9
  csrrci x3,    0x340, 0xa
  csrrsi x3,    0x340, 0xa
  csrrwi x3,    0x340, 0xa
  csrrci x3,    0x340, 0xb
  csrrsi x3,    0x340, 0xb
  csrrwi x3,    0x340, 0xb
  csrrci x3,    0x340, 0xc
  csrrsi x3,    0x340, 0xc
  csrrwi x3,    0x340, 0xc
  csrrci x3,    0x340, 0xd
  csrrsi x3,    0x340, 0xd
  csrrwi x3,    0x340, 0xd
  csrrci x3,    0x340, 0xe
  csrrsi x3,    0x340, 0xe
  csrrwi x3,    0x340, 0xe
  csrrci x3,    0x340, 0xf
  csrrsi x3,    0x340, 0xf
  csrrwi x3,    0x340, 0xf
  csrrci x3,    0x340, 0x10
  csrrsi x3,    0x340, 0x10
  csrrwi x3,    0x340, 0x10
  csrrci x3,    0x340, 0x11
  csrrsi x3,    0x340, 0x11
  csrrwi x3,    0x340, 0x11
  csrrci x3,    0x340, 0x12
  csrrsi x3,    0x340, 0x12
  csrrwi x3,    0x340, 0x12
  csrrci x3,    0x340, 0x13
  csrrsi x3,    0x340, 0x13
  csrrwi x3,    0x340, 0x13
  csrrci x3,    0x340, 0x14
  csrrsi x3,    0x340, 0x14
  csrrwi x3,    0x340, 0x14
  csrrci x3,    0x340, 0x15
  csrrsi x3,    0x340, 0x15
  csrrwi x3,    0x340, 0x15
  csrrci x3,    0x340, 0x16
  csrrsi x3,    0x340, 0x16
  csrrwi x3,    0x340, 0x16
  csrrci x3,    0x340, 0x17
  csrrsi x3,    0x340, 0x17
  csrrwi x3,    0x340, 0x17
  csrrci x3,    0x340, 0x18
  csrrsi x3,    0x340, 0x18
  csrrwi x3,    0x340, 0x18
  csrrci x3,    0x340, 0x19
  csrrsi x3,    0x340, 0x19
  csrrwi x3,    0x340, 0x19
  csrrci x3,    0x340, 0x1a
  csrrsi x3,    0x340, 0x1a
  csrrwi x3,    0x340, 0x1a
  csrrci x3,    0x340, 0x1b
  csrrsi x3,    0x340, 0x1b
  csrrwi x3,    0x340, 0x1b
  csrrci x3,    0x340, 0x1c
  csrrsi x3,    0x340, 0x1c
  csrrwi x3,    0x340, 0x1c
  csrrci x3,    0x340, 0x1d
  csrrsi x3,    0x340, 0x1d
  csrrwi x3,    0x340, 0x1d
  csrrci x3,    0x340, 0x1e
  csrrsi x3,    0x340, 0x1e
  csrrwi x3,    0x340, 0x1e
  csrrci x3,    0x340, 0x1f
  csrrsi x3,    0x340, 0x1f
  csrrwi x3,    0x340, 0x1f

  csrrci x4,    0x340, 0x0
  csrrsi x4,    0x340, 0x0
  csrrwi x4,    0x340, 0x0
  csrrci x4,    0x340, 0x1
  csrrsi x4,    0x340, 0x1
  csrrwi x4,    0x340, 0x1
  csrrci x4,    0x340, 0x2
  csrrsi x4,    0x340, 0x2
  csrrwi x4,    0x340, 0x2
  csrrci x4,    0x340, 0x3
  csrrsi x4,    0x340, 0x3
  csrrwi x4,    0x340, 0x3
  csrrci x4,    0x340, 0x4
  csrrsi x4,    0x340, 0x4
  csrrwi x4,    0x340, 0x4
  csrrci x4,    0x340, 0x5
  csrrsi x4,    0x340, 0x5
  csrrwi x4,    0x340, 0x5
  csrrci x4,    0x340, 0x6
  csrrsi x4,    0x340, 0x6
  csrrwi x4,    0x340, 0x6
  csrrci x4,    0x340, 0x7
  csrrsi x4,    0x340, 0x7
  csrrwi x4,    0x340, 0x7
  csrrci x4,    0x340, 0x8
  csrrsi x4,    0x340, 0x8
  csrrwi x4,    0x340, 0x8
  csrrci x4,    0x340, 0x9
  csrrsi x4,    0x340, 0x9
  csrrwi x4,    0x340, 0x9
  csrrci x4,    0x340, 0xa
  csrrsi x4,    0x340, 0xa
  csrrwi x4,    0x340, 0xa
  csrrci x4,    0x340, 0xb
  csrrsi x4,    0x340, 0xb
  csrrwi x4,    0x340, 0xb
  csrrci x4,    0x340, 0xc
  csrrsi x4,    0x340, 0xc
  csrrwi x4,    0x340, 0xc
  csrrci x4,    0x340, 0xd
  csrrsi x4,    0x340, 0xd
  csrrwi x4,    0x340, 0xd
  csrrci x4,    0x340, 0xe
  csrrsi x4,    0x340, 0xe
  csrrwi x4,    0x340, 0xe
  csrrci x4,    0x340, 0xf
  csrrsi x4,    0x340, 0xf
  csrrwi x4,    0x340, 0xf
  csrrci x4,    0x340, 0x10
  csrrsi x4,    0x340, 0x10
  csrrwi x4,    0x340, 0x10
  csrrci x4,    0x340, 0x11
  csrrsi x4,    0x340, 0x11
  csrrwi x4,    0x340, 0x11
  csrrci x4,    0x340, 0x12
  csrrsi x4,    0x340, 0x12
  csrrwi x4,    0x340, 0x12
  csrrci x4,    0x340, 0x13
  csrrsi x4,    0x340, 0x13
  csrrwi x4,    0x340, 0x13
  csrrci x4,    0x340, 0x14
  csrrsi x4,    0x340, 0x14
  csrrwi x4,    0x340, 0x14
  csrrci x4,    0x340, 0x15
  csrrsi x4,    0x340, 0x15
  csrrwi x4,    0x340, 0x15
  csrrci x4,    0x340, 0x16
  csrrsi x4,    0x340, 0x16
  csrrwi x4,    0x340, 0x16
  csrrci x4,    0x340, 0x17
  csrrsi x4,    0x340, 0x17
  csrrwi x4,    0x340, 0x17
  csrrci x4,    0x340, 0x18
  csrrsi x4,    0x340, 0x18
  csrrwi x4,    0x340, 0x18
  csrrci x4,    0x340, 0x19
  csrrsi x4,    0x340, 0x19
  csrrwi x4,    0x340, 0x19
  csrrci x4,    0x340, 0x1a
  csrrsi x4,    0x340, 0x1a
  csrrwi x4,    0x340, 0x1a
  csrrci x4,    0x340, 0x1b
  csrrsi x4,    0x340, 0x1b
  csrrwi x4,    0x340, 0x1b
  csrrci x4,    0x340, 0x1c
  csrrsi x4,    0x340, 0x1c
  csrrwi x4,    0x340, 0x1c
  csrrci x4,    0x340, 0x1d
  csrrsi x4,    0x340, 0x1d
  csrrwi x4,    0x340, 0x1d
  csrrci x4,    0x340, 0x1e
  csrrsi x4,    0x340, 0x1e
  csrrwi x4,    0x340, 0x1e
  csrrci x4,    0x340, 0x1f
  csrrsi x4,    0x340, 0x1f
  csrrwi x4,    0x340, 0x1f

  csrrci x5,    0x340, 0x0
  csrrsi x5,    0x340, 0x0
  csrrwi x5,    0x340, 0x0
  csrrci x5,    0x340, 0x1
  csrrsi x5,    0x340, 0x1
  csrrwi x5,    0x340, 0x1
  csrrci x5,    0x340, 0x2
  csrrsi x5,    0x340, 0x2
  csrrwi x5,    0x340, 0x2
  csrrci x5,    0x340, 0x3
  csrrsi x5,    0x340, 0x3
  csrrwi x5,    0x340, 0x3
  csrrci x5,    0x340, 0x4
  csrrsi x5,    0x340, 0x4
  csrrwi x5,    0x340, 0x4
  csrrci x5,    0x340, 0x5
  csrrsi x5,    0x340, 0x5
  csrrwi x5,    0x340, 0x5
  csrrci x5,    0x340, 0x6
  csrrsi x5,    0x340, 0x6
  csrrwi x5,    0x340, 0x6
  csrrci x5,    0x340, 0x7
  csrrsi x5,    0x340, 0x7
  csrrwi x5,    0x340, 0x7
  csrrci x5,    0x340, 0x8
  csrrsi x5,    0x340, 0x8
  csrrwi x5,    0x340, 0x8
  csrrci x5,    0x340, 0x9
  csrrsi x5,    0x340, 0x9
  csrrwi x5,    0x340, 0x9
  csrrci x5,    0x340, 0xa
  csrrsi x5,    0x340, 0xa
  csrrwi x5,    0x340, 0xa
  csrrci x5,    0x340, 0xb
  csrrsi x5,    0x340, 0xb
  csrrwi x5,    0x340, 0xb
  csrrci x5,    0x340, 0xc
  csrrsi x5,    0x340, 0xc
  csrrwi x5,    0x340, 0xc
  csrrci x5,    0x340, 0xd
  csrrsi x5,    0x340, 0xd
  csrrwi x5,    0x340, 0xd
  csrrci x5,    0x340, 0xe
  csrrsi x5,    0x340, 0xe
  csrrwi x5,    0x340, 0xe
  csrrci x5,    0x340, 0xf
  csrrsi x5,    0x340, 0xf
  csrrwi x5,    0x340, 0xf
  csrrci x5,    0x340, 0x10
  csrrsi x5,    0x340, 0x10
  csrrwi x5,    0x340, 0x10
  csrrci x5,    0x340, 0x11
  csrrsi x5,    0x340, 0x11
  csrrwi x5,    0x340, 0x11
  csrrci x5,    0x340, 0x12
  csrrsi x5,    0x340, 0x12
  csrrwi x5,    0x340, 0x12
  csrrci x5,    0x340, 0x13
  csrrsi x5,    0x340, 0x13
  csrrwi x5,    0x340, 0x13
  csrrci x5,    0x340, 0x14
  csrrsi x5,    0x340, 0x14
  csrrwi x5,    0x340, 0x14
  csrrci x5,    0x340, 0x15
  csrrsi x5,    0x340, 0x15
  csrrwi x5,    0x340, 0x15
  csrrci x5,    0x340, 0x16
  csrrsi x5,    0x340, 0x16
  csrrwi x5,    0x340, 0x16
  csrrci x5,    0x340, 0x17
  csrrsi x5,    0x340, 0x17
  csrrwi x5,    0x340, 0x17
  csrrci x5,    0x340, 0x18
  csrrsi x5,    0x340, 0x18
  csrrwi x5,    0x340, 0x18
  csrrci x5,    0x340, 0x19
  csrrsi x5,    0x340, 0x19
  csrrwi x5,    0x340, 0x19
  csrrci x5,    0x340, 0x1a
  csrrsi x5,    0x340, 0x1a
  csrrwi x5,    0x340, 0x1a
  csrrci x5,    0x340, 0x1b
  csrrsi x5,    0x340, 0x1b
  csrrwi x5,    0x340, 0x1b
  csrrci x5,    0x340, 0x1c
  csrrsi x5,    0x340, 0x1c
  csrrwi x5,    0x340, 0x1c
  csrrci x5,    0x340, 0x1d
  csrrsi x5,    0x340, 0x1d
  csrrwi x5,    0x340, 0x1d
  csrrci x5,    0x340, 0x1e
  csrrsi x5,    0x340, 0x1e
  csrrwi x5,    0x340, 0x1e
  csrrci x5,    0x340, 0x1f
  csrrsi x5,    0x340, 0x1f
  csrrwi x5,    0x340, 0x1f

  csrrci x6,    0x340, 0x0
  csrrsi x6,    0x340, 0x0
  csrrwi x6,    0x340, 0x0
  csrrci x6,    0x340, 0x1
  csrrsi x6,    0x340, 0x1
  csrrwi x6,    0x340, 0x1
  csrrci x6,    0x340, 0x2
  csrrsi x6,    0x340, 0x2
  csrrwi x6,    0x340, 0x2
  csrrci x6,    0x340, 0x3
  csrrsi x6,    0x340, 0x3
  csrrwi x6,    0x340, 0x3
  csrrci x6,    0x340, 0x4
  csrrsi x6,    0x340, 0x4
  csrrwi x6,    0x340, 0x4
  csrrci x6,    0x340, 0x5
  csrrsi x6,    0x340, 0x5
  csrrwi x6,    0x340, 0x5
  csrrci x6,    0x340, 0x6
  csrrsi x6,    0x340, 0x6
  csrrwi x6,    0x340, 0x6
  csrrci x6,    0x340, 0x7
  csrrsi x6,    0x340, 0x7
  csrrwi x6,    0x340, 0x7
  csrrci x6,    0x340, 0x8
  csrrsi x6,    0x340, 0x8
  csrrwi x6,    0x340, 0x8
  csrrci x6,    0x340, 0x9
  csrrsi x6,    0x340, 0x9
  csrrwi x6,    0x340, 0x9
  csrrci x6,    0x340, 0xa
  csrrsi x6,    0x340, 0xa
  csrrwi x6,    0x340, 0xa
  csrrci x6,    0x340, 0xb
  csrrsi x6,    0x340, 0xb
  csrrwi x6,    0x340, 0xb
  csrrci x6,    0x340, 0xc
  csrrsi x6,    0x340, 0xc
  csrrwi x6,    0x340, 0xc
  csrrci x6,    0x340, 0xd
  csrrsi x6,    0x340, 0xd
  csrrwi x6,    0x340, 0xd
  csrrci x6,    0x340, 0xe
  csrrsi x6,    0x340, 0xe
  csrrwi x6,    0x340, 0xe
  csrrci x6,    0x340, 0xf
  csrrsi x6,    0x340, 0xf
  csrrwi x6,    0x340, 0xf
  csrrci x6,    0x340, 0x10
  csrrsi x6,    0x340, 0x10
  csrrwi x6,    0x340, 0x10
  csrrci x6,    0x340, 0x11
  csrrsi x6,    0x340, 0x11
  csrrwi x6,    0x340, 0x11
  csrrci x6,    0x340, 0x12
  csrrsi x6,    0x340, 0x12
  csrrwi x6,    0x340, 0x12
  csrrci x6,    0x340, 0x13
  csrrsi x6,    0x340, 0x13
  csrrwi x6,    0x340, 0x13
  csrrci x6,    0x340, 0x14
  csrrsi x6,    0x340, 0x14
  csrrwi x6,    0x340, 0x14
  csrrci x6,    0x340, 0x15
  csrrsi x6,    0x340, 0x15
  csrrwi x6,    0x340, 0x15
  csrrci x6,    0x340, 0x16
  csrrsi x6,    0x340, 0x16
  csrrwi x6,    0x340, 0x16
  csrrci x6,    0x340, 0x17
  csrrsi x6,    0x340, 0x17
  csrrwi x6,    0x340, 0x17
  csrrci x6,    0x340, 0x18
  csrrsi x6,    0x340, 0x18
  csrrwi x6,    0x340, 0x18
  csrrci x6,    0x340, 0x19
  csrrsi x6,    0x340, 0x19
  csrrwi x6,    0x340, 0x19
  csrrci x6,    0x340, 0x1a
  csrrsi x6,    0x340, 0x1a
  csrrwi x6,    0x340, 0x1a
  csrrci x6,    0x340, 0x1b
  csrrsi x6,    0x340, 0x1b
  csrrwi x6,    0x340, 0x1b
  csrrci x6,    0x340, 0x1c
  csrrsi x6,    0x340, 0x1c
  csrrwi x6,    0x340, 0x1c
  csrrci x6,    0x340, 0x1d
  csrrsi x6,    0x340, 0x1d
  csrrwi x6,    0x340, 0x1d
  csrrci x6,    0x340, 0x1e
  csrrsi x6,    0x340, 0x1e
  csrrwi x6,    0x340, 0x1e
  csrrci x6,    0x340, 0x1f
  csrrsi x6,    0x340, 0x1f
  csrrwi x6,    0x340, 0x1f

  csrrci x7,    0x340, 0x0
  csrrsi x7,    0x340, 0x0
  csrrwi x7,    0x340, 0x0
  csrrci x7,    0x340, 0x1
  csrrsi x7,    0x340, 0x1
  csrrwi x7,    0x340, 0x1
  csrrci x7,    0x340, 0x2
  csrrsi x7,    0x340, 0x2
  csrrwi x7,    0x340, 0x2
  csrrci x7,    0x340, 0x3
  csrrsi x7,    0x340, 0x3
  csrrwi x7,    0x340, 0x3
  csrrci x7,    0x340, 0x4
  csrrsi x7,    0x340, 0x4
  csrrwi x7,    0x340, 0x4
  csrrci x7,    0x340, 0x5
  csrrsi x7,    0x340, 0x5
  csrrwi x7,    0x340, 0x5
  csrrci x7,    0x340, 0x6
  csrrsi x7,    0x340, 0x6
  csrrwi x7,    0x340, 0x6
  csrrci x7,    0x340, 0x7
  csrrsi x7,    0x340, 0x7
  csrrwi x7,    0x340, 0x7
  csrrci x7,    0x340, 0x8
  csrrsi x7,    0x340, 0x8
  csrrwi x7,    0x340, 0x8
  csrrci x7,    0x340, 0x9
  csrrsi x7,    0x340, 0x9
  csrrwi x7,    0x340, 0x9
  csrrci x7,    0x340, 0xa
  csrrsi x7,    0x340, 0xa
  csrrwi x7,    0x340, 0xa
  csrrci x7,    0x340, 0xb
  csrrsi x7,    0x340, 0xb
  csrrwi x7,    0x340, 0xb
  csrrci x7,    0x340, 0xc
  csrrsi x7,    0x340, 0xc
  csrrwi x7,    0x340, 0xc
  csrrci x7,    0x340, 0xd
  csrrsi x7,    0x340, 0xd
  csrrwi x7,    0x340, 0xd
  csrrci x7,    0x340, 0xe
  csrrsi x7,    0x340, 0xe
  csrrwi x7,    0x340, 0xe
  csrrci x7,    0x340, 0xf
  csrrsi x7,    0x340, 0xf
  csrrwi x7,    0x340, 0xf
  csrrci x7,    0x340, 0x10
  csrrsi x7,    0x340, 0x10
  csrrwi x7,    0x340, 0x10
  csrrci x7,    0x340, 0x11
  csrrsi x7,    0x340, 0x11
  csrrwi x7,    0x340, 0x11
  csrrci x7,    0x340, 0x12
  csrrsi x7,    0x340, 0x12
  csrrwi x7,    0x340, 0x12
  csrrci x7,    0x340, 0x13
  csrrsi x7,    0x340, 0x13
  csrrwi x7,    0x340, 0x13
  csrrci x7,    0x340, 0x14
  csrrsi x7,    0x340, 0x14
  csrrwi x7,    0x340, 0x14
  csrrci x7,    0x340, 0x15
  csrrsi x7,    0x340, 0x15
  csrrwi x7,    0x340, 0x15
  csrrci x7,    0x340, 0x16
  csrrsi x7,    0x340, 0x16
  csrrwi x7,    0x340, 0x16
  csrrci x7,    0x340, 0x17
  csrrsi x7,    0x340, 0x17
  csrrwi x7,    0x340, 0x17
  csrrci x7,    0x340, 0x18
  csrrsi x7,    0x340, 0x18
  csrrwi x7,    0x340, 0x18
  csrrci x7,    0x340, 0x19
  csrrsi x7,    0x340, 0x19
  csrrwi x7,    0x340, 0x19
  csrrci x7,    0x340, 0x1a
  csrrsi x7,    0x340, 0x1a
  csrrwi x7,    0x340, 0x1a
  csrrci x7,    0x340, 0x1b
  csrrsi x7,    0x340, 0x1b
  csrrwi x7,    0x340, 0x1b
  csrrci x7,    0x340, 0x1c
  csrrsi x7,    0x340, 0x1c
  csrrwi x7,    0x340, 0x1c
  csrrci x7,    0x340, 0x1d
  csrrsi x7,    0x340, 0x1d
  csrrwi x7,    0x340, 0x1d
  csrrci x7,    0x340, 0x1e
  csrrsi x7,    0x340, 0x1e
  csrrwi x7,    0x340, 0x1e
  csrrci x7,    0x340, 0x1f
  csrrsi x7,    0x340, 0x1f
  csrrwi x7,    0x340, 0x1f

  csrrci x8,    0x340, 0x0
  csrrsi x8,    0x340, 0x0
  csrrwi x8,    0x340, 0x0
  csrrci x8,    0x340, 0x1
  csrrsi x8,    0x340, 0x1
  csrrwi x8,    0x340, 0x1
  csrrci x8,    0x340, 0x2
  csrrsi x8,    0x340, 0x2
  csrrwi x8,    0x340, 0x2
  csrrci x8,    0x340, 0x3
  csrrsi x8,    0x340, 0x3
  csrrwi x8,    0x340, 0x3
  csrrci x8,    0x340, 0x4
  csrrsi x8,    0x340, 0x4
  csrrwi x8,    0x340, 0x4
  csrrci x8,    0x340, 0x5
  csrrsi x8,    0x340, 0x5
  csrrwi x8,    0x340, 0x5
  csrrci x8,    0x340, 0x6
  csrrsi x8,    0x340, 0x6
  csrrwi x8,    0x340, 0x6
  csrrci x8,    0x340, 0x7
  csrrsi x8,    0x340, 0x7
  csrrwi x8,    0x340, 0x7
  csrrci x8,    0x340, 0x8
  csrrsi x8,    0x340, 0x8
  csrrwi x8,    0x340, 0x8
  csrrci x8,    0x340, 0x9
  csrrsi x8,    0x340, 0x9
  csrrwi x8,    0x340, 0x9
  csrrci x8,    0x340, 0xa
  csrrsi x8,    0x340, 0xa
  csrrwi x8,    0x340, 0xa
  csrrci x8,    0x340, 0xb
  csrrsi x8,    0x340, 0xb
  csrrwi x8,    0x340, 0xb
  csrrci x8,    0x340, 0xc
  csrrsi x8,    0x340, 0xc
  csrrwi x8,    0x340, 0xc
  csrrci x8,    0x340, 0xd
  csrrsi x8,    0x340, 0xd
  csrrwi x8,    0x340, 0xd
  csrrci x8,    0x340, 0xe
  csrrsi x8,    0x340, 0xe
  csrrwi x8,    0x340, 0xe
  csrrci x8,    0x340, 0xf
  csrrsi x8,    0x340, 0xf
  csrrwi x8,    0x340, 0xf
  csrrci x8,    0x340, 0x10
  csrrsi x8,    0x340, 0x10
  csrrwi x8,    0x340, 0x10
  csrrci x8,    0x340, 0x11
  csrrsi x8,    0x340, 0x11
  csrrwi x8,    0x340, 0x11
  csrrci x8,    0x340, 0x12
  csrrsi x8,    0x340, 0x12
  csrrwi x8,    0x340, 0x12
  csrrci x8,    0x340, 0x13
  csrrsi x8,    0x340, 0x13
  csrrwi x8,    0x340, 0x13
  csrrci x8,    0x340, 0x14
  csrrsi x8,    0x340, 0x14
  csrrwi x8,    0x340, 0x14
  csrrci x8,    0x340, 0x15
  csrrsi x8,    0x340, 0x15
  csrrwi x8,    0x340, 0x15
  csrrci x8,    0x340, 0x16
  csrrsi x8,    0x340, 0x16
  csrrwi x8,    0x340, 0x16
  csrrci x8,    0x340, 0x17
  csrrsi x8,    0x340, 0x17
  csrrwi x8,    0x340, 0x17
  csrrci x8,    0x340, 0x18
  csrrsi x8,    0x340, 0x18
  csrrwi x8,    0x340, 0x18
  csrrci x8,    0x340, 0x19
  csrrsi x8,    0x340, 0x19
  csrrwi x8,    0x340, 0x19
  csrrci x8,    0x340, 0x1a
  csrrsi x8,    0x340, 0x1a
  csrrwi x8,    0x340, 0x1a
  csrrci x8,    0x340, 0x1b
  csrrsi x8,    0x340, 0x1b
  csrrwi x8,    0x340, 0x1b
  csrrci x8,    0x340, 0x1c
  csrrsi x8,    0x340, 0x1c
  csrrwi x8,    0x340, 0x1c
  csrrci x8,    0x340, 0x1d
  csrrsi x8,    0x340, 0x1d
  csrrwi x8,    0x340, 0x1d
  csrrci x8,    0x340, 0x1e
  csrrsi x8,    0x340, 0x1e
  csrrwi x8,    0x340, 0x1e
  csrrci x8,    0x340, 0x1f
  csrrsi x8,    0x340, 0x1f
  csrrwi x8,    0x340, 0x1f

  csrrci x9,    0x340, 0x0
  csrrsi x9,    0x340, 0x0
  csrrwi x9,    0x340, 0x0
  csrrci x9,    0x340, 0x1
  csrrsi x9,    0x340, 0x1
  csrrwi x9,    0x340, 0x1
  csrrci x9,    0x340, 0x2
  csrrsi x9,    0x340, 0x2
  csrrwi x9,    0x340, 0x2
  csrrci x9,    0x340, 0x3
  csrrsi x9,    0x340, 0x3
  csrrwi x9,    0x340, 0x3
  csrrci x9,    0x340, 0x4
  csrrsi x9,    0x340, 0x4
  csrrwi x9,    0x340, 0x4
  csrrci x9,    0x340, 0x5
  csrrsi x9,    0x340, 0x5
  csrrwi x9,    0x340, 0x5
  csrrci x9,    0x340, 0x6
  csrrsi x9,    0x340, 0x6
  csrrwi x9,    0x340, 0x6
  csrrci x9,    0x340, 0x7
  csrrsi x9,    0x340, 0x7
  csrrwi x9,    0x340, 0x7
  csrrci x9,    0x340, 0x8
  csrrsi x9,    0x340, 0x8
  csrrwi x9,    0x340, 0x8
  csrrci x9,    0x340, 0x9
  csrrsi x9,    0x340, 0x9
  csrrwi x9,    0x340, 0x9
  csrrci x9,    0x340, 0xa
  csrrsi x9,    0x340, 0xa
  csrrwi x9,    0x340, 0xa
  csrrci x9,    0x340, 0xb
  csrrsi x9,    0x340, 0xb
  csrrwi x9,    0x340, 0xb
  csrrci x9,    0x340, 0xc
  csrrsi x9,    0x340, 0xc
  csrrwi x9,    0x340, 0xc
  csrrci x9,    0x340, 0xd
  csrrsi x9,    0x340, 0xd
  csrrwi x9,    0x340, 0xd
  csrrci x9,    0x340, 0xe
  csrrsi x9,    0x340, 0xe
  csrrwi x9,    0x340, 0xe
  csrrci x9,    0x340, 0xf
  csrrsi x9,    0x340, 0xf
  csrrwi x9,    0x340, 0xf
  csrrci x9,    0x340, 0x10
  csrrsi x9,    0x340, 0x10
  csrrwi x9,    0x340, 0x10
  csrrci x9,    0x340, 0x11
  csrrsi x9,    0x340, 0x11
  csrrwi x9,    0x340, 0x11
  csrrci x9,    0x340, 0x12
  csrrsi x9,    0x340, 0x12
  csrrwi x9,    0x340, 0x12
  csrrci x9,    0x340, 0x13
  csrrsi x9,    0x340, 0x13
  csrrwi x9,    0x340, 0x13
  csrrci x9,    0x340, 0x14
  csrrsi x9,    0x340, 0x14
  csrrwi x9,    0x340, 0x14
  csrrci x9,    0x340, 0x15
  csrrsi x9,    0x340, 0x15
  csrrwi x9,    0x340, 0x15
  csrrci x9,    0x340, 0x16
  csrrsi x9,    0x340, 0x16
  csrrwi x9,    0x340, 0x16
  csrrci x9,    0x340, 0x17
  csrrsi x9,    0x340, 0x17
  csrrwi x9,    0x340, 0x17
  csrrci x9,    0x340, 0x18
  csrrsi x9,    0x340, 0x18
  csrrwi x9,    0x340, 0x18
  csrrci x9,    0x340, 0x19
  csrrsi x9,    0x340, 0x19
  csrrwi x9,    0x340, 0x19
  csrrci x9,    0x340, 0x1a
  csrrsi x9,    0x340, 0x1a
  csrrwi x9,    0x340, 0x1a
  csrrci x9,    0x340, 0x1b
  csrrsi x9,    0x340, 0x1b
  csrrwi x9,    0x340, 0x1b
  csrrci x9,    0x340, 0x1c
  csrrsi x9,    0x340, 0x1c
  csrrwi x9,    0x340, 0x1c
  csrrci x9,    0x340, 0x1d
  csrrsi x9,    0x340, 0x1d
  csrrwi x9,    0x340, 0x1d
  csrrci x9,    0x340, 0x1e
  csrrsi x9,    0x340, 0x1e
  csrrwi x9,    0x340, 0x1e
  csrrci x9,    0x340, 0x1f
  csrrsi x9,    0x340, 0x1f
  csrrwi x9,    0x340, 0x1f

  csrrci x10,    0x340, 0x0
  csrrsi x10,    0x340, 0x0
  csrrwi x10,    0x340, 0x0
  csrrci x10,    0x340, 0x1
  csrrsi x10,    0x340, 0x1
  csrrwi x10,    0x340, 0x1
  csrrci x10,    0x340, 0x2
  csrrsi x10,    0x340, 0x2
  csrrwi x10,    0x340, 0x2
  csrrci x10,    0x340, 0x3
  csrrsi x10,    0x340, 0x3
  csrrwi x10,    0x340, 0x3
  csrrci x10,    0x340, 0x4
  csrrsi x10,    0x340, 0x4
  csrrwi x10,    0x340, 0x4
  csrrci x10,    0x340, 0x5
  csrrsi x10,    0x340, 0x5
  csrrwi x10,    0x340, 0x5
  csrrci x10,    0x340, 0x6
  csrrsi x10,    0x340, 0x6
  csrrwi x10,    0x340, 0x6
  csrrci x10,    0x340, 0x7
  csrrsi x10,    0x340, 0x7
  csrrwi x10,    0x340, 0x7
  csrrci x10,    0x340, 0x8
  csrrsi x10,    0x340, 0x8
  csrrwi x10,    0x340, 0x8
  csrrci x10,    0x340, 0x9
  csrrsi x10,    0x340, 0x9
  csrrwi x10,    0x340, 0x9
  csrrci x10,    0x340, 0xa
  csrrsi x10,    0x340, 0xa
  csrrwi x10,    0x340, 0xa
  csrrci x10,    0x340, 0xb
  csrrsi x10,    0x340, 0xb
  csrrwi x10,    0x340, 0xb
  csrrci x10,    0x340, 0xc
  csrrsi x10,    0x340, 0xc
  csrrwi x10,    0x340, 0xc
  csrrci x10,    0x340, 0xd
  csrrsi x10,    0x340, 0xd
  csrrwi x10,    0x340, 0xd
  csrrci x10,    0x340, 0xe
  csrrsi x10,    0x340, 0xe
  csrrwi x10,    0x340, 0xe
  csrrci x10,    0x340, 0xf
  csrrsi x10,    0x340, 0xf
  csrrwi x10,    0x340, 0xf
  csrrci x10,    0x340, 0x10
  csrrsi x10,    0x340, 0x10
  csrrwi x10,    0x340, 0x10
  csrrci x10,    0x340, 0x11
  csrrsi x10,    0x340, 0x11
  csrrwi x10,    0x340, 0x11
  csrrci x10,    0x340, 0x12
  csrrsi x10,    0x340, 0x12
  csrrwi x10,    0x340, 0x12
  csrrci x10,    0x340, 0x13
  csrrsi x10,    0x340, 0x13
  csrrwi x10,    0x340, 0x13
  csrrci x10,    0x340, 0x14
  csrrsi x10,    0x340, 0x14
  csrrwi x10,    0x340, 0x14
  csrrci x10,    0x340, 0x15
  csrrsi x10,    0x340, 0x15
  csrrwi x10,    0x340, 0x15
  csrrci x10,    0x340, 0x16
  csrrsi x10,    0x340, 0x16
  csrrwi x10,    0x340, 0x16
  csrrci x10,    0x340, 0x17
  csrrsi x10,    0x340, 0x17
  csrrwi x10,    0x340, 0x17
  csrrci x10,    0x340, 0x18
  csrrsi x10,    0x340, 0x18
  csrrwi x10,    0x340, 0x18
  csrrci x10,    0x340, 0x19
  csrrsi x10,    0x340, 0x19
  csrrwi x10,    0x340, 0x19
  csrrci x10,    0x340, 0x1a
  csrrsi x10,    0x340, 0x1a
  csrrwi x10,    0x340, 0x1a
  csrrci x10,    0x340, 0x1b
  csrrsi x10,    0x340, 0x1b
  csrrwi x10,    0x340, 0x1b
  csrrci x10,    0x340, 0x1c
  csrrsi x10,    0x340, 0x1c
  csrrwi x10,    0x340, 0x1c
  csrrci x10,    0x340, 0x1d
  csrrsi x10,    0x340, 0x1d
  csrrwi x10,    0x340, 0x1d
  csrrci x10,    0x340, 0x1e
  csrrsi x10,    0x340, 0x1e
  csrrwi x10,    0x340, 0x1e
  csrrci x10,    0x340, 0x1f
  csrrsi x10,    0x340, 0x1f
  csrrwi x10,    0x340, 0x1f

  csrrci x11,    0x340, 0x0
  csrrsi x11,    0x340, 0x0
  csrrwi x11,    0x340, 0x0
  csrrci x11,    0x340, 0x1
  csrrsi x11,    0x340, 0x1
  csrrwi x11,    0x340, 0x1
  csrrci x11,    0x340, 0x2
  csrrsi x11,    0x340, 0x2
  csrrwi x11,    0x340, 0x2
  csrrci x11,    0x340, 0x3
  csrrsi x11,    0x340, 0x3
  csrrwi x11,    0x340, 0x3
  csrrci x11,    0x340, 0x4
  csrrsi x11,    0x340, 0x4
  csrrwi x11,    0x340, 0x4
  csrrci x11,    0x340, 0x5
  csrrsi x11,    0x340, 0x5
  csrrwi x11,    0x340, 0x5
  csrrci x11,    0x340, 0x6
  csrrsi x11,    0x340, 0x6
  csrrwi x11,    0x340, 0x6
  csrrci x11,    0x340, 0x7
  csrrsi x11,    0x340, 0x7
  csrrwi x11,    0x340, 0x7
  csrrci x11,    0x340, 0x8
  csrrsi x11,    0x340, 0x8
  csrrwi x11,    0x340, 0x8
  csrrci x11,    0x340, 0x9
  csrrsi x11,    0x340, 0x9
  csrrwi x11,    0x340, 0x9
  csrrci x11,    0x340, 0xa
  csrrsi x11,    0x340, 0xa
  csrrwi x11,    0x340, 0xa
  csrrci x11,    0x340, 0xb
  csrrsi x11,    0x340, 0xb
  csrrwi x11,    0x340, 0xb
  csrrci x11,    0x340, 0xc
  csrrsi x11,    0x340, 0xc
  csrrwi x11,    0x340, 0xc
  csrrci x11,    0x340, 0xd
  csrrsi x11,    0x340, 0xd
  csrrwi x11,    0x340, 0xd
  csrrci x11,    0x340, 0xe
  csrrsi x11,    0x340, 0xe
  csrrwi x11,    0x340, 0xe
  csrrci x11,    0x340, 0xf
  csrrsi x11,    0x340, 0xf
  csrrwi x11,    0x340, 0xf
  csrrci x11,    0x340, 0x10
  csrrsi x11,    0x340, 0x10
  csrrwi x11,    0x340, 0x10
  csrrci x11,    0x340, 0x11
  csrrsi x11,    0x340, 0x11
  csrrwi x11,    0x340, 0x11
  csrrci x11,    0x340, 0x12
  csrrsi x11,    0x340, 0x12
  csrrwi x11,    0x340, 0x12
  csrrci x11,    0x340, 0x13
  csrrsi x11,    0x340, 0x13
  csrrwi x11,    0x340, 0x13
  csrrci x11,    0x340, 0x14
  csrrsi x11,    0x340, 0x14
  csrrwi x11,    0x340, 0x14
  csrrci x11,    0x340, 0x15
  csrrsi x11,    0x340, 0x15
  csrrwi x11,    0x340, 0x15
  csrrci x11,    0x340, 0x16
  csrrsi x11,    0x340, 0x16
  csrrwi x11,    0x340, 0x16
  csrrci x11,    0x340, 0x17
  csrrsi x11,    0x340, 0x17
  csrrwi x11,    0x340, 0x17
  csrrci x11,    0x340, 0x18
  csrrsi x11,    0x340, 0x18
  csrrwi x11,    0x340, 0x18
  csrrci x11,    0x340, 0x19
  csrrsi x11,    0x340, 0x19
  csrrwi x11,    0x340, 0x19
  csrrci x11,    0x340, 0x1a
  csrrsi x11,    0x340, 0x1a
  csrrwi x11,    0x340, 0x1a
  csrrci x11,    0x340, 0x1b
  csrrsi x11,    0x340, 0x1b
  csrrwi x11,    0x340, 0x1b
  csrrci x11,    0x340, 0x1c
  csrrsi x11,    0x340, 0x1c
  csrrwi x11,    0x340, 0x1c
  csrrci x11,    0x340, 0x1d
  csrrsi x11,    0x340, 0x1d
  csrrwi x11,    0x340, 0x1d
  csrrci x11,    0x340, 0x1e
  csrrsi x11,    0x340, 0x1e
  csrrwi x11,    0x340, 0x1e
  csrrci x11,    0x340, 0x1f
  csrrsi x11,    0x340, 0x1f
  csrrwi x11,    0x340, 0x1f

  csrrci x12,    0x340, 0x0
  csrrsi x12,    0x340, 0x0
  csrrwi x12,    0x340, 0x0
  csrrci x12,    0x340, 0x1
  csrrsi x12,    0x340, 0x1
  csrrwi x12,    0x340, 0x1
  csrrci x12,    0x340, 0x2
  csrrsi x12,    0x340, 0x2
  csrrwi x12,    0x340, 0x2
  csrrci x12,    0x340, 0x3
  csrrsi x12,    0x340, 0x3
  csrrwi x12,    0x340, 0x3
  csrrci x12,    0x340, 0x4
  csrrsi x12,    0x340, 0x4
  csrrwi x12,    0x340, 0x4
  csrrci x12,    0x340, 0x5
  csrrsi x12,    0x340, 0x5
  csrrwi x12,    0x340, 0x5
  csrrci x12,    0x340, 0x6
  csrrsi x12,    0x340, 0x6
  csrrwi x12,    0x340, 0x6
  csrrci x12,    0x340, 0x7
  csrrsi x12,    0x340, 0x7
  csrrwi x12,    0x340, 0x7
  csrrci x12,    0x340, 0x8
  csrrsi x12,    0x340, 0x8
  csrrwi x12,    0x340, 0x8
  csrrci x12,    0x340, 0x9
  csrrsi x12,    0x340, 0x9
  csrrwi x12,    0x340, 0x9
  csrrci x12,    0x340, 0xa
  csrrsi x12,    0x340, 0xa
  csrrwi x12,    0x340, 0xa
  csrrci x12,    0x340, 0xb
  csrrsi x12,    0x340, 0xb
  csrrwi x12,    0x340, 0xb
  csrrci x12,    0x340, 0xc
  csrrsi x12,    0x340, 0xc
  csrrwi x12,    0x340, 0xc
  csrrci x12,    0x340, 0xd
  csrrsi x12,    0x340, 0xd
  csrrwi x12,    0x340, 0xd
  csrrci x12,    0x340, 0xe
  csrrsi x12,    0x340, 0xe
  csrrwi x12,    0x340, 0xe
  csrrci x12,    0x340, 0xf
  csrrsi x12,    0x340, 0xf
  csrrwi x12,    0x340, 0xf
  csrrci x12,    0x340, 0x10
  csrrsi x12,    0x340, 0x10
  csrrwi x12,    0x340, 0x10
  csrrci x12,    0x340, 0x11
  csrrsi x12,    0x340, 0x11
  csrrwi x12,    0x340, 0x11
  csrrci x12,    0x340, 0x12
  csrrsi x12,    0x340, 0x12
  csrrwi x12,    0x340, 0x12
  csrrci x12,    0x340, 0x13
  csrrsi x12,    0x340, 0x13
  csrrwi x12,    0x340, 0x13
  csrrci x12,    0x340, 0x14
  csrrsi x12,    0x340, 0x14
  csrrwi x12,    0x340, 0x14
  csrrci x12,    0x340, 0x15
  csrrsi x12,    0x340, 0x15
  csrrwi x12,    0x340, 0x15
  csrrci x12,    0x340, 0x16
  csrrsi x12,    0x340, 0x16
  csrrwi x12,    0x340, 0x16
  csrrci x12,    0x340, 0x17
  csrrsi x12,    0x340, 0x17
  csrrwi x12,    0x340, 0x17
  csrrci x12,    0x340, 0x18
  csrrsi x12,    0x340, 0x18
  csrrwi x12,    0x340, 0x18
  csrrci x12,    0x340, 0x19
  csrrsi x12,    0x340, 0x19
  csrrwi x12,    0x340, 0x19
  csrrci x12,    0x340, 0x1a
  csrrsi x12,    0x340, 0x1a
  csrrwi x12,    0x340, 0x1a
  csrrci x12,    0x340, 0x1b
  csrrsi x12,    0x340, 0x1b
  csrrwi x12,    0x340, 0x1b
  csrrci x12,    0x340, 0x1c
  csrrsi x12,    0x340, 0x1c
  csrrwi x12,    0x340, 0x1c
  csrrci x12,    0x340, 0x1d
  csrrsi x12,    0x340, 0x1d
  csrrwi x12,    0x340, 0x1d
  csrrci x12,    0x340, 0x1e
  csrrsi x12,    0x340, 0x1e
  csrrwi x12,    0x340, 0x1e
  csrrci x12,    0x340, 0x1f
  csrrsi x12,    0x340, 0x1f
  csrrwi x12,    0x340, 0x1f

  csrrci x13,    0x340, 0x0
  csrrsi x13,    0x340, 0x0
  csrrwi x13,    0x340, 0x0
  csrrci x13,    0x340, 0x1
  csrrsi x13,    0x340, 0x1
  csrrwi x13,    0x340, 0x1
  csrrci x13,    0x340, 0x2
  csrrsi x13,    0x340, 0x2
  csrrwi x13,    0x340, 0x2
  csrrci x13,    0x340, 0x3
  csrrsi x13,    0x340, 0x3
  csrrwi x13,    0x340, 0x3
  csrrci x13,    0x340, 0x4
  csrrsi x13,    0x340, 0x4
  csrrwi x13,    0x340, 0x4
  csrrci x13,    0x340, 0x5
  csrrsi x13,    0x340, 0x5
  csrrwi x13,    0x340, 0x5
  csrrci x13,    0x340, 0x6
  csrrsi x13,    0x340, 0x6
  csrrwi x13,    0x340, 0x6
  csrrci x13,    0x340, 0x7
  csrrsi x13,    0x340, 0x7
  csrrwi x13,    0x340, 0x7
  csrrci x13,    0x340, 0x8
  csrrsi x13,    0x340, 0x8
  csrrwi x13,    0x340, 0x8
  csrrci x13,    0x340, 0x9
  csrrsi x13,    0x340, 0x9
  csrrwi x13,    0x340, 0x9
  csrrci x13,    0x340, 0xa
  csrrsi x13,    0x340, 0xa
  csrrwi x13,    0x340, 0xa
  csrrci x13,    0x340, 0xb
  csrrsi x13,    0x340, 0xb
  csrrwi x13,    0x340, 0xb
  csrrci x13,    0x340, 0xc
  csrrsi x13,    0x340, 0xc
  csrrwi x13,    0x340, 0xc
  csrrci x13,    0x340, 0xd
  csrrsi x13,    0x340, 0xd
  csrrwi x13,    0x340, 0xd
  csrrci x13,    0x340, 0xe
  csrrsi x13,    0x340, 0xe
  csrrwi x13,    0x340, 0xe
  csrrci x13,    0x340, 0xf
  csrrsi x13,    0x340, 0xf
  csrrwi x13,    0x340, 0xf
  csrrci x13,    0x340, 0x10
  csrrsi x13,    0x340, 0x10
  csrrwi x13,    0x340, 0x10
  csrrci x13,    0x340, 0x11
  csrrsi x13,    0x340, 0x11
  csrrwi x13,    0x340, 0x11
  csrrci x13,    0x340, 0x12
  csrrsi x13,    0x340, 0x12
  csrrwi x13,    0x340, 0x12
  csrrci x13,    0x340, 0x13
  csrrsi x13,    0x340, 0x13
  csrrwi x13,    0x340, 0x13
  csrrci x13,    0x340, 0x14
  csrrsi x13,    0x340, 0x14
  csrrwi x13,    0x340, 0x14
  csrrci x13,    0x340, 0x15
  csrrsi x13,    0x340, 0x15
  csrrwi x13,    0x340, 0x15
  csrrci x13,    0x340, 0x16
  csrrsi x13,    0x340, 0x16
  csrrwi x13,    0x340, 0x16
  csrrci x13,    0x340, 0x17
  csrrsi x13,    0x340, 0x17
  csrrwi x13,    0x340, 0x17
  csrrci x13,    0x340, 0x18
  csrrsi x13,    0x340, 0x18
  csrrwi x13,    0x340, 0x18
  csrrci x13,    0x340, 0x19
  csrrsi x13,    0x340, 0x19
  csrrwi x13,    0x340, 0x19
  csrrci x13,    0x340, 0x1a
  csrrsi x13,    0x340, 0x1a
  csrrwi x13,    0x340, 0x1a
  csrrci x13,    0x340, 0x1b
  csrrsi x13,    0x340, 0x1b
  csrrwi x13,    0x340, 0x1b
  csrrci x13,    0x340, 0x1c
  csrrsi x13,    0x340, 0x1c
  csrrwi x13,    0x340, 0x1c
  csrrci x13,    0x340, 0x1d
  csrrsi x13,    0x340, 0x1d
  csrrwi x13,    0x340, 0x1d
  csrrci x13,    0x340, 0x1e
  csrrsi x13,    0x340, 0x1e
  csrrwi x13,    0x340, 0x1e
  csrrci x13,    0x340, 0x1f
  csrrsi x13,    0x340, 0x1f
  csrrwi x13,    0x340, 0x1f

  csrrci x14,    0x340, 0x0
  csrrsi x14,    0x340, 0x0
  csrrwi x14,    0x340, 0x0
  csrrci x14,    0x340, 0x1
  csrrsi x14,    0x340, 0x1
  csrrwi x14,    0x340, 0x1
  csrrci x14,    0x340, 0x2
  csrrsi x14,    0x340, 0x2
  csrrwi x14,    0x340, 0x2
  csrrci x14,    0x340, 0x3
  csrrsi x14,    0x340, 0x3
  csrrwi x14,    0x340, 0x3
  csrrci x14,    0x340, 0x4
  csrrsi x14,    0x340, 0x4
  csrrwi x14,    0x340, 0x4
  csrrci x14,    0x340, 0x5
  csrrsi x14,    0x340, 0x5
  csrrwi x14,    0x340, 0x5
  csrrci x14,    0x340, 0x6
  csrrsi x14,    0x340, 0x6
  csrrwi x14,    0x340, 0x6
  csrrci x14,    0x340, 0x7
  csrrsi x14,    0x340, 0x7
  csrrwi x14,    0x340, 0x7
  csrrci x14,    0x340, 0x8
  csrrsi x14,    0x340, 0x8
  csrrwi x14,    0x340, 0x8
  csrrci x14,    0x340, 0x9
  csrrsi x14,    0x340, 0x9
  csrrwi x14,    0x340, 0x9
  csrrci x14,    0x340, 0xa
  csrrsi x14,    0x340, 0xa
  csrrwi x14,    0x340, 0xa
  csrrci x14,    0x340, 0xb
  csrrsi x14,    0x340, 0xb
  csrrwi x14,    0x340, 0xb
  csrrci x14,    0x340, 0xc
  csrrsi x14,    0x340, 0xc
  csrrwi x14,    0x340, 0xc
  csrrci x14,    0x340, 0xd
  csrrsi x14,    0x340, 0xd
  csrrwi x14,    0x340, 0xd
  csrrci x14,    0x340, 0xe
  csrrsi x14,    0x340, 0xe
  csrrwi x14,    0x340, 0xe
  csrrci x14,    0x340, 0xf
  csrrsi x14,    0x340, 0xf
  csrrwi x14,    0x340, 0xf
  csrrci x14,    0x340, 0x10
  csrrsi x14,    0x340, 0x10
  csrrwi x14,    0x340, 0x10
  csrrci x14,    0x340, 0x11
  csrrsi x14,    0x340, 0x11
  csrrwi x14,    0x340, 0x11
  csrrci x14,    0x340, 0x12
  csrrsi x14,    0x340, 0x12
  csrrwi x14,    0x340, 0x12
  csrrci x14,    0x340, 0x13
  csrrsi x14,    0x340, 0x13
  csrrwi x14,    0x340, 0x13
  csrrci x14,    0x340, 0x14
  csrrsi x14,    0x340, 0x14
  csrrwi x14,    0x340, 0x14
  csrrci x14,    0x340, 0x15
  csrrsi x14,    0x340, 0x15
  csrrwi x14,    0x340, 0x15
  csrrci x14,    0x340, 0x16
  csrrsi x14,    0x340, 0x16
  csrrwi x14,    0x340, 0x16
  csrrci x14,    0x340, 0x17
  csrrsi x14,    0x340, 0x17
  csrrwi x14,    0x340, 0x17
  csrrci x14,    0x340, 0x18
  csrrsi x14,    0x340, 0x18
  csrrwi x14,    0x340, 0x18
  csrrci x14,    0x340, 0x19
  csrrsi x14,    0x340, 0x19
  csrrwi x14,    0x340, 0x19
  csrrci x14,    0x340, 0x1a
  csrrsi x14,    0x340, 0x1a
  csrrwi x14,    0x340, 0x1a
  csrrci x14,    0x340, 0x1b
  csrrsi x14,    0x340, 0x1b
  csrrwi x14,    0x340, 0x1b
  csrrci x14,    0x340, 0x1c
  csrrsi x14,    0x340, 0x1c
  csrrwi x14,    0x340, 0x1c
  csrrci x14,    0x340, 0x1d
  csrrsi x14,    0x340, 0x1d
  csrrwi x14,    0x340, 0x1d
  csrrci x14,    0x340, 0x1e
  csrrsi x14,    0x340, 0x1e
  csrrwi x14,    0x340, 0x1e
  csrrci x14,    0x340, 0x1f
  csrrsi x14,    0x340, 0x1f
  csrrwi x14,    0x340, 0x1f

  csrrci x15,    0x340, 0x0
  csrrsi x15,    0x340, 0x0
  csrrwi x15,    0x340, 0x0
  csrrci x15,    0x340, 0x1
  csrrsi x15,    0x340, 0x1
  csrrwi x15,    0x340, 0x1
  csrrci x15,    0x340, 0x2
  csrrsi x15,    0x340, 0x2
  csrrwi x15,    0x340, 0x2
  csrrci x15,    0x340, 0x3
  csrrsi x15,    0x340, 0x3
  csrrwi x15,    0x340, 0x3
  csrrci x15,    0x340, 0x4
  csrrsi x15,    0x340, 0x4
  csrrwi x15,    0x340, 0x4
  csrrci x15,    0x340, 0x5
  csrrsi x15,    0x340, 0x5
  csrrwi x15,    0x340, 0x5
  csrrci x15,    0x340, 0x6
  csrrsi x15,    0x340, 0x6
  csrrwi x15,    0x340, 0x6
  csrrci x15,    0x340, 0x7
  csrrsi x15,    0x340, 0x7
  csrrwi x15,    0x340, 0x7
  csrrci x15,    0x340, 0x8
  csrrsi x15,    0x340, 0x8
  csrrwi x15,    0x340, 0x8
  csrrci x15,    0x340, 0x9
  csrrsi x15,    0x340, 0x9
  csrrwi x15,    0x340, 0x9
  csrrci x15,    0x340, 0xa
  csrrsi x15,    0x340, 0xa
  csrrwi x15,    0x340, 0xa
  csrrci x15,    0x340, 0xb
  csrrsi x15,    0x340, 0xb
  csrrwi x15,    0x340, 0xb
  csrrci x15,    0x340, 0xc
  csrrsi x15,    0x340, 0xc
  csrrwi x15,    0x340, 0xc
  csrrci x15,    0x340, 0xd
  csrrsi x15,    0x340, 0xd
  csrrwi x15,    0x340, 0xd
  csrrci x15,    0x340, 0xe
  csrrsi x15,    0x340, 0xe
  csrrwi x15,    0x340, 0xe
  csrrci x15,    0x340, 0xf
  csrrsi x15,    0x340, 0xf
  csrrwi x15,    0x340, 0xf
  csrrci x15,    0x340, 0x10
  csrrsi x15,    0x340, 0x10
  csrrwi x15,    0x340, 0x10
  csrrci x15,    0x340, 0x11
  csrrsi x15,    0x340, 0x11
  csrrwi x15,    0x340, 0x11
  csrrci x15,    0x340, 0x12
  csrrsi x15,    0x340, 0x12
  csrrwi x15,    0x340, 0x12
  csrrci x15,    0x340, 0x13
  csrrsi x15,    0x340, 0x13
  csrrwi x15,    0x340, 0x13
  csrrci x15,    0x340, 0x14
  csrrsi x15,    0x340, 0x14
  csrrwi x15,    0x340, 0x14
  csrrci x15,    0x340, 0x15
  csrrsi x15,    0x340, 0x15
  csrrwi x15,    0x340, 0x15
  csrrci x15,    0x340, 0x16
  csrrsi x15,    0x340, 0x16
  csrrwi x15,    0x340, 0x16
  csrrci x15,    0x340, 0x17
  csrrsi x15,    0x340, 0x17
  csrrwi x15,    0x340, 0x17
  csrrci x15,    0x340, 0x18
  csrrsi x15,    0x340, 0x18
  csrrwi x15,    0x340, 0x18
  csrrci x15,    0x340, 0x19
  csrrsi x15,    0x340, 0x19
  csrrwi x15,    0x340, 0x19
  csrrci x15,    0x340, 0x1a
  csrrsi x15,    0x340, 0x1a
  csrrwi x15,    0x340, 0x1a
  csrrci x15,    0x340, 0x1b
  csrrsi x15,    0x340, 0x1b
  csrrwi x15,    0x340, 0x1b
  csrrci x15,    0x340, 0x1c
  csrrsi x15,    0x340, 0x1c
  csrrwi x15,    0x340, 0x1c
  csrrci x15,    0x340, 0x1d
  csrrsi x15,    0x340, 0x1d
  csrrwi x15,    0x340, 0x1d
  csrrci x15,    0x340, 0x1e
  csrrsi x15,    0x340, 0x1e
  csrrwi x15,    0x340, 0x1e
  csrrci x15,    0x340, 0x1f
  csrrsi x15,    0x340, 0x1f
  csrrwi x15,    0x340, 0x1f

  csrrci x16,    0x340, 0x0
  csrrsi x16,    0x340, 0x0
  csrrwi x16,    0x340, 0x0
  csrrci x16,    0x340, 0x1
  csrrsi x16,    0x340, 0x1
  csrrwi x16,    0x340, 0x1
  csrrci x16,    0x340, 0x2
  csrrsi x16,    0x340, 0x2
  csrrwi x16,    0x340, 0x2
  csrrci x16,    0x340, 0x3
  csrrsi x16,    0x340, 0x3
  csrrwi x16,    0x340, 0x3
  csrrci x16,    0x340, 0x4
  csrrsi x16,    0x340, 0x4
  csrrwi x16,    0x340, 0x4
  csrrci x16,    0x340, 0x5
  csrrsi x16,    0x340, 0x5
  csrrwi x16,    0x340, 0x5
  csrrci x16,    0x340, 0x6
  csrrsi x16,    0x340, 0x6
  csrrwi x16,    0x340, 0x6
  csrrci x16,    0x340, 0x7
  csrrsi x16,    0x340, 0x7
  csrrwi x16,    0x340, 0x7
  csrrci x16,    0x340, 0x8
  csrrsi x16,    0x340, 0x8
  csrrwi x16,    0x340, 0x8
  csrrci x16,    0x340, 0x9
  csrrsi x16,    0x340, 0x9
  csrrwi x16,    0x340, 0x9
  csrrci x16,    0x340, 0xa
  csrrsi x16,    0x340, 0xa
  csrrwi x16,    0x340, 0xa
  csrrci x16,    0x340, 0xb
  csrrsi x16,    0x340, 0xb
  csrrwi x16,    0x340, 0xb
  csrrci x16,    0x340, 0xc
  csrrsi x16,    0x340, 0xc
  csrrwi x16,    0x340, 0xc
  csrrci x16,    0x340, 0xd
  csrrsi x16,    0x340, 0xd
  csrrwi x16,    0x340, 0xd
  csrrci x16,    0x340, 0xe
  csrrsi x16,    0x340, 0xe
  csrrwi x16,    0x340, 0xe
  csrrci x16,    0x340, 0xf
  csrrsi x16,    0x340, 0xf
  csrrwi x16,    0x340, 0xf
  csrrci x16,    0x340, 0x10
  csrrsi x16,    0x340, 0x10
  csrrwi x16,    0x340, 0x10
  csrrci x16,    0x340, 0x11
  csrrsi x16,    0x340, 0x11
  csrrwi x16,    0x340, 0x11
  csrrci x16,    0x340, 0x12
  csrrsi x16,    0x340, 0x12
  csrrwi x16,    0x340, 0x12
  csrrci x16,    0x340, 0x13
  csrrsi x16,    0x340, 0x13
  csrrwi x16,    0x340, 0x13
  csrrci x16,    0x340, 0x14
  csrrsi x16,    0x340, 0x14
  csrrwi x16,    0x340, 0x14
  csrrci x16,    0x340, 0x15
  csrrsi x16,    0x340, 0x15
  csrrwi x16,    0x340, 0x15
  csrrci x16,    0x340, 0x16
  csrrsi x16,    0x340, 0x16
  csrrwi x16,    0x340, 0x16
  csrrci x16,    0x340, 0x17
  csrrsi x16,    0x340, 0x17
  csrrwi x16,    0x340, 0x17
  csrrci x16,    0x340, 0x18
  csrrsi x16,    0x340, 0x18
  csrrwi x16,    0x340, 0x18
  csrrci x16,    0x340, 0x19
  csrrsi x16,    0x340, 0x19
  csrrwi x16,    0x340, 0x19
  csrrci x16,    0x340, 0x1a
  csrrsi x16,    0x340, 0x1a
  csrrwi x16,    0x340, 0x1a
  csrrci x16,    0x340, 0x1b
  csrrsi x16,    0x340, 0x1b
  csrrwi x16,    0x340, 0x1b
  csrrci x16,    0x340, 0x1c
  csrrsi x16,    0x340, 0x1c
  csrrwi x16,    0x340, 0x1c
  csrrci x16,    0x340, 0x1d
  csrrsi x16,    0x340, 0x1d
  csrrwi x16,    0x340, 0x1d
  csrrci x16,    0x340, 0x1e
  csrrsi x16,    0x340, 0x1e
  csrrwi x16,    0x340, 0x1e
  csrrci x16,    0x340, 0x1f
  csrrsi x16,    0x340, 0x1f
  csrrwi x16,    0x340, 0x1f

  csrrci x17,    0x340, 0x0
  csrrsi x17,    0x340, 0x0
  csrrwi x17,    0x340, 0x0
  csrrci x17,    0x340, 0x1
  csrrsi x17,    0x340, 0x1
  csrrwi x17,    0x340, 0x1
  csrrci x17,    0x340, 0x2
  csrrsi x17,    0x340, 0x2
  csrrwi x17,    0x340, 0x2
  csrrci x17,    0x340, 0x3
  csrrsi x17,    0x340, 0x3
  csrrwi x17,    0x340, 0x3
  csrrci x17,    0x340, 0x4
  csrrsi x17,    0x340, 0x4
  csrrwi x17,    0x340, 0x4
  csrrci x17,    0x340, 0x5
  csrrsi x17,    0x340, 0x5
  csrrwi x17,    0x340, 0x5
  csrrci x17,    0x340, 0x6
  csrrsi x17,    0x340, 0x6
  csrrwi x17,    0x340, 0x6
  csrrci x17,    0x340, 0x7
  csrrsi x17,    0x340, 0x7
  csrrwi x17,    0x340, 0x7
  csrrci x17,    0x340, 0x8
  csrrsi x17,    0x340, 0x8
  csrrwi x17,    0x340, 0x8
  csrrci x17,    0x340, 0x9
  csrrsi x17,    0x340, 0x9
  csrrwi x17,    0x340, 0x9
  csrrci x17,    0x340, 0xa
  csrrsi x17,    0x340, 0xa
  csrrwi x17,    0x340, 0xa
  csrrci x17,    0x340, 0xb
  csrrsi x17,    0x340, 0xb
  csrrwi x17,    0x340, 0xb
  csrrci x17,    0x340, 0xc
  csrrsi x17,    0x340, 0xc
  csrrwi x17,    0x340, 0xc
  csrrci x17,    0x340, 0xd
  csrrsi x17,    0x340, 0xd
  csrrwi x17,    0x340, 0xd
  csrrci x17,    0x340, 0xe
  csrrsi x17,    0x340, 0xe
  csrrwi x17,    0x340, 0xe
  csrrci x17,    0x340, 0xf
  csrrsi x17,    0x340, 0xf
  csrrwi x17,    0x340, 0xf
  csrrci x17,    0x340, 0x10
  csrrsi x17,    0x340, 0x10
  csrrwi x17,    0x340, 0x10
  csrrci x17,    0x340, 0x11
  csrrsi x17,    0x340, 0x11
  csrrwi x17,    0x340, 0x11
  csrrci x17,    0x340, 0x12
  csrrsi x17,    0x340, 0x12
  csrrwi x17,    0x340, 0x12
  csrrci x17,    0x340, 0x13
  csrrsi x17,    0x340, 0x13
  csrrwi x17,    0x340, 0x13
  csrrci x17,    0x340, 0x14
  csrrsi x17,    0x340, 0x14
  csrrwi x17,    0x340, 0x14
  csrrci x17,    0x340, 0x15
  csrrsi x17,    0x340, 0x15
  csrrwi x17,    0x340, 0x15
  csrrci x17,    0x340, 0x16
  csrrsi x17,    0x340, 0x16
  csrrwi x17,    0x340, 0x16
  csrrci x17,    0x340, 0x17
  csrrsi x17,    0x340, 0x17
  csrrwi x17,    0x340, 0x17
  csrrci x17,    0x340, 0x18
  csrrsi x17,    0x340, 0x18
  csrrwi x17,    0x340, 0x18
  csrrci x17,    0x340, 0x19
  csrrsi x17,    0x340, 0x19
  csrrwi x17,    0x340, 0x19
  csrrci x17,    0x340, 0x1a
  csrrsi x17,    0x340, 0x1a
  csrrwi x17,    0x340, 0x1a
  csrrci x17,    0x340, 0x1b
  csrrsi x17,    0x340, 0x1b
  csrrwi x17,    0x340, 0x1b
  csrrci x17,    0x340, 0x1c
  csrrsi x17,    0x340, 0x1c
  csrrwi x17,    0x340, 0x1c
  csrrci x17,    0x340, 0x1d
  csrrsi x17,    0x340, 0x1d
  csrrwi x17,    0x340, 0x1d
  csrrci x17,    0x340, 0x1e
  csrrsi x17,    0x340, 0x1e
  csrrwi x17,    0x340, 0x1e
  csrrci x17,    0x340, 0x1f
  csrrsi x17,    0x340, 0x1f
  csrrwi x17,    0x340, 0x1f

  csrrci x18,    0x340, 0x0
  csrrsi x18,    0x340, 0x0
  csrrwi x18,    0x340, 0x0
  csrrci x18,    0x340, 0x1
  csrrsi x18,    0x340, 0x1
  csrrwi x18,    0x340, 0x1
  csrrci x18,    0x340, 0x2
  csrrsi x18,    0x340, 0x2
  csrrwi x18,    0x340, 0x2
  csrrci x18,    0x340, 0x3
  csrrsi x18,    0x340, 0x3
  csrrwi x18,    0x340, 0x3
  csrrci x18,    0x340, 0x4
  csrrsi x18,    0x340, 0x4
  csrrwi x18,    0x340, 0x4
  csrrci x18,    0x340, 0x5
  csrrsi x18,    0x340, 0x5
  csrrwi x18,    0x340, 0x5
  csrrci x18,    0x340, 0x6
  csrrsi x18,    0x340, 0x6
  csrrwi x18,    0x340, 0x6
  csrrci x18,    0x340, 0x7
  csrrsi x18,    0x340, 0x7
  csrrwi x18,    0x340, 0x7
  csrrci x18,    0x340, 0x8
  csrrsi x18,    0x340, 0x8
  csrrwi x18,    0x340, 0x8
  csrrci x18,    0x340, 0x9
  csrrsi x18,    0x340, 0x9
  csrrwi x18,    0x340, 0x9
  csrrci x18,    0x340, 0xa
  csrrsi x18,    0x340, 0xa
  csrrwi x18,    0x340, 0xa
  csrrci x18,    0x340, 0xb
  csrrsi x18,    0x340, 0xb
  csrrwi x18,    0x340, 0xb
  csrrci x18,    0x340, 0xc
  csrrsi x18,    0x340, 0xc
  csrrwi x18,    0x340, 0xc
  csrrci x18,    0x340, 0xd
  csrrsi x18,    0x340, 0xd
  csrrwi x18,    0x340, 0xd
  csrrci x18,    0x340, 0xe
  csrrsi x18,    0x340, 0xe
  csrrwi x18,    0x340, 0xe
  csrrci x18,    0x340, 0xf
  csrrsi x18,    0x340, 0xf
  csrrwi x18,    0x340, 0xf
  csrrci x18,    0x340, 0x10
  csrrsi x18,    0x340, 0x10
  csrrwi x18,    0x340, 0x10
  csrrci x18,    0x340, 0x11
  csrrsi x18,    0x340, 0x11
  csrrwi x18,    0x340, 0x11
  csrrci x18,    0x340, 0x12
  csrrsi x18,    0x340, 0x12
  csrrwi x18,    0x340, 0x12
  csrrci x18,    0x340, 0x13
  csrrsi x18,    0x340, 0x13
  csrrwi x18,    0x340, 0x13
  csrrci x18,    0x340, 0x14
  csrrsi x18,    0x340, 0x14
  csrrwi x18,    0x340, 0x14
  csrrci x18,    0x340, 0x15
  csrrsi x18,    0x340, 0x15
  csrrwi x18,    0x340, 0x15
  csrrci x18,    0x340, 0x16
  csrrsi x18,    0x340, 0x16
  csrrwi x18,    0x340, 0x16
  csrrci x18,    0x340, 0x17
  csrrsi x18,    0x340, 0x17
  csrrwi x18,    0x340, 0x17
  csrrci x18,    0x340, 0x18
  csrrsi x18,    0x340, 0x18
  csrrwi x18,    0x340, 0x18
  csrrci x18,    0x340, 0x19
  csrrsi x18,    0x340, 0x19
  csrrwi x18,    0x340, 0x19
  csrrci x18,    0x340, 0x1a
  csrrsi x18,    0x340, 0x1a
  csrrwi x18,    0x340, 0x1a
  csrrci x18,    0x340, 0x1b
  csrrsi x18,    0x340, 0x1b
  csrrwi x18,    0x340, 0x1b
  csrrci x18,    0x340, 0x1c
  csrrsi x18,    0x340, 0x1c
  csrrwi x18,    0x340, 0x1c
  csrrci x18,    0x340, 0x1d
  csrrsi x18,    0x340, 0x1d
  csrrwi x18,    0x340, 0x1d
  csrrci x18,    0x340, 0x1e
  csrrsi x18,    0x340, 0x1e
  csrrwi x18,    0x340, 0x1e
  csrrci x18,    0x340, 0x1f
  csrrsi x18,    0x340, 0x1f
  csrrwi x18,    0x340, 0x1f

  csrrci x19,    0x340, 0x0
  csrrsi x19,    0x340, 0x0
  csrrwi x19,    0x340, 0x0
  csrrci x19,    0x340, 0x1
  csrrsi x19,    0x340, 0x1
  csrrwi x19,    0x340, 0x1
  csrrci x19,    0x340, 0x2
  csrrsi x19,    0x340, 0x2
  csrrwi x19,    0x340, 0x2
  csrrci x19,    0x340, 0x3
  csrrsi x19,    0x340, 0x3
  csrrwi x19,    0x340, 0x3
  csrrci x19,    0x340, 0x4
  csrrsi x19,    0x340, 0x4
  csrrwi x19,    0x340, 0x4
  csrrci x19,    0x340, 0x5
  csrrsi x19,    0x340, 0x5
  csrrwi x19,    0x340, 0x5
  csrrci x19,    0x340, 0x6
  csrrsi x19,    0x340, 0x6
  csrrwi x19,    0x340, 0x6
  csrrci x19,    0x340, 0x7
  csrrsi x19,    0x340, 0x7
  csrrwi x19,    0x340, 0x7
  csrrci x19,    0x340, 0x8
  csrrsi x19,    0x340, 0x8
  csrrwi x19,    0x340, 0x8
  csrrci x19,    0x340, 0x9
  csrrsi x19,    0x340, 0x9
  csrrwi x19,    0x340, 0x9
  csrrci x19,    0x340, 0xa
  csrrsi x19,    0x340, 0xa
  csrrwi x19,    0x340, 0xa
  csrrci x19,    0x340, 0xb
  csrrsi x19,    0x340, 0xb
  csrrwi x19,    0x340, 0xb
  csrrci x19,    0x340, 0xc
  csrrsi x19,    0x340, 0xc
  csrrwi x19,    0x340, 0xc
  csrrci x19,    0x340, 0xd
  csrrsi x19,    0x340, 0xd
  csrrwi x19,    0x340, 0xd
  csrrci x19,    0x340, 0xe
  csrrsi x19,    0x340, 0xe
  csrrwi x19,    0x340, 0xe
  csrrci x19,    0x340, 0xf
  csrrsi x19,    0x340, 0xf
  csrrwi x19,    0x340, 0xf
  csrrci x19,    0x340, 0x10
  csrrsi x19,    0x340, 0x10
  csrrwi x19,    0x340, 0x10
  csrrci x19,    0x340, 0x11
  csrrsi x19,    0x340, 0x11
  csrrwi x19,    0x340, 0x11
  csrrci x19,    0x340, 0x12
  csrrsi x19,    0x340, 0x12
  csrrwi x19,    0x340, 0x12
  csrrci x19,    0x340, 0x13
  csrrsi x19,    0x340, 0x13
  csrrwi x19,    0x340, 0x13
  csrrci x19,    0x340, 0x14
  csrrsi x19,    0x340, 0x14
  csrrwi x19,    0x340, 0x14
  csrrci x19,    0x340, 0x15
  csrrsi x19,    0x340, 0x15
  csrrwi x19,    0x340, 0x15
  csrrci x19,    0x340, 0x16
  csrrsi x19,    0x340, 0x16
  csrrwi x19,    0x340, 0x16
  csrrci x19,    0x340, 0x17
  csrrsi x19,    0x340, 0x17
  csrrwi x19,    0x340, 0x17
  csrrci x19,    0x340, 0x18
  csrrsi x19,    0x340, 0x18
  csrrwi x19,    0x340, 0x18
  csrrci x19,    0x340, 0x19
  csrrsi x19,    0x340, 0x19
  csrrwi x19,    0x340, 0x19
  csrrci x19,    0x340, 0x1a
  csrrsi x19,    0x340, 0x1a
  csrrwi x19,    0x340, 0x1a
  csrrci x19,    0x340, 0x1b
  csrrsi x19,    0x340, 0x1b
  csrrwi x19,    0x340, 0x1b
  csrrci x19,    0x340, 0x1c
  csrrsi x19,    0x340, 0x1c
  csrrwi x19,    0x340, 0x1c
  csrrci x19,    0x340, 0x1d
  csrrsi x19,    0x340, 0x1d
  csrrwi x19,    0x340, 0x1d
  csrrci x19,    0x340, 0x1e
  csrrsi x19,    0x340, 0x1e
  csrrwi x19,    0x340, 0x1e
  csrrci x19,    0x340, 0x1f
  csrrsi x19,    0x340, 0x1f
  csrrwi x19,    0x340, 0x1f

  csrrci x20,    0x340, 0x0
  csrrsi x20,    0x340, 0x0
  csrrwi x20,    0x340, 0x0
  csrrci x20,    0x340, 0x1
  csrrsi x20,    0x340, 0x1
  csrrwi x20,    0x340, 0x1
  csrrci x20,    0x340, 0x2
  csrrsi x20,    0x340, 0x2
  csrrwi x20,    0x340, 0x2
  csrrci x20,    0x340, 0x3
  csrrsi x20,    0x340, 0x3
  csrrwi x20,    0x340, 0x3
  csrrci x20,    0x340, 0x4
  csrrsi x20,    0x340, 0x4
  csrrwi x20,    0x340, 0x4
  csrrci x20,    0x340, 0x5
  csrrsi x20,    0x340, 0x5
  csrrwi x20,    0x340, 0x5
  csrrci x20,    0x340, 0x6
  csrrsi x20,    0x340, 0x6
  csrrwi x20,    0x340, 0x6
  csrrci x20,    0x340, 0x7
  csrrsi x20,    0x340, 0x7
  csrrwi x20,    0x340, 0x7
  csrrci x20,    0x340, 0x8
  csrrsi x20,    0x340, 0x8
  csrrwi x20,    0x340, 0x8
  csrrci x20,    0x340, 0x9
  csrrsi x20,    0x340, 0x9
  csrrwi x20,    0x340, 0x9
  csrrci x20,    0x340, 0xa
  csrrsi x20,    0x340, 0xa
  csrrwi x20,    0x340, 0xa
  csrrci x20,    0x340, 0xb
  csrrsi x20,    0x340, 0xb
  csrrwi x20,    0x340, 0xb
  csrrci x20,    0x340, 0xc
  csrrsi x20,    0x340, 0xc
  csrrwi x20,    0x340, 0xc
  csrrci x20,    0x340, 0xd
  csrrsi x20,    0x340, 0xd
  csrrwi x20,    0x340, 0xd
  csrrci x20,    0x340, 0xe
  csrrsi x20,    0x340, 0xe
  csrrwi x20,    0x340, 0xe
  csrrci x20,    0x340, 0xf
  csrrsi x20,    0x340, 0xf
  csrrwi x20,    0x340, 0xf
  csrrci x20,    0x340, 0x10
  csrrsi x20,    0x340, 0x10
  csrrwi x20,    0x340, 0x10
  csrrci x20,    0x340, 0x11
  csrrsi x20,    0x340, 0x11
  csrrwi x20,    0x340, 0x11
  csrrci x20,    0x340, 0x12
  csrrsi x20,    0x340, 0x12
  csrrwi x20,    0x340, 0x12
  csrrci x20,    0x340, 0x13
  csrrsi x20,    0x340, 0x13
  csrrwi x20,    0x340, 0x13
  csrrci x20,    0x340, 0x14
  csrrsi x20,    0x340, 0x14
  csrrwi x20,    0x340, 0x14
  csrrci x20,    0x340, 0x15
  csrrsi x20,    0x340, 0x15
  csrrwi x20,    0x340, 0x15
  csrrci x20,    0x340, 0x16
  csrrsi x20,    0x340, 0x16
  csrrwi x20,    0x340, 0x16
  csrrci x20,    0x340, 0x17
  csrrsi x20,    0x340, 0x17
  csrrwi x20,    0x340, 0x17
  csrrci x20,    0x340, 0x18
  csrrsi x20,    0x340, 0x18
  csrrwi x20,    0x340, 0x18
  csrrci x20,    0x340, 0x19
  csrrsi x20,    0x340, 0x19
  csrrwi x20,    0x340, 0x19
  csrrci x20,    0x340, 0x1a
  csrrsi x20,    0x340, 0x1a
  csrrwi x20,    0x340, 0x1a
  csrrci x20,    0x340, 0x1b
  csrrsi x20,    0x340, 0x1b
  csrrwi x20,    0x340, 0x1b
  csrrci x20,    0x340, 0x1c
  csrrsi x20,    0x340, 0x1c
  csrrwi x20,    0x340, 0x1c
  csrrci x20,    0x340, 0x1d
  csrrsi x20,    0x340, 0x1d
  csrrwi x20,    0x340, 0x1d
  csrrci x20,    0x340, 0x1e
  csrrsi x20,    0x340, 0x1e
  csrrwi x20,    0x340, 0x1e
  csrrci x20,    0x340, 0x1f
  csrrsi x20,    0x340, 0x1f
  csrrwi x20,    0x340, 0x1f

  csrrci x21,    0x340, 0x0
  csrrsi x21,    0x340, 0x0
  csrrwi x21,    0x340, 0x0
  csrrci x21,    0x340, 0x1
  csrrsi x21,    0x340, 0x1
  csrrwi x21,    0x340, 0x1
  csrrci x21,    0x340, 0x2
  csrrsi x21,    0x340, 0x2
  csrrwi x21,    0x340, 0x2
  csrrci x21,    0x340, 0x3
  csrrsi x21,    0x340, 0x3
  csrrwi x21,    0x340, 0x3
  csrrci x21,    0x340, 0x4
  csrrsi x21,    0x340, 0x4
  csrrwi x21,    0x340, 0x4
  csrrci x21,    0x340, 0x5
  csrrsi x21,    0x340, 0x5
  csrrwi x21,    0x340, 0x5
  csrrci x21,    0x340, 0x6
  csrrsi x21,    0x340, 0x6
  csrrwi x21,    0x340, 0x6
  csrrci x21,    0x340, 0x7
  csrrsi x21,    0x340, 0x7
  csrrwi x21,    0x340, 0x7
  csrrci x21,    0x340, 0x8
  csrrsi x21,    0x340, 0x8
  csrrwi x21,    0x340, 0x8
  csrrci x21,    0x340, 0x9
  csrrsi x21,    0x340, 0x9
  csrrwi x21,    0x340, 0x9
  csrrci x21,    0x340, 0xa
  csrrsi x21,    0x340, 0xa
  csrrwi x21,    0x340, 0xa
  csrrci x21,    0x340, 0xb
  csrrsi x21,    0x340, 0xb
  csrrwi x21,    0x340, 0xb
  csrrci x21,    0x340, 0xc
  csrrsi x21,    0x340, 0xc
  csrrwi x21,    0x340, 0xc
  csrrci x21,    0x340, 0xd
  csrrsi x21,    0x340, 0xd
  csrrwi x21,    0x340, 0xd
  csrrci x21,    0x340, 0xe
  csrrsi x21,    0x340, 0xe
  csrrwi x21,    0x340, 0xe
  csrrci x21,    0x340, 0xf
  csrrsi x21,    0x340, 0xf
  csrrwi x21,    0x340, 0xf
  csrrci x21,    0x340, 0x10
  csrrsi x21,    0x340, 0x10
  csrrwi x21,    0x340, 0x10
  csrrci x21,    0x340, 0x11
  csrrsi x21,    0x340, 0x11
  csrrwi x21,    0x340, 0x11
  csrrci x21,    0x340, 0x12
  csrrsi x21,    0x340, 0x12
  csrrwi x21,    0x340, 0x12
  csrrci x21,    0x340, 0x13
  csrrsi x21,    0x340, 0x13
  csrrwi x21,    0x340, 0x13
  csrrci x21,    0x340, 0x14
  csrrsi x21,    0x340, 0x14
  csrrwi x21,    0x340, 0x14
  csrrci x21,    0x340, 0x15
  csrrsi x21,    0x340, 0x15
  csrrwi x21,    0x340, 0x15
  csrrci x21,    0x340, 0x16
  csrrsi x21,    0x340, 0x16
  csrrwi x21,    0x340, 0x16
  csrrci x21,    0x340, 0x17
  csrrsi x21,    0x340, 0x17
  csrrwi x21,    0x340, 0x17
  csrrci x21,    0x340, 0x18
  csrrsi x21,    0x340, 0x18
  csrrwi x21,    0x340, 0x18
  csrrci x21,    0x340, 0x19
  csrrsi x21,    0x340, 0x19
  csrrwi x21,    0x340, 0x19
  csrrci x21,    0x340, 0x1a
  csrrsi x21,    0x340, 0x1a
  csrrwi x21,    0x340, 0x1a
  csrrci x21,    0x340, 0x1b
  csrrsi x21,    0x340, 0x1b
  csrrwi x21,    0x340, 0x1b
  csrrci x21,    0x340, 0x1c
  csrrsi x21,    0x340, 0x1c
  csrrwi x21,    0x340, 0x1c
  csrrci x21,    0x340, 0x1d
  csrrsi x21,    0x340, 0x1d
  csrrwi x21,    0x340, 0x1d
  csrrci x21,    0x340, 0x1e
  csrrsi x21,    0x340, 0x1e
  csrrwi x21,    0x340, 0x1e
  csrrci x21,    0x340, 0x1f
  csrrsi x21,    0x340, 0x1f
  csrrwi x21,    0x340, 0x1f

  csrrci x22,    0x340, 0x0
  csrrsi x22,    0x340, 0x0
  csrrwi x22,    0x340, 0x0
  csrrci x22,    0x340, 0x1
  csrrsi x22,    0x340, 0x1
  csrrwi x22,    0x340, 0x1
  csrrci x22,    0x340, 0x2
  csrrsi x22,    0x340, 0x2
  csrrwi x22,    0x340, 0x2
  csrrci x22,    0x340, 0x3
  csrrsi x22,    0x340, 0x3
  csrrwi x22,    0x340, 0x3
  csrrci x22,    0x340, 0x4
  csrrsi x22,    0x340, 0x4
  csrrwi x22,    0x340, 0x4
  csrrci x22,    0x340, 0x5
  csrrsi x22,    0x340, 0x5
  csrrwi x22,    0x340, 0x5
  csrrci x22,    0x340, 0x6
  csrrsi x22,    0x340, 0x6
  csrrwi x22,    0x340, 0x6
  csrrci x22,    0x340, 0x7
  csrrsi x22,    0x340, 0x7
  csrrwi x22,    0x340, 0x7
  csrrci x22,    0x340, 0x8
  csrrsi x22,    0x340, 0x8
  csrrwi x22,    0x340, 0x8
  csrrci x22,    0x340, 0x9
  csrrsi x22,    0x340, 0x9
  csrrwi x22,    0x340, 0x9
  csrrci x22,    0x340, 0xa
  csrrsi x22,    0x340, 0xa
  csrrwi x22,    0x340, 0xa
  csrrci x22,    0x340, 0xb
  csrrsi x22,    0x340, 0xb
  csrrwi x22,    0x340, 0xb
  csrrci x22,    0x340, 0xc
  csrrsi x22,    0x340, 0xc
  csrrwi x22,    0x340, 0xc
  csrrci x22,    0x340, 0xd
  csrrsi x22,    0x340, 0xd
  csrrwi x22,    0x340, 0xd
  csrrci x22,    0x340, 0xe
  csrrsi x22,    0x340, 0xe
  csrrwi x22,    0x340, 0xe
  csrrci x22,    0x340, 0xf
  csrrsi x22,    0x340, 0xf
  csrrwi x22,    0x340, 0xf
  csrrci x22,    0x340, 0x10
  csrrsi x22,    0x340, 0x10
  csrrwi x22,    0x340, 0x10
  csrrci x22,    0x340, 0x11
  csrrsi x22,    0x340, 0x11
  csrrwi x22,    0x340, 0x11
  csrrci x22,    0x340, 0x12
  csrrsi x22,    0x340, 0x12
  csrrwi x22,    0x340, 0x12
  csrrci x22,    0x340, 0x13
  csrrsi x22,    0x340, 0x13
  csrrwi x22,    0x340, 0x13
  csrrci x22,    0x340, 0x14
  csrrsi x22,    0x340, 0x14
  csrrwi x22,    0x340, 0x14
  csrrci x22,    0x340, 0x15
  csrrsi x22,    0x340, 0x15
  csrrwi x22,    0x340, 0x15
  csrrci x22,    0x340, 0x16
  csrrsi x22,    0x340, 0x16
  csrrwi x22,    0x340, 0x16
  csrrci x22,    0x340, 0x17
  csrrsi x22,    0x340, 0x17
  csrrwi x22,    0x340, 0x17
  csrrci x22,    0x340, 0x18
  csrrsi x22,    0x340, 0x18
  csrrwi x22,    0x340, 0x18
  csrrci x22,    0x340, 0x19
  csrrsi x22,    0x340, 0x19
  csrrwi x22,    0x340, 0x19
  csrrci x22,    0x340, 0x1a
  csrrsi x22,    0x340, 0x1a
  csrrwi x22,    0x340, 0x1a
  csrrci x22,    0x340, 0x1b
  csrrsi x22,    0x340, 0x1b
  csrrwi x22,    0x340, 0x1b
  csrrci x22,    0x340, 0x1c
  csrrsi x22,    0x340, 0x1c
  csrrwi x22,    0x340, 0x1c
  csrrci x22,    0x340, 0x1d
  csrrsi x22,    0x340, 0x1d
  csrrwi x22,    0x340, 0x1d
  csrrci x22,    0x340, 0x1e
  csrrsi x22,    0x340, 0x1e
  csrrwi x22,    0x340, 0x1e
  csrrci x22,    0x340, 0x1f
  csrrsi x22,    0x340, 0x1f
  csrrwi x22,    0x340, 0x1f

  csrrci x23,    0x340, 0x0
  csrrsi x23,    0x340, 0x0
  csrrwi x23,    0x340, 0x0
  csrrci x23,    0x340, 0x1
  csrrsi x23,    0x340, 0x1
  csrrwi x23,    0x340, 0x1
  csrrci x23,    0x340, 0x2
  csrrsi x23,    0x340, 0x2
  csrrwi x23,    0x340, 0x2
  csrrci x23,    0x340, 0x3
  csrrsi x23,    0x340, 0x3
  csrrwi x23,    0x340, 0x3
  csrrci x23,    0x340, 0x4
  csrrsi x23,    0x340, 0x4
  csrrwi x23,    0x340, 0x4
  csrrci x23,    0x340, 0x5
  csrrsi x23,    0x340, 0x5
  csrrwi x23,    0x340, 0x5
  csrrci x23,    0x340, 0x6
  csrrsi x23,    0x340, 0x6
  csrrwi x23,    0x340, 0x6
  csrrci x23,    0x340, 0x7
  csrrsi x23,    0x340, 0x7
  csrrwi x23,    0x340, 0x7
  csrrci x23,    0x340, 0x8
  csrrsi x23,    0x340, 0x8
  csrrwi x23,    0x340, 0x8
  csrrci x23,    0x340, 0x9
  csrrsi x23,    0x340, 0x9
  csrrwi x23,    0x340, 0x9
  csrrci x23,    0x340, 0xa
  csrrsi x23,    0x340, 0xa
  csrrwi x23,    0x340, 0xa
  csrrci x23,    0x340, 0xb
  csrrsi x23,    0x340, 0xb
  csrrwi x23,    0x340, 0xb
  csrrci x23,    0x340, 0xc
  csrrsi x23,    0x340, 0xc
  csrrwi x23,    0x340, 0xc
  csrrci x23,    0x340, 0xd
  csrrsi x23,    0x340, 0xd
  csrrwi x23,    0x340, 0xd
  csrrci x23,    0x340, 0xe
  csrrsi x23,    0x340, 0xe
  csrrwi x23,    0x340, 0xe
  csrrci x23,    0x340, 0xf
  csrrsi x23,    0x340, 0xf
  csrrwi x23,    0x340, 0xf
  csrrci x23,    0x340, 0x10
  csrrsi x23,    0x340, 0x10
  csrrwi x23,    0x340, 0x10
  csrrci x23,    0x340, 0x11
  csrrsi x23,    0x340, 0x11
  csrrwi x23,    0x340, 0x11
  csrrci x23,    0x340, 0x12
  csrrsi x23,    0x340, 0x12
  csrrwi x23,    0x340, 0x12
  csrrci x23,    0x340, 0x13
  csrrsi x23,    0x340, 0x13
  csrrwi x23,    0x340, 0x13
  csrrci x23,    0x340, 0x14
  csrrsi x23,    0x340, 0x14
  csrrwi x23,    0x340, 0x14
  csrrci x23,    0x340, 0x15
  csrrsi x23,    0x340, 0x15
  csrrwi x23,    0x340, 0x15
  csrrci x23,    0x340, 0x16
  csrrsi x23,    0x340, 0x16
  csrrwi x23,    0x340, 0x16
  csrrci x23,    0x340, 0x17
  csrrsi x23,    0x340, 0x17
  csrrwi x23,    0x340, 0x17
  csrrci x23,    0x340, 0x18
  csrrsi x23,    0x340, 0x18
  csrrwi x23,    0x340, 0x18
  csrrci x23,    0x340, 0x19
  csrrsi x23,    0x340, 0x19
  csrrwi x23,    0x340, 0x19
  csrrci x23,    0x340, 0x1a
  csrrsi x23,    0x340, 0x1a
  csrrwi x23,    0x340, 0x1a
  csrrci x23,    0x340, 0x1b
  csrrsi x23,    0x340, 0x1b
  csrrwi x23,    0x340, 0x1b
  csrrci x23,    0x340, 0x1c
  csrrsi x23,    0x340, 0x1c
  csrrwi x23,    0x340, 0x1c
  csrrci x23,    0x340, 0x1d
  csrrsi x23,    0x340, 0x1d
  csrrwi x23,    0x340, 0x1d
  csrrci x23,    0x340, 0x1e
  csrrsi x23,    0x340, 0x1e
  csrrwi x23,    0x340, 0x1e
  csrrci x23,    0x340, 0x1f
  csrrsi x23,    0x340, 0x1f
  csrrwi x23,    0x340, 0x1f

  csrrci x24,    0x340, 0x0
  csrrsi x24,    0x340, 0x0
  csrrwi x24,    0x340, 0x0
  csrrci x24,    0x340, 0x1
  csrrsi x24,    0x340, 0x1
  csrrwi x24,    0x340, 0x1
  csrrci x24,    0x340, 0x2
  csrrsi x24,    0x340, 0x2
  csrrwi x24,    0x340, 0x2
  csrrci x24,    0x340, 0x3
  csrrsi x24,    0x340, 0x3
  csrrwi x24,    0x340, 0x3
  csrrci x24,    0x340, 0x4
  csrrsi x24,    0x340, 0x4
  csrrwi x24,    0x340, 0x4
  csrrci x24,    0x340, 0x5
  csrrsi x24,    0x340, 0x5
  csrrwi x24,    0x340, 0x5
  csrrci x24,    0x340, 0x6
  csrrsi x24,    0x340, 0x6
  csrrwi x24,    0x340, 0x6
  csrrci x24,    0x340, 0x7
  csrrsi x24,    0x340, 0x7
  csrrwi x24,    0x340, 0x7
  csrrci x24,    0x340, 0x8
  csrrsi x24,    0x340, 0x8
  csrrwi x24,    0x340, 0x8
  csrrci x24,    0x340, 0x9
  csrrsi x24,    0x340, 0x9
  csrrwi x24,    0x340, 0x9
  csrrci x24,    0x340, 0xa
  csrrsi x24,    0x340, 0xa
  csrrwi x24,    0x340, 0xa
  csrrci x24,    0x340, 0xb
  csrrsi x24,    0x340, 0xb
  csrrwi x24,    0x340, 0xb
  csrrci x24,    0x340, 0xc
  csrrsi x24,    0x340, 0xc
  csrrwi x24,    0x340, 0xc
  csrrci x24,    0x340, 0xd
  csrrsi x24,    0x340, 0xd
  csrrwi x24,    0x340, 0xd
  csrrci x24,    0x340, 0xe
  csrrsi x24,    0x340, 0xe
  csrrwi x24,    0x340, 0xe
  csrrci x24,    0x340, 0xf
  csrrsi x24,    0x340, 0xf
  csrrwi x24,    0x340, 0xf
  csrrci x24,    0x340, 0x10
  csrrsi x24,    0x340, 0x10
  csrrwi x24,    0x340, 0x10
  csrrci x24,    0x340, 0x11
  csrrsi x24,    0x340, 0x11
  csrrwi x24,    0x340, 0x11
  csrrci x24,    0x340, 0x12
  csrrsi x24,    0x340, 0x12
  csrrwi x24,    0x340, 0x12
  csrrci x24,    0x340, 0x13
  csrrsi x24,    0x340, 0x13
  csrrwi x24,    0x340, 0x13
  csrrci x24,    0x340, 0x14
  csrrsi x24,    0x340, 0x14
  csrrwi x24,    0x340, 0x14
  csrrci x24,    0x340, 0x15
  csrrsi x24,    0x340, 0x15
  csrrwi x24,    0x340, 0x15
  csrrci x24,    0x340, 0x16
  csrrsi x24,    0x340, 0x16
  csrrwi x24,    0x340, 0x16
  csrrci x24,    0x340, 0x17
  csrrsi x24,    0x340, 0x17
  csrrwi x24,    0x340, 0x17
  csrrci x24,    0x340, 0x18
  csrrsi x24,    0x340, 0x18
  csrrwi x24,    0x340, 0x18
  csrrci x24,    0x340, 0x19
  csrrsi x24,    0x340, 0x19
  csrrwi x24,    0x340, 0x19
  csrrci x24,    0x340, 0x1a
  csrrsi x24,    0x340, 0x1a
  csrrwi x24,    0x340, 0x1a
  csrrci x24,    0x340, 0x1b
  csrrsi x24,    0x340, 0x1b
  csrrwi x24,    0x340, 0x1b
  csrrci x24,    0x340, 0x1c
  csrrsi x24,    0x340, 0x1c
  csrrwi x24,    0x340, 0x1c
  csrrci x24,    0x340, 0x1d
  csrrsi x24,    0x340, 0x1d
  csrrwi x24,    0x340, 0x1d
  csrrci x24,    0x340, 0x1e
  csrrsi x24,    0x340, 0x1e
  csrrwi x24,    0x340, 0x1e
  csrrci x24,    0x340, 0x1f
  csrrsi x24,    0x340, 0x1f
  csrrwi x24,    0x340, 0x1f

  csrrci x25,    0x340, 0x0
  csrrsi x25,    0x340, 0x0
  csrrwi x25,    0x340, 0x0
  csrrci x25,    0x340, 0x1
  csrrsi x25,    0x340, 0x1
  csrrwi x25,    0x340, 0x1
  csrrci x25,    0x340, 0x2
  csrrsi x25,    0x340, 0x2
  csrrwi x25,    0x340, 0x2
  csrrci x25,    0x340, 0x3
  csrrsi x25,    0x340, 0x3
  csrrwi x25,    0x340, 0x3
  csrrci x25,    0x340, 0x4
  csrrsi x25,    0x340, 0x4
  csrrwi x25,    0x340, 0x4
  csrrci x25,    0x340, 0x5
  csrrsi x25,    0x340, 0x5
  csrrwi x25,    0x340, 0x5
  csrrci x25,    0x340, 0x6
  csrrsi x25,    0x340, 0x6
  csrrwi x25,    0x340, 0x6
  csrrci x25,    0x340, 0x7
  csrrsi x25,    0x340, 0x7
  csrrwi x25,    0x340, 0x7
  csrrci x25,    0x340, 0x8
  csrrsi x25,    0x340, 0x8
  csrrwi x25,    0x340, 0x8
  csrrci x25,    0x340, 0x9
  csrrsi x25,    0x340, 0x9
  csrrwi x25,    0x340, 0x9
  csrrci x25,    0x340, 0xa
  csrrsi x25,    0x340, 0xa
  csrrwi x25,    0x340, 0xa
  csrrci x25,    0x340, 0xb
  csrrsi x25,    0x340, 0xb
  csrrwi x25,    0x340, 0xb
  csrrci x25,    0x340, 0xc
  csrrsi x25,    0x340, 0xc
  csrrwi x25,    0x340, 0xc
  csrrci x25,    0x340, 0xd
  csrrsi x25,    0x340, 0xd
  csrrwi x25,    0x340, 0xd
  csrrci x25,    0x340, 0xe
  csrrsi x25,    0x340, 0xe
  csrrwi x25,    0x340, 0xe
  csrrci x25,    0x340, 0xf
  csrrsi x25,    0x340, 0xf
  csrrwi x25,    0x340, 0xf
  csrrci x25,    0x340, 0x10
  csrrsi x25,    0x340, 0x10
  csrrwi x25,    0x340, 0x10
  csrrci x25,    0x340, 0x11
  csrrsi x25,    0x340, 0x11
  csrrwi x25,    0x340, 0x11
  csrrci x25,    0x340, 0x12
  csrrsi x25,    0x340, 0x12
  csrrwi x25,    0x340, 0x12
  csrrci x25,    0x340, 0x13
  csrrsi x25,    0x340, 0x13
  csrrwi x25,    0x340, 0x13
  csrrci x25,    0x340, 0x14
  csrrsi x25,    0x340, 0x14
  csrrwi x25,    0x340, 0x14
  csrrci x25,    0x340, 0x15
  csrrsi x25,    0x340, 0x15
  csrrwi x25,    0x340, 0x15
  csrrci x25,    0x340, 0x16
  csrrsi x25,    0x340, 0x16
  csrrwi x25,    0x340, 0x16
  csrrci x25,    0x340, 0x17
  csrrsi x25,    0x340, 0x17
  csrrwi x25,    0x340, 0x17
  csrrci x25,    0x340, 0x18
  csrrsi x25,    0x340, 0x18
  csrrwi x25,    0x340, 0x18
  csrrci x25,    0x340, 0x19
  csrrsi x25,    0x340, 0x19
  csrrwi x25,    0x340, 0x19
  csrrci x25,    0x340, 0x1a
  csrrsi x25,    0x340, 0x1a
  csrrwi x25,    0x340, 0x1a
  csrrci x25,    0x340, 0x1b
  csrrsi x25,    0x340, 0x1b
  csrrwi x25,    0x340, 0x1b
  csrrci x25,    0x340, 0x1c
  csrrsi x25,    0x340, 0x1c
  csrrwi x25,    0x340, 0x1c
  csrrci x25,    0x340, 0x1d
  csrrsi x25,    0x340, 0x1d
  csrrwi x25,    0x340, 0x1d
  csrrci x25,    0x340, 0x1e
  csrrsi x25,    0x340, 0x1e
  csrrwi x25,    0x340, 0x1e
  csrrci x25,    0x340, 0x1f
  csrrsi x25,    0x340, 0x1f
  csrrwi x25,    0x340, 0x1f

  csrrci x26,    0x340, 0x0
  csrrsi x26,    0x340, 0x0
  csrrwi x26,    0x340, 0x0
  csrrci x26,    0x340, 0x1
  csrrsi x26,    0x340, 0x1
  csrrwi x26,    0x340, 0x1
  csrrci x26,    0x340, 0x2
  csrrsi x26,    0x340, 0x2
  csrrwi x26,    0x340, 0x2
  csrrci x26,    0x340, 0x3
  csrrsi x26,    0x340, 0x3
  csrrwi x26,    0x340, 0x3
  csrrci x26,    0x340, 0x4
  csrrsi x26,    0x340, 0x4
  csrrwi x26,    0x340, 0x4
  csrrci x26,    0x340, 0x5
  csrrsi x26,    0x340, 0x5
  csrrwi x26,    0x340, 0x5
  csrrci x26,    0x340, 0x6
  csrrsi x26,    0x340, 0x6
  csrrwi x26,    0x340, 0x6
  csrrci x26,    0x340, 0x7
  csrrsi x26,    0x340, 0x7
  csrrwi x26,    0x340, 0x7
  csrrci x26,    0x340, 0x8
  csrrsi x26,    0x340, 0x8
  csrrwi x26,    0x340, 0x8
  csrrci x26,    0x340, 0x9
  csrrsi x26,    0x340, 0x9
  csrrwi x26,    0x340, 0x9
  csrrci x26,    0x340, 0xa
  csrrsi x26,    0x340, 0xa
  csrrwi x26,    0x340, 0xa
  csrrci x26,    0x340, 0xb
  csrrsi x26,    0x340, 0xb
  csrrwi x26,    0x340, 0xb
  csrrci x26,    0x340, 0xc
  csrrsi x26,    0x340, 0xc
  csrrwi x26,    0x340, 0xc
  csrrci x26,    0x340, 0xd
  csrrsi x26,    0x340, 0xd
  csrrwi x26,    0x340, 0xd
  csrrci x26,    0x340, 0xe
  csrrsi x26,    0x340, 0xe
  csrrwi x26,    0x340, 0xe
  csrrci x26,    0x340, 0xf
  csrrsi x26,    0x340, 0xf
  csrrwi x26,    0x340, 0xf
  csrrci x26,    0x340, 0x10
  csrrsi x26,    0x340, 0x10
  csrrwi x26,    0x340, 0x10
  csrrci x26,    0x340, 0x11
  csrrsi x26,    0x340, 0x11
  csrrwi x26,    0x340, 0x11
  csrrci x26,    0x340, 0x12
  csrrsi x26,    0x340, 0x12
  csrrwi x26,    0x340, 0x12
  csrrci x26,    0x340, 0x13
  csrrsi x26,    0x340, 0x13
  csrrwi x26,    0x340, 0x13
  csrrci x26,    0x340, 0x14
  csrrsi x26,    0x340, 0x14
  csrrwi x26,    0x340, 0x14
  csrrci x26,    0x340, 0x15
  csrrsi x26,    0x340, 0x15
  csrrwi x26,    0x340, 0x15
  csrrci x26,    0x340, 0x16
  csrrsi x26,    0x340, 0x16
  csrrwi x26,    0x340, 0x16
  csrrci x26,    0x340, 0x17
  csrrsi x26,    0x340, 0x17
  csrrwi x26,    0x340, 0x17
  csrrci x26,    0x340, 0x18
  csrrsi x26,    0x340, 0x18
  csrrwi x26,    0x340, 0x18
  csrrci x26,    0x340, 0x19
  csrrsi x26,    0x340, 0x19
  csrrwi x26,    0x340, 0x19
  csrrci x26,    0x340, 0x1a
  csrrsi x26,    0x340, 0x1a
  csrrwi x26,    0x340, 0x1a
  csrrci x26,    0x340, 0x1b
  csrrsi x26,    0x340, 0x1b
  csrrwi x26,    0x340, 0x1b
  csrrci x26,    0x340, 0x1c
  csrrsi x26,    0x340, 0x1c
  csrrwi x26,    0x340, 0x1c
  csrrci x26,    0x340, 0x1d
  csrrsi x26,    0x340, 0x1d
  csrrwi x26,    0x340, 0x1d
  csrrci x26,    0x340, 0x1e
  csrrsi x26,    0x340, 0x1e
  csrrwi x26,    0x340, 0x1e
  csrrci x26,    0x340, 0x1f
  csrrsi x26,    0x340, 0x1f
  csrrwi x26,    0x340, 0x1f

  csrrci x27,    0x340, 0x0
  csrrsi x27,    0x340, 0x0
  csrrwi x27,    0x340, 0x0
  csrrci x27,    0x340, 0x1
  csrrsi x27,    0x340, 0x1
  csrrwi x27,    0x340, 0x1
  csrrci x27,    0x340, 0x2
  csrrsi x27,    0x340, 0x2
  csrrwi x27,    0x340, 0x2
  csrrci x27,    0x340, 0x3
  csrrsi x27,    0x340, 0x3
  csrrwi x27,    0x340, 0x3
  csrrci x27,    0x340, 0x4
  csrrsi x27,    0x340, 0x4
  csrrwi x27,    0x340, 0x4
  csrrci x27,    0x340, 0x5
  csrrsi x27,    0x340, 0x5
  csrrwi x27,    0x340, 0x5
  csrrci x27,    0x340, 0x6
  csrrsi x27,    0x340, 0x6
  csrrwi x27,    0x340, 0x6
  csrrci x27,    0x340, 0x7
  csrrsi x27,    0x340, 0x7
  csrrwi x27,    0x340, 0x7
  csrrci x27,    0x340, 0x8
  csrrsi x27,    0x340, 0x8
  csrrwi x27,    0x340, 0x8
  csrrci x27,    0x340, 0x9
  csrrsi x27,    0x340, 0x9
  csrrwi x27,    0x340, 0x9
  csrrci x27,    0x340, 0xa
  csrrsi x27,    0x340, 0xa
  csrrwi x27,    0x340, 0xa
  csrrci x27,    0x340, 0xb
  csrrsi x27,    0x340, 0xb
  csrrwi x27,    0x340, 0xb
  csrrci x27,    0x340, 0xc
  csrrsi x27,    0x340, 0xc
  csrrwi x27,    0x340, 0xc
  csrrci x27,    0x340, 0xd
  csrrsi x27,    0x340, 0xd
  csrrwi x27,    0x340, 0xd
  csrrci x27,    0x340, 0xe
  csrrsi x27,    0x340, 0xe
  csrrwi x27,    0x340, 0xe
  csrrci x27,    0x340, 0xf
  csrrsi x27,    0x340, 0xf
  csrrwi x27,    0x340, 0xf
  csrrci x27,    0x340, 0x10
  csrrsi x27,    0x340, 0x10
  csrrwi x27,    0x340, 0x10
  csrrci x27,    0x340, 0x11
  csrrsi x27,    0x340, 0x11
  csrrwi x27,    0x340, 0x11
  csrrci x27,    0x340, 0x12
  csrrsi x27,    0x340, 0x12
  csrrwi x27,    0x340, 0x12
  csrrci x27,    0x340, 0x13
  csrrsi x27,    0x340, 0x13
  csrrwi x27,    0x340, 0x13
  csrrci x27,    0x340, 0x14
  csrrsi x27,    0x340, 0x14
  csrrwi x27,    0x340, 0x14
  csrrci x27,    0x340, 0x15
  csrrsi x27,    0x340, 0x15
  csrrwi x27,    0x340, 0x15
  csrrci x27,    0x340, 0x16
  csrrsi x27,    0x340, 0x16
  csrrwi x27,    0x340, 0x16
  csrrci x27,    0x340, 0x17
  csrrsi x27,    0x340, 0x17
  csrrwi x27,    0x340, 0x17
  csrrci x27,    0x340, 0x18
  csrrsi x27,    0x340, 0x18
  csrrwi x27,    0x340, 0x18
  csrrci x27,    0x340, 0x19
  csrrsi x27,    0x340, 0x19
  csrrwi x27,    0x340, 0x19
  csrrci x27,    0x340, 0x1a
  csrrsi x27,    0x340, 0x1a
  csrrwi x27,    0x340, 0x1a
  csrrci x27,    0x340, 0x1b
  csrrsi x27,    0x340, 0x1b
  csrrwi x27,    0x340, 0x1b
  csrrci x27,    0x340, 0x1c
  csrrsi x27,    0x340, 0x1c
  csrrwi x27,    0x340, 0x1c
  csrrci x27,    0x340, 0x1d
  csrrsi x27,    0x340, 0x1d
  csrrwi x27,    0x340, 0x1d
  csrrci x27,    0x340, 0x1e
  csrrsi x27,    0x340, 0x1e
  csrrwi x27,    0x340, 0x1e
  csrrci x27,    0x340, 0x1f
  csrrsi x27,    0x340, 0x1f
  csrrwi x27,    0x340, 0x1f

  csrrci x28,    0x340, 0x0
  csrrsi x28,    0x340, 0x0
  csrrwi x28,    0x340, 0x0
  csrrci x28,    0x340, 0x1
  csrrsi x28,    0x340, 0x1
  csrrwi x28,    0x340, 0x1
  csrrci x28,    0x340, 0x2
  csrrsi x28,    0x340, 0x2
  csrrwi x28,    0x340, 0x2
  csrrci x28,    0x340, 0x3
  csrrsi x28,    0x340, 0x3
  csrrwi x28,    0x340, 0x3
  csrrci x28,    0x340, 0x4
  csrrsi x28,    0x340, 0x4
  csrrwi x28,    0x340, 0x4
  csrrci x28,    0x340, 0x5
  csrrsi x28,    0x340, 0x5
  csrrwi x28,    0x340, 0x5
  csrrci x28,    0x340, 0x6
  csrrsi x28,    0x340, 0x6
  csrrwi x28,    0x340, 0x6
  csrrci x28,    0x340, 0x7
  csrrsi x28,    0x340, 0x7
  csrrwi x28,    0x340, 0x7
  csrrci x28,    0x340, 0x8
  csrrsi x28,    0x340, 0x8
  csrrwi x28,    0x340, 0x8
  csrrci x28,    0x340, 0x9
  csrrsi x28,    0x340, 0x9
  csrrwi x28,    0x340, 0x9
  csrrci x28,    0x340, 0xa
  csrrsi x28,    0x340, 0xa
  csrrwi x28,    0x340, 0xa
  csrrci x28,    0x340, 0xb
  csrrsi x28,    0x340, 0xb
  csrrwi x28,    0x340, 0xb
  csrrci x28,    0x340, 0xc
  csrrsi x28,    0x340, 0xc
  csrrwi x28,    0x340, 0xc
  csrrci x28,    0x340, 0xd
  csrrsi x28,    0x340, 0xd
  csrrwi x28,    0x340, 0xd
  csrrci x28,    0x340, 0xe
  csrrsi x28,    0x340, 0xe
  csrrwi x28,    0x340, 0xe
  csrrci x28,    0x340, 0xf
  csrrsi x28,    0x340, 0xf
  csrrwi x28,    0x340, 0xf
  csrrci x28,    0x340, 0x10
  csrrsi x28,    0x340, 0x10
  csrrwi x28,    0x340, 0x10
  csrrci x28,    0x340, 0x11
  csrrsi x28,    0x340, 0x11
  csrrwi x28,    0x340, 0x11
  csrrci x28,    0x340, 0x12
  csrrsi x28,    0x340, 0x12
  csrrwi x28,    0x340, 0x12
  csrrci x28,    0x340, 0x13
  csrrsi x28,    0x340, 0x13
  csrrwi x28,    0x340, 0x13
  csrrci x28,    0x340, 0x14
  csrrsi x28,    0x340, 0x14
  csrrwi x28,    0x340, 0x14
  csrrci x28,    0x340, 0x15
  csrrsi x28,    0x340, 0x15
  csrrwi x28,    0x340, 0x15
  csrrci x28,    0x340, 0x16
  csrrsi x28,    0x340, 0x16
  csrrwi x28,    0x340, 0x16
  csrrci x28,    0x340, 0x17
  csrrsi x28,    0x340, 0x17
  csrrwi x28,    0x340, 0x17
  csrrci x28,    0x340, 0x18
  csrrsi x28,    0x340, 0x18
  csrrwi x28,    0x340, 0x18
  csrrci x28,    0x340, 0x19
  csrrsi x28,    0x340, 0x19
  csrrwi x28,    0x340, 0x19
  csrrci x28,    0x340, 0x1a
  csrrsi x28,    0x340, 0x1a
  csrrwi x28,    0x340, 0x1a
  csrrci x28,    0x340, 0x1b
  csrrsi x28,    0x340, 0x1b
  csrrwi x28,    0x340, 0x1b
  csrrci x28,    0x340, 0x1c
  csrrsi x28,    0x340, 0x1c
  csrrwi x28,    0x340, 0x1c
  csrrci x28,    0x340, 0x1d
  csrrsi x28,    0x340, 0x1d
  csrrwi x28,    0x340, 0x1d
  csrrci x28,    0x340, 0x1e
  csrrsi x28,    0x340, 0x1e
  csrrwi x28,    0x340, 0x1e
  csrrci x28,    0x340, 0x1f
  csrrsi x28,    0x340, 0x1f
  csrrwi x28,    0x340, 0x1f

  csrrci x29,    0x340, 0x0
  csrrsi x29,    0x340, 0x0
  csrrwi x29,    0x340, 0x0
  csrrci x29,    0x340, 0x1
  csrrsi x29,    0x340, 0x1
  csrrwi x29,    0x340, 0x1
  csrrci x29,    0x340, 0x2
  csrrsi x29,    0x340, 0x2
  csrrwi x29,    0x340, 0x2
  csrrci x29,    0x340, 0x3
  csrrsi x29,    0x340, 0x3
  csrrwi x29,    0x340, 0x3
  csrrci x29,    0x340, 0x4
  csrrsi x29,    0x340, 0x4
  csrrwi x29,    0x340, 0x4
  csrrci x29,    0x340, 0x5
  csrrsi x29,    0x340, 0x5
  csrrwi x29,    0x340, 0x5
  csrrci x29,    0x340, 0x6
  csrrsi x29,    0x340, 0x6
  csrrwi x29,    0x340, 0x6
  csrrci x29,    0x340, 0x7
  csrrsi x29,    0x340, 0x7
  csrrwi x29,    0x340, 0x7
  csrrci x29,    0x340, 0x8
  csrrsi x29,    0x340, 0x8
  csrrwi x29,    0x340, 0x8
  csrrci x29,    0x340, 0x9
  csrrsi x29,    0x340, 0x9
  csrrwi x29,    0x340, 0x9
  csrrci x29,    0x340, 0xa
  csrrsi x29,    0x340, 0xa
  csrrwi x29,    0x340, 0xa
  csrrci x29,    0x340, 0xb
  csrrsi x29,    0x340, 0xb
  csrrwi x29,    0x340, 0xb
  csrrci x29,    0x340, 0xc
  csrrsi x29,    0x340, 0xc
  csrrwi x29,    0x340, 0xc
  csrrci x29,    0x340, 0xd
  csrrsi x29,    0x340, 0xd
  csrrwi x29,    0x340, 0xd
  csrrci x29,    0x340, 0xe
  csrrsi x29,    0x340, 0xe
  csrrwi x29,    0x340, 0xe
  csrrci x29,    0x340, 0xf
  csrrsi x29,    0x340, 0xf
  csrrwi x29,    0x340, 0xf
  csrrci x29,    0x340, 0x10
  csrrsi x29,    0x340, 0x10
  csrrwi x29,    0x340, 0x10
  csrrci x29,    0x340, 0x11
  csrrsi x29,    0x340, 0x11
  csrrwi x29,    0x340, 0x11
  csrrci x29,    0x340, 0x12
  csrrsi x29,    0x340, 0x12
  csrrwi x29,    0x340, 0x12
  csrrci x29,    0x340, 0x13
  csrrsi x29,    0x340, 0x13
  csrrwi x29,    0x340, 0x13
  csrrci x29,    0x340, 0x14
  csrrsi x29,    0x340, 0x14
  csrrwi x29,    0x340, 0x14
  csrrci x29,    0x340, 0x15
  csrrsi x29,    0x340, 0x15
  csrrwi x29,    0x340, 0x15
  csrrci x29,    0x340, 0x16
  csrrsi x29,    0x340, 0x16
  csrrwi x29,    0x340, 0x16
  csrrci x29,    0x340, 0x17
  csrrsi x29,    0x340, 0x17
  csrrwi x29,    0x340, 0x17
  csrrci x29,    0x340, 0x18
  csrrsi x29,    0x340, 0x18
  csrrwi x29,    0x340, 0x18
  csrrci x29,    0x340, 0x19
  csrrsi x29,    0x340, 0x19
  csrrwi x29,    0x340, 0x19
  csrrci x29,    0x340, 0x1a
  csrrsi x29,    0x340, 0x1a
  csrrwi x29,    0x340, 0x1a
  csrrci x29,    0x340, 0x1b
  csrrsi x29,    0x340, 0x1b
  csrrwi x29,    0x340, 0x1b
  csrrci x29,    0x340, 0x1c
  csrrsi x29,    0x340, 0x1c
  csrrwi x29,    0x340, 0x1c
  csrrci x29,    0x340, 0x1d
  csrrsi x29,    0x340, 0x1d
  csrrwi x29,    0x340, 0x1d
  csrrci x29,    0x340, 0x1e
  csrrsi x29,    0x340, 0x1e
  csrrwi x29,    0x340, 0x1e
  csrrci x29,    0x340, 0x1f
  csrrsi x29,    0x340, 0x1f
  csrrwi x29,    0x340, 0x1f

  csrrci x30,    0x340, 0x0
  csrrsi x30,    0x340, 0x0
  csrrwi x30,    0x340, 0x0
  csrrci x30,    0x340, 0x1
  csrrsi x30,    0x340, 0x1
  csrrwi x30,    0x340, 0x1
  csrrci x30,    0x340, 0x2
  csrrsi x30,    0x340, 0x2
  csrrwi x30,    0x340, 0x2
  csrrci x30,    0x340, 0x3
  csrrsi x30,    0x340, 0x3
  csrrwi x30,    0x340, 0x3
  csrrci x30,    0x340, 0x4
  csrrsi x30,    0x340, 0x4
  csrrwi x30,    0x340, 0x4
  csrrci x30,    0x340, 0x5
  csrrsi x30,    0x340, 0x5
  csrrwi x30,    0x340, 0x5
  csrrci x30,    0x340, 0x6
  csrrsi x30,    0x340, 0x6
  csrrwi x30,    0x340, 0x6
  csrrci x30,    0x340, 0x7
  csrrsi x30,    0x340, 0x7
  csrrwi x30,    0x340, 0x7
  csrrci x30,    0x340, 0x8
  csrrsi x30,    0x340, 0x8
  csrrwi x30,    0x340, 0x8
  csrrci x30,    0x340, 0x9
  csrrsi x30,    0x340, 0x9
  csrrwi x30,    0x340, 0x9
  csrrci x30,    0x340, 0xa
  csrrsi x30,    0x340, 0xa
  csrrwi x30,    0x340, 0xa
  csrrci x30,    0x340, 0xb
  csrrsi x30,    0x340, 0xb
  csrrwi x30,    0x340, 0xb
  csrrci x30,    0x340, 0xc
  csrrsi x30,    0x340, 0xc
  csrrwi x30,    0x340, 0xc
  csrrci x30,    0x340, 0xd
  csrrsi x30,    0x340, 0xd
  csrrwi x30,    0x340, 0xd
  csrrci x30,    0x340, 0xe
  csrrsi x30,    0x340, 0xe
  csrrwi x30,    0x340, 0xe
  csrrci x30,    0x340, 0xf
  csrrsi x30,    0x340, 0xf
  csrrwi x30,    0x340, 0xf
  csrrci x30,    0x340, 0x10
  csrrsi x30,    0x340, 0x10
  csrrwi x30,    0x340, 0x10
  csrrci x30,    0x340, 0x11
  csrrsi x30,    0x340, 0x11
  csrrwi x30,    0x340, 0x11
  csrrci x30,    0x340, 0x12
  csrrsi x30,    0x340, 0x12
  csrrwi x30,    0x340, 0x12
  csrrci x30,    0x340, 0x13
  csrrsi x30,    0x340, 0x13
  csrrwi x30,    0x340, 0x13
  csrrci x30,    0x340, 0x14
  csrrsi x30,    0x340, 0x14
  csrrwi x30,    0x340, 0x14
  csrrci x30,    0x340, 0x15
  csrrsi x30,    0x340, 0x15
  csrrwi x30,    0x340, 0x15
  csrrci x30,    0x340, 0x16
  csrrsi x30,    0x340, 0x16
  csrrwi x30,    0x340, 0x16
  csrrci x30,    0x340, 0x17
  csrrsi x30,    0x340, 0x17
  csrrwi x30,    0x340, 0x17
  csrrci x30,    0x340, 0x18
  csrrsi x30,    0x340, 0x18
  csrrwi x30,    0x340, 0x18
  csrrci x30,    0x340, 0x19
  csrrsi x30,    0x340, 0x19
  csrrwi x30,    0x340, 0x19
  csrrci x30,    0x340, 0x1a
  csrrsi x30,    0x340, 0x1a
  csrrwi x30,    0x340, 0x1a
  csrrci x30,    0x340, 0x1b
  csrrsi x30,    0x340, 0x1b
  csrrwi x30,    0x340, 0x1b
  csrrci x30,    0x340, 0x1c
  csrrsi x30,    0x340, 0x1c
  csrrwi x30,    0x340, 0x1c
  csrrci x30,    0x340, 0x1d
  csrrsi x30,    0x340, 0x1d
  csrrwi x30,    0x340, 0x1d
  csrrci x30,    0x340, 0x1e
  csrrsi x30,    0x340, 0x1e
  csrrwi x30,    0x340, 0x1e
  csrrci x30,    0x340, 0x1f
  csrrsi x30,    0x340, 0x1f
  csrrwi x30,    0x340, 0x1f

  csrrci x31,    0x340, 0x0
  csrrsi x31,    0x340, 0x0
  csrrwi x31,    0x340, 0x0
  csrrci x31,    0x340, 0x1
  csrrsi x31,    0x340, 0x1
  csrrwi x31,    0x340, 0x1
  csrrci x31,    0x340, 0x2
  csrrsi x31,    0x340, 0x2
  csrrwi x31,    0x340, 0x2
  csrrci x31,    0x340, 0x3
  csrrsi x31,    0x340, 0x3
  csrrwi x31,    0x340, 0x3
  csrrci x31,    0x340, 0x4
  csrrsi x31,    0x340, 0x4
  csrrwi x31,    0x340, 0x4
  csrrci x31,    0x340, 0x5
  csrrsi x31,    0x340, 0x5
  csrrwi x31,    0x340, 0x5
  csrrci x31,    0x340, 0x6
  csrrsi x31,    0x340, 0x6
  csrrwi x31,    0x340, 0x6
  csrrci x31,    0x340, 0x7
  csrrsi x31,    0x340, 0x7
  csrrwi x31,    0x340, 0x7
  csrrci x31,    0x340, 0x8
  csrrsi x31,    0x340, 0x8
  csrrwi x31,    0x340, 0x8
  csrrci x31,    0x340, 0x9
  csrrsi x31,    0x340, 0x9
  csrrwi x31,    0x340, 0x9
  csrrci x31,    0x340, 0xa
  csrrsi x31,    0x340, 0xa
  csrrwi x31,    0x340, 0xa
  csrrci x31,    0x340, 0xb
  csrrsi x31,    0x340, 0xb
  csrrwi x31,    0x340, 0xb
  csrrci x31,    0x340, 0xc
  csrrsi x31,    0x340, 0xc
  csrrwi x31,    0x340, 0xc
  csrrci x31,    0x340, 0xd
  csrrsi x31,    0x340, 0xd
  csrrwi x31,    0x340, 0xd
  csrrci x31,    0x340, 0xe
  csrrsi x31,    0x340, 0xe
  csrrwi x31,    0x340, 0xe
  csrrci x31,    0x340, 0xf
  csrrsi x31,    0x340, 0xf
  csrrwi x31,    0x340, 0xf
  csrrci x31,    0x340, 0x10
  csrrsi x31,    0x340, 0x10
  csrrwi x31,    0x340, 0x10
  csrrci x31,    0x340, 0x11
  csrrsi x31,    0x340, 0x11
  csrrwi x31,    0x340, 0x11
  csrrci x31,    0x340, 0x12
  csrrsi x31,    0x340, 0x12
  csrrwi x31,    0x340, 0x12
  csrrci x31,    0x340, 0x13
  csrrsi x31,    0x340, 0x13
  csrrwi x31,    0x340, 0x13
  csrrci x31,    0x340, 0x14
  csrrsi x31,    0x340, 0x14
  csrrwi x31,    0x340, 0x14
  csrrci x31,    0x340, 0x15
  csrrsi x31,    0x340, 0x15
  csrrwi x31,    0x340, 0x15
  csrrci x31,    0x340, 0x16
  csrrsi x31,    0x340, 0x16
  csrrwi x31,    0x340, 0x16
  csrrci x31,    0x340, 0x17
  csrrsi x31,    0x340, 0x17
  csrrwi x31,    0x340, 0x17
  csrrci x31,    0x340, 0x18
  csrrsi x31,    0x340, 0x18
  csrrwi x31,    0x340, 0x18
  csrrci x31,    0x340, 0x19
  csrrsi x31,    0x340, 0x19
  csrrwi x31,    0x340, 0x19
  csrrci x31,    0x340, 0x1a
  csrrsi x31,    0x340, 0x1a
  csrrwi x31,    0x340, 0x1a
  csrrci x31,    0x340, 0x1b
  csrrsi x31,    0x340, 0x1b
  csrrwi x31,    0x340, 0x1b
  csrrci x31,    0x340, 0x1c
  csrrsi x31,    0x340, 0x1c
  csrrwi x31,    0x340, 0x1c
  csrrci x31,    0x340, 0x1d
  csrrsi x31,    0x340, 0x1d
  csrrwi x31,    0x340, 0x1d
  csrrci x31,    0x340, 0x1e
  csrrsi x31,    0x340, 0x1e
  csrrwi x31,    0x340, 0x1e
  csrrci x31,    0x340, 0x1f
  csrrsi x31,    0x340, 0x1f
  csrrwi x31,    0x340, 0x1f



  # Non-immediates
  csrrc  x0,    0x340, x0
  csrrs  x0,    0x340, x0
  csrrw  x0,    0x340, x0
  csrrc  x0,    0x340, x1
  csrrs  x0,    0x340, x1
  csrrw  x0,    0x340, x1
  csrrc  x0,    0x340, x2
  csrrs  x0,    0x340, x2
  csrrw  x0,    0x340, x2
  csrrc  x0,    0x340, x3
  csrrs  x0,    0x340, x3
  csrrw  x0,    0x340, x3
  csrrc  x0,    0x340, x4
  csrrs  x0,    0x340, x4
  csrrw  x0,    0x340, x4
  csrrc  x0,    0x340, x5
  csrrs  x0,    0x340, x5
  csrrw  x0,    0x340, x5
  csrrc  x0,    0x340, x6
  csrrs  x0,    0x340, x6
  csrrw  x0,    0x340, x6
  csrrc  x0,    0x340, x7
  csrrs  x0,    0x340, x7
  csrrw  x0,    0x340, x7
  csrrc  x0,    0x340, x8
  csrrs  x0,    0x340, x8
  csrrw  x0,    0x340, x8
  csrrc  x0,    0x340, x9
  csrrs  x0,    0x340, x9
  csrrw  x0,    0x340, x9
  csrrc  x0,    0x340, x10
  csrrs  x0,    0x340, x10
  csrrw  x0,    0x340, x10
  csrrc  x0,    0x340, x11
  csrrs  x0,    0x340, x11
  csrrw  x0,    0x340, x11
  csrrc  x0,    0x340, x12
  csrrs  x0,    0x340, x12
  csrrw  x0,    0x340, x12
  csrrc  x0,    0x340, x13
  csrrs  x0,    0x340, x13
  csrrw  x0,    0x340, x13
  csrrc  x0,    0x340, x14
  csrrs  x0,    0x340, x14
  csrrw  x0,    0x340, x14
  csrrc  x0,    0x340, x15
  csrrs  x0,    0x340, x15
  csrrw  x0,    0x340, x15
  csrrc  x0,    0x340, x16
  csrrs  x0,    0x340, x16
  csrrw  x0,    0x340, x16
  csrrc  x0,    0x340, x17
  csrrs  x0,    0x340, x17
  csrrw  x0,    0x340, x17
  csrrc  x0,    0x340, x18
  csrrs  x0,    0x340, x18
  csrrw  x0,    0x340, x18
  csrrc  x0,    0x340, x19
  csrrs  x0,    0x340, x19
  csrrw  x0,    0x340, x19
  csrrc  x0,    0x340, x20
  csrrs  x0,    0x340, x20
  csrrw  x0,    0x340, x20
  csrrc  x0,    0x340, x21
  csrrs  x0,    0x340, x21
  csrrw  x0,    0x340, x21
  csrrc  x0,    0x340, x22
  csrrs  x0,    0x340, x22
  csrrw  x0,    0x340, x22
  csrrc  x0,    0x340, x23
  csrrs  x0,    0x340, x23
  csrrw  x0,    0x340, x23
  csrrc  x0,    0x340, x24
  csrrs  x0,    0x340, x24
  csrrw  x0,    0x340, x24
  csrrc  x0,    0x340, x25
  csrrs  x0,    0x340, x25
  csrrw  x0,    0x340, x25
  csrrc  x0,    0x340, x26
  csrrs  x0,    0x340, x26
  csrrw  x0,    0x340, x26
  csrrc  x0,    0x340, x27
  csrrs  x0,    0x340, x27
  csrrw  x0,    0x340, x27
  csrrc  x0,    0x340, x28
  csrrs  x0,    0x340, x28
  csrrw  x0,    0x340, x28
  csrrc  x0,    0x340, x29
  csrrs  x0,    0x340, x29
  csrrw  x0,    0x340, x29
  csrrc  x0,    0x340, x30
  csrrs  x0,    0x340, x30
  csrrw  x0,    0x340, x30
  csrrc  x0,    0x340, x31
  csrrs  x0,    0x340, x31
  csrrw  x0,    0x340, x31

  csrrc  x1,    0x340, x0
  csrrs  x1,    0x340, x0
  csrrw  x1,    0x340, x0
  csrrc  x1,    0x340, x1
  csrrs  x1,    0x340, x1
  csrrw  x1,    0x340, x1
  csrrc  x1,    0x340, x2
  csrrs  x1,    0x340, x2
  csrrw  x1,    0x340, x2
  csrrc  x1,    0x340, x3
  csrrs  x1,    0x340, x3
  csrrw  x1,    0x340, x3
  csrrc  x1,    0x340, x4
  csrrs  x1,    0x340, x4
  csrrw  x1,    0x340, x4
  csrrc  x1,    0x340, x5
  csrrs  x1,    0x340, x5
  csrrw  x1,    0x340, x5
  csrrc  x1,    0x340, x6
  csrrs  x1,    0x340, x6
  csrrw  x1,    0x340, x6
  csrrc  x1,    0x340, x7
  csrrs  x1,    0x340, x7
  csrrw  x1,    0x340, x7
  csrrc  x1,    0x340, x8
  csrrs  x1,    0x340, x8
  csrrw  x1,    0x340, x8
  csrrc  x1,    0x340, x9
  csrrs  x1,    0x340, x9
  csrrw  x1,    0x340, x9
  csrrc  x1,    0x340, x10
  csrrs  x1,    0x340, x10
  csrrw  x1,    0x340, x10
  csrrc  x1,    0x340, x11
  csrrs  x1,    0x340, x11
  csrrw  x1,    0x340, x11
  csrrc  x1,    0x340, x12
  csrrs  x1,    0x340, x12
  csrrw  x1,    0x340, x12
  csrrc  x1,    0x340, x13
  csrrs  x1,    0x340, x13
  csrrw  x1,    0x340, x13
  csrrc  x1,    0x340, x14
  csrrs  x1,    0x340, x14
  csrrw  x1,    0x340, x14
  csrrc  x1,    0x340, x15
  csrrs  x1,    0x340, x15
  csrrw  x1,    0x340, x15
  csrrc  x1,    0x340, x16
  csrrs  x1,    0x340, x16
  csrrw  x1,    0x340, x16
  csrrc  x1,    0x340, x17
  csrrs  x1,    0x340, x17
  csrrw  x1,    0x340, x17
  csrrc  x1,    0x340, x18
  csrrs  x1,    0x340, x18
  csrrw  x1,    0x340, x18
  csrrc  x1,    0x340, x19
  csrrs  x1,    0x340, x19
  csrrw  x1,    0x340, x19
  csrrc  x1,    0x340, x20
  csrrs  x1,    0x340, x20
  csrrw  x1,    0x340, x20
  csrrc  x1,    0x340, x21
  csrrs  x1,    0x340, x21
  csrrw  x1,    0x340, x21
  csrrc  x1,    0x340, x22
  csrrs  x1,    0x340, x22
  csrrw  x1,    0x340, x22
  csrrc  x1,    0x340, x23
  csrrs  x1,    0x340, x23
  csrrw  x1,    0x340, x23
  csrrc  x1,    0x340, x24
  csrrs  x1,    0x340, x24
  csrrw  x1,    0x340, x24
  csrrc  x1,    0x340, x25
  csrrs  x1,    0x340, x25
  csrrw  x1,    0x340, x25
  csrrc  x1,    0x340, x26
  csrrs  x1,    0x340, x26
  csrrw  x1,    0x340, x26
  csrrc  x1,    0x340, x27
  csrrs  x1,    0x340, x27
  csrrw  x1,    0x340, x27
  csrrc  x1,    0x340, x28
  csrrs  x1,    0x340, x28
  csrrw  x1,    0x340, x28
  csrrc  x1,    0x340, x29
  csrrs  x1,    0x340, x29
  csrrw  x1,    0x340, x29
  csrrc  x1,    0x340, x30
  csrrs  x1,    0x340, x30
  csrrw  x1,    0x340, x30
  csrrc  x1,    0x340, x31
  csrrs  x1,    0x340, x31
  csrrw  x1,    0x340, x31

  csrrc  x2,    0x340, x0
  csrrs  x2,    0x340, x0
  csrrw  x2,    0x340, x0
  csrrc  x2,    0x340, x1
  csrrs  x2,    0x340, x1
  csrrw  x2,    0x340, x1
  csrrc  x2,    0x340, x2
  csrrs  x2,    0x340, x2
  csrrw  x2,    0x340, x2
  csrrc  x2,    0x340, x3
  csrrs  x2,    0x340, x3
  csrrw  x2,    0x340, x3
  csrrc  x2,    0x340, x4
  csrrs  x2,    0x340, x4
  csrrw  x2,    0x340, x4
  csrrc  x2,    0x340, x5
  csrrs  x2,    0x340, x5
  csrrw  x2,    0x340, x5
  csrrc  x2,    0x340, x6
  csrrs  x2,    0x340, x6
  csrrw  x2,    0x340, x6
  csrrc  x2,    0x340, x7
  csrrs  x2,    0x340, x7
  csrrw  x2,    0x340, x7
  csrrc  x2,    0x340, x8
  csrrs  x2,    0x340, x8
  csrrw  x2,    0x340, x8
  csrrc  x2,    0x340, x9
  csrrs  x2,    0x340, x9
  csrrw  x2,    0x340, x9
  csrrc  x2,    0x340, x10
  csrrs  x2,    0x340, x10
  csrrw  x2,    0x340, x10
  csrrc  x2,    0x340, x11
  csrrs  x2,    0x340, x11
  csrrw  x2,    0x340, x11
  csrrc  x2,    0x340, x12
  csrrs  x2,    0x340, x12
  csrrw  x2,    0x340, x12
  csrrc  x2,    0x340, x13
  csrrs  x2,    0x340, x13
  csrrw  x2,    0x340, x13
  csrrc  x2,    0x340, x14
  csrrs  x2,    0x340, x14
  csrrw  x2,    0x340, x14
  csrrc  x2,    0x340, x15
  csrrs  x2,    0x340, x15
  csrrw  x2,    0x340, x15
  csrrc  x2,    0x340, x16
  csrrs  x2,    0x340, x16
  csrrw  x2,    0x340, x16
  csrrc  x2,    0x340, x17
  csrrs  x2,    0x340, x17
  csrrw  x2,    0x340, x17
  csrrc  x2,    0x340, x18
  csrrs  x2,    0x340, x18
  csrrw  x2,    0x340, x18
  csrrc  x2,    0x340, x19
  csrrs  x2,    0x340, x19
  csrrw  x2,    0x340, x19
  csrrc  x2,    0x340, x20
  csrrs  x2,    0x340, x20
  csrrw  x2,    0x340, x20
  csrrc  x2,    0x340, x21
  csrrs  x2,    0x340, x21
  csrrw  x2,    0x340, x21
  csrrc  x2,    0x340, x22
  csrrs  x2,    0x340, x22
  csrrw  x2,    0x340, x22
  csrrc  x2,    0x340, x23
  csrrs  x2,    0x340, x23
  csrrw  x2,    0x340, x23
  csrrc  x2,    0x340, x24
  csrrs  x2,    0x340, x24
  csrrw  x2,    0x340, x24
  csrrc  x2,    0x340, x25
  csrrs  x2,    0x340, x25
  csrrw  x2,    0x340, x25
  csrrc  x2,    0x340, x26
  csrrs  x2,    0x340, x26
  csrrw  x2,    0x340, x26
  csrrc  x2,    0x340, x27
  csrrs  x2,    0x340, x27
  csrrw  x2,    0x340, x27
  csrrc  x2,    0x340, x28
  csrrs  x2,    0x340, x28
  csrrw  x2,    0x340, x28
  csrrc  x2,    0x340, x29
  csrrs  x2,    0x340, x29
  csrrw  x2,    0x340, x29
  csrrc  x2,    0x340, x30
  csrrs  x2,    0x340, x30
  csrrw  x2,    0x340, x30
  csrrc  x2,    0x340, x31
  csrrs  x2,    0x340, x31
  csrrw  x2,    0x340, x31

  csrrc  x3,    0x340, x0
  csrrs  x3,    0x340, x0
  csrrw  x3,    0x340, x0
  csrrc  x3,    0x340, x1
  csrrs  x3,    0x340, x1
  csrrw  x3,    0x340, x1
  csrrc  x3,    0x340, x2
  csrrs  x3,    0x340, x2
  csrrw  x3,    0x340, x2
  csrrc  x3,    0x340, x3
  csrrs  x3,    0x340, x3
  csrrw  x3,    0x340, x3
  csrrc  x3,    0x340, x4
  csrrs  x3,    0x340, x4
  csrrw  x3,    0x340, x4
  csrrc  x3,    0x340, x5
  csrrs  x3,    0x340, x5
  csrrw  x3,    0x340, x5
  csrrc  x3,    0x340, x6
  csrrs  x3,    0x340, x6
  csrrw  x3,    0x340, x6
  csrrc  x3,    0x340, x7
  csrrs  x3,    0x340, x7
  csrrw  x3,    0x340, x7
  csrrc  x3,    0x340, x8
  csrrs  x3,    0x340, x8
  csrrw  x3,    0x340, x8
  csrrc  x3,    0x340, x9
  csrrs  x3,    0x340, x9
  csrrw  x3,    0x340, x9
  csrrc  x3,    0x340, x10
  csrrs  x3,    0x340, x10
  csrrw  x3,    0x340, x10
  csrrc  x3,    0x340, x11
  csrrs  x3,    0x340, x11
  csrrw  x3,    0x340, x11
  csrrc  x3,    0x340, x12
  csrrs  x3,    0x340, x12
  csrrw  x3,    0x340, x12
  csrrc  x3,    0x340, x13
  csrrs  x3,    0x340, x13
  csrrw  x3,    0x340, x13
  csrrc  x3,    0x340, x14
  csrrs  x3,    0x340, x14
  csrrw  x3,    0x340, x14
  csrrc  x3,    0x340, x15
  csrrs  x3,    0x340, x15
  csrrw  x3,    0x340, x15
  csrrc  x3,    0x340, x16
  csrrs  x3,    0x340, x16
  csrrw  x3,    0x340, x16
  csrrc  x3,    0x340, x17
  csrrs  x3,    0x340, x17
  csrrw  x3,    0x340, x17
  csrrc  x3,    0x340, x18
  csrrs  x3,    0x340, x18
  csrrw  x3,    0x340, x18
  csrrc  x3,    0x340, x19
  csrrs  x3,    0x340, x19
  csrrw  x3,    0x340, x19
  csrrc  x3,    0x340, x20
  csrrs  x3,    0x340, x20
  csrrw  x3,    0x340, x20
  csrrc  x3,    0x340, x21
  csrrs  x3,    0x340, x21
  csrrw  x3,    0x340, x21
  csrrc  x3,    0x340, x22
  csrrs  x3,    0x340, x22
  csrrw  x3,    0x340, x22
  csrrc  x3,    0x340, x23
  csrrs  x3,    0x340, x23
  csrrw  x3,    0x340, x23
  csrrc  x3,    0x340, x24
  csrrs  x3,    0x340, x24
  csrrw  x3,    0x340, x24
  csrrc  x3,    0x340, x25
  csrrs  x3,    0x340, x25
  csrrw  x3,    0x340, x25
  csrrc  x3,    0x340, x26
  csrrs  x3,    0x340, x26
  csrrw  x3,    0x340, x26
  csrrc  x3,    0x340, x27
  csrrs  x3,    0x340, x27
  csrrw  x3,    0x340, x27
  csrrc  x3,    0x340, x28
  csrrs  x3,    0x340, x28
  csrrw  x3,    0x340, x28
  csrrc  x3,    0x340, x29
  csrrs  x3,    0x340, x29
  csrrw  x3,    0x340, x29
  csrrc  x3,    0x340, x30
  csrrs  x3,    0x340, x30
  csrrw  x3,    0x340, x30
  csrrc  x3,    0x340, x31
  csrrs  x3,    0x340, x31
  csrrw  x3,    0x340, x31

  csrrc  x4,    0x340, x0
  csrrs  x4,    0x340, x0
  csrrw  x4,    0x340, x0
  csrrc  x4,    0x340, x1
  csrrs  x4,    0x340, x1
  csrrw  x4,    0x340, x1
  csrrc  x4,    0x340, x2
  csrrs  x4,    0x340, x2
  csrrw  x4,    0x340, x2
  csrrc  x4,    0x340, x3
  csrrs  x4,    0x340, x3
  csrrw  x4,    0x340, x3
  csrrc  x4,    0x340, x4
  csrrs  x4,    0x340, x4
  csrrw  x4,    0x340, x4
  csrrc  x4,    0x340, x5
  csrrs  x4,    0x340, x5
  csrrw  x4,    0x340, x5
  csrrc  x4,    0x340, x6
  csrrs  x4,    0x340, x6
  csrrw  x4,    0x340, x6
  csrrc  x4,    0x340, x7
  csrrs  x4,    0x340, x7
  csrrw  x4,    0x340, x7
  csrrc  x4,    0x340, x8
  csrrs  x4,    0x340, x8
  csrrw  x4,    0x340, x8
  csrrc  x4,    0x340, x9
  csrrs  x4,    0x340, x9
  csrrw  x4,    0x340, x9
  csrrc  x4,    0x340, x10
  csrrs  x4,    0x340, x10
  csrrw  x4,    0x340, x10
  csrrc  x4,    0x340, x11
  csrrs  x4,    0x340, x11
  csrrw  x4,    0x340, x11
  csrrc  x4,    0x340, x12
  csrrs  x4,    0x340, x12
  csrrw  x4,    0x340, x12
  csrrc  x4,    0x340, x13
  csrrs  x4,    0x340, x13
  csrrw  x4,    0x340, x13
  csrrc  x4,    0x340, x14
  csrrs  x4,    0x340, x14
  csrrw  x4,    0x340, x14
  csrrc  x4,    0x340, x15
  csrrs  x4,    0x340, x15
  csrrw  x4,    0x340, x15
  csrrc  x4,    0x340, x16
  csrrs  x4,    0x340, x16
  csrrw  x4,    0x340, x16
  csrrc  x4,    0x340, x17
  csrrs  x4,    0x340, x17
  csrrw  x4,    0x340, x17
  csrrc  x4,    0x340, x18
  csrrs  x4,    0x340, x18
  csrrw  x4,    0x340, x18
  csrrc  x4,    0x340, x19
  csrrs  x4,    0x340, x19
  csrrw  x4,    0x340, x19
  csrrc  x4,    0x340, x20
  csrrs  x4,    0x340, x20
  csrrw  x4,    0x340, x20
  csrrc  x4,    0x340, x21
  csrrs  x4,    0x340, x21
  csrrw  x4,    0x340, x21
  csrrc  x4,    0x340, x22
  csrrs  x4,    0x340, x22
  csrrw  x4,    0x340, x22
  csrrc  x4,    0x340, x23
  csrrs  x4,    0x340, x23
  csrrw  x4,    0x340, x23
  csrrc  x4,    0x340, x24
  csrrs  x4,    0x340, x24
  csrrw  x4,    0x340, x24
  csrrc  x4,    0x340, x25
  csrrs  x4,    0x340, x25
  csrrw  x4,    0x340, x25
  csrrc  x4,    0x340, x26
  csrrs  x4,    0x340, x26
  csrrw  x4,    0x340, x26
  csrrc  x4,    0x340, x27
  csrrs  x4,    0x340, x27
  csrrw  x4,    0x340, x27
  csrrc  x4,    0x340, x28
  csrrs  x4,    0x340, x28
  csrrw  x4,    0x340, x28
  csrrc  x4,    0x340, x29
  csrrs  x4,    0x340, x29
  csrrw  x4,    0x340, x29
  csrrc  x4,    0x340, x30
  csrrs  x4,    0x340, x30
  csrrw  x4,    0x340, x30
  csrrc  x4,    0x340, x31
  csrrs  x4,    0x340, x31
  csrrw  x4,    0x340, x31

  csrrc  x5,    0x340, x0
  csrrs  x5,    0x340, x0
  csrrw  x5,    0x340, x0
  csrrc  x5,    0x340, x1
  csrrs  x5,    0x340, x1
  csrrw  x5,    0x340, x1
  csrrc  x5,    0x340, x2
  csrrs  x5,    0x340, x2
  csrrw  x5,    0x340, x2
  csrrc  x5,    0x340, x3
  csrrs  x5,    0x340, x3
  csrrw  x5,    0x340, x3
  csrrc  x5,    0x340, x4
  csrrs  x5,    0x340, x4
  csrrw  x5,    0x340, x4
  csrrc  x5,    0x340, x5
  csrrs  x5,    0x340, x5
  csrrw  x5,    0x340, x5
  csrrc  x5,    0x340, x6
  csrrs  x5,    0x340, x6
  csrrw  x5,    0x340, x6
  csrrc  x5,    0x340, x7
  csrrs  x5,    0x340, x7
  csrrw  x5,    0x340, x7
  csrrc  x5,    0x340, x8
  csrrs  x5,    0x340, x8
  csrrw  x5,    0x340, x8
  csrrc  x5,    0x340, x9
  csrrs  x5,    0x340, x9
  csrrw  x5,    0x340, x9
  csrrc  x5,    0x340, x10
  csrrs  x5,    0x340, x10
  csrrw  x5,    0x340, x10
  csrrc  x5,    0x340, x11
  csrrs  x5,    0x340, x11
  csrrw  x5,    0x340, x11
  csrrc  x5,    0x340, x12
  csrrs  x5,    0x340, x12
  csrrw  x5,    0x340, x12
  csrrc  x5,    0x340, x13
  csrrs  x5,    0x340, x13
  csrrw  x5,    0x340, x13
  csrrc  x5,    0x340, x14
  csrrs  x5,    0x340, x14
  csrrw  x5,    0x340, x14
  csrrc  x5,    0x340, x15
  csrrs  x5,    0x340, x15
  csrrw  x5,    0x340, x15
  csrrc  x5,    0x340, x16
  csrrs  x5,    0x340, x16
  csrrw  x5,    0x340, x16
  csrrc  x5,    0x340, x17
  csrrs  x5,    0x340, x17
  csrrw  x5,    0x340, x17
  csrrc  x5,    0x340, x18
  csrrs  x5,    0x340, x18
  csrrw  x5,    0x340, x18
  csrrc  x5,    0x340, x19
  csrrs  x5,    0x340, x19
  csrrw  x5,    0x340, x19
  csrrc  x5,    0x340, x20
  csrrs  x5,    0x340, x20
  csrrw  x5,    0x340, x20
  csrrc  x5,    0x340, x21
  csrrs  x5,    0x340, x21
  csrrw  x5,    0x340, x21
  csrrc  x5,    0x340, x22
  csrrs  x5,    0x340, x22
  csrrw  x5,    0x340, x22
  csrrc  x5,    0x340, x23
  csrrs  x5,    0x340, x23
  csrrw  x5,    0x340, x23
  csrrc  x5,    0x340, x24
  csrrs  x5,    0x340, x24
  csrrw  x5,    0x340, x24
  csrrc  x5,    0x340, x25
  csrrs  x5,    0x340, x25
  csrrw  x5,    0x340, x25
  csrrc  x5,    0x340, x26
  csrrs  x5,    0x340, x26
  csrrw  x5,    0x340, x26
  csrrc  x5,    0x340, x27
  csrrs  x5,    0x340, x27
  csrrw  x5,    0x340, x27
  csrrc  x5,    0x340, x28
  csrrs  x5,    0x340, x28
  csrrw  x5,    0x340, x28
  csrrc  x5,    0x340, x29
  csrrs  x5,    0x340, x29
  csrrw  x5,    0x340, x29
  csrrc  x5,    0x340, x30
  csrrs  x5,    0x340, x30
  csrrw  x5,    0x340, x30
  csrrc  x5,    0x340, x31
  csrrs  x5,    0x340, x31
  csrrw  x5,    0x340, x31

  csrrc  x6,    0x340, x0
  csrrs  x6,    0x340, x0
  csrrw  x6,    0x340, x0
  csrrc  x6,    0x340, x1
  csrrs  x6,    0x340, x1
  csrrw  x6,    0x340, x1
  csrrc  x6,    0x340, x2
  csrrs  x6,    0x340, x2
  csrrw  x6,    0x340, x2
  csrrc  x6,    0x340, x3
  csrrs  x6,    0x340, x3
  csrrw  x6,    0x340, x3
  csrrc  x6,    0x340, x4
  csrrs  x6,    0x340, x4
  csrrw  x6,    0x340, x4
  csrrc  x6,    0x340, x5
  csrrs  x6,    0x340, x5
  csrrw  x6,    0x340, x5
  csrrc  x6,    0x340, x6
  csrrs  x6,    0x340, x6
  csrrw  x6,    0x340, x6
  csrrc  x6,    0x340, x7
  csrrs  x6,    0x340, x7
  csrrw  x6,    0x340, x7
  csrrc  x6,    0x340, x8
  csrrs  x6,    0x340, x8
  csrrw  x6,    0x340, x8
  csrrc  x6,    0x340, x9
  csrrs  x6,    0x340, x9
  csrrw  x6,    0x340, x9
  csrrc  x6,    0x340, x10
  csrrs  x6,    0x340, x10
  csrrw  x6,    0x340, x10
  csrrc  x6,    0x340, x11
  csrrs  x6,    0x340, x11
  csrrw  x6,    0x340, x11
  csrrc  x6,    0x340, x12
  csrrs  x6,    0x340, x12
  csrrw  x6,    0x340, x12
  csrrc  x6,    0x340, x13
  csrrs  x6,    0x340, x13
  csrrw  x6,    0x340, x13
  csrrc  x6,    0x340, x14
  csrrs  x6,    0x340, x14
  csrrw  x6,    0x340, x14
  csrrc  x6,    0x340, x15
  csrrs  x6,    0x340, x15
  csrrw  x6,    0x340, x15
  csrrc  x6,    0x340, x16
  csrrs  x6,    0x340, x16
  csrrw  x6,    0x340, x16
  csrrc  x6,    0x340, x17
  csrrs  x6,    0x340, x17
  csrrw  x6,    0x340, x17
  csrrc  x6,    0x340, x18
  csrrs  x6,    0x340, x18
  csrrw  x6,    0x340, x18
  csrrc  x6,    0x340, x19
  csrrs  x6,    0x340, x19
  csrrw  x6,    0x340, x19
  csrrc  x6,    0x340, x20
  csrrs  x6,    0x340, x20
  csrrw  x6,    0x340, x20
  csrrc  x6,    0x340, x21
  csrrs  x6,    0x340, x21
  csrrw  x6,    0x340, x21
  csrrc  x6,    0x340, x22
  csrrs  x6,    0x340, x22
  csrrw  x6,    0x340, x22
  csrrc  x6,    0x340, x23
  csrrs  x6,    0x340, x23
  csrrw  x6,    0x340, x23
  csrrc  x6,    0x340, x24
  csrrs  x6,    0x340, x24
  csrrw  x6,    0x340, x24
  csrrc  x6,    0x340, x25
  csrrs  x6,    0x340, x25
  csrrw  x6,    0x340, x25
  csrrc  x6,    0x340, x26
  csrrs  x6,    0x340, x26
  csrrw  x6,    0x340, x26
  csrrc  x6,    0x340, x27
  csrrs  x6,    0x340, x27
  csrrw  x6,    0x340, x27
  csrrc  x6,    0x340, x28
  csrrs  x6,    0x340, x28
  csrrw  x6,    0x340, x28
  csrrc  x6,    0x340, x29
  csrrs  x6,    0x340, x29
  csrrw  x6,    0x340, x29
  csrrc  x6,    0x340, x30
  csrrs  x6,    0x340, x30
  csrrw  x6,    0x340, x30
  csrrc  x6,    0x340, x31
  csrrs  x6,    0x340, x31
  csrrw  x6,    0x340, x31

  csrrc  x7,    0x340, x0
  csrrs  x7,    0x340, x0
  csrrw  x7,    0x340, x0
  csrrc  x7,    0x340, x1
  csrrs  x7,    0x340, x1
  csrrw  x7,    0x340, x1
  csrrc  x7,    0x340, x2
  csrrs  x7,    0x340, x2
  csrrw  x7,    0x340, x2
  csrrc  x7,    0x340, x3
  csrrs  x7,    0x340, x3
  csrrw  x7,    0x340, x3
  csrrc  x7,    0x340, x4
  csrrs  x7,    0x340, x4
  csrrw  x7,    0x340, x4
  csrrc  x7,    0x340, x5
  csrrs  x7,    0x340, x5
  csrrw  x7,    0x340, x5
  csrrc  x7,    0x340, x6
  csrrs  x7,    0x340, x6
  csrrw  x7,    0x340, x6
  csrrc  x7,    0x340, x7
  csrrs  x7,    0x340, x7
  csrrw  x7,    0x340, x7
  csrrc  x7,    0x340, x8
  csrrs  x7,    0x340, x8
  csrrw  x7,    0x340, x8
  csrrc  x7,    0x340, x9
  csrrs  x7,    0x340, x9
  csrrw  x7,    0x340, x9
  csrrc  x7,    0x340, x10
  csrrs  x7,    0x340, x10
  csrrw  x7,    0x340, x10
  csrrc  x7,    0x340, x11
  csrrs  x7,    0x340, x11
  csrrw  x7,    0x340, x11
  csrrc  x7,    0x340, x12
  csrrs  x7,    0x340, x12
  csrrw  x7,    0x340, x12
  csrrc  x7,    0x340, x13
  csrrs  x7,    0x340, x13
  csrrw  x7,    0x340, x13
  csrrc  x7,    0x340, x14
  csrrs  x7,    0x340, x14
  csrrw  x7,    0x340, x14
  csrrc  x7,    0x340, x15
  csrrs  x7,    0x340, x15
  csrrw  x7,    0x340, x15
  csrrc  x7,    0x340, x16
  csrrs  x7,    0x340, x16
  csrrw  x7,    0x340, x16
  csrrc  x7,    0x340, x17
  csrrs  x7,    0x340, x17
  csrrw  x7,    0x340, x17
  csrrc  x7,    0x340, x18
  csrrs  x7,    0x340, x18
  csrrw  x7,    0x340, x18
  csrrc  x7,    0x340, x19
  csrrs  x7,    0x340, x19
  csrrw  x7,    0x340, x19
  csrrc  x7,    0x340, x20
  csrrs  x7,    0x340, x20
  csrrw  x7,    0x340, x20
  csrrc  x7,    0x340, x21
  csrrs  x7,    0x340, x21
  csrrw  x7,    0x340, x21
  csrrc  x7,    0x340, x22
  csrrs  x7,    0x340, x22
  csrrw  x7,    0x340, x22
  csrrc  x7,    0x340, x23
  csrrs  x7,    0x340, x23
  csrrw  x7,    0x340, x23
  csrrc  x7,    0x340, x24
  csrrs  x7,    0x340, x24
  csrrw  x7,    0x340, x24
  csrrc  x7,    0x340, x25
  csrrs  x7,    0x340, x25
  csrrw  x7,    0x340, x25
  csrrc  x7,    0x340, x26
  csrrs  x7,    0x340, x26
  csrrw  x7,    0x340, x26
  csrrc  x7,    0x340, x27
  csrrs  x7,    0x340, x27
  csrrw  x7,    0x340, x27
  csrrc  x7,    0x340, x28
  csrrs  x7,    0x340, x28
  csrrw  x7,    0x340, x28
  csrrc  x7,    0x340, x29
  csrrs  x7,    0x340, x29
  csrrw  x7,    0x340, x29
  csrrc  x7,    0x340, x30
  csrrs  x7,    0x340, x30
  csrrw  x7,    0x340, x30
  csrrc  x7,    0x340, x31
  csrrs  x7,    0x340, x31
  csrrw  x7,    0x340, x31

  csrrc  x8,    0x340, x0
  csrrs  x8,    0x340, x0
  csrrw  x8,    0x340, x0
  csrrc  x8,    0x340, x1
  csrrs  x8,    0x340, x1
  csrrw  x8,    0x340, x1
  csrrc  x8,    0x340, x2
  csrrs  x8,    0x340, x2
  csrrw  x8,    0x340, x2
  csrrc  x8,    0x340, x3
  csrrs  x8,    0x340, x3
  csrrw  x8,    0x340, x3
  csrrc  x8,    0x340, x4
  csrrs  x8,    0x340, x4
  csrrw  x8,    0x340, x4
  csrrc  x8,    0x340, x5
  csrrs  x8,    0x340, x5
  csrrw  x8,    0x340, x5
  csrrc  x8,    0x340, x6
  csrrs  x8,    0x340, x6
  csrrw  x8,    0x340, x6
  csrrc  x8,    0x340, x7
  csrrs  x8,    0x340, x7
  csrrw  x8,    0x340, x7
  csrrc  x8,    0x340, x8
  csrrs  x8,    0x340, x8
  csrrw  x8,    0x340, x8
  csrrc  x8,    0x340, x9
  csrrs  x8,    0x340, x9
  csrrw  x8,    0x340, x9
  csrrc  x8,    0x340, x10
  csrrs  x8,    0x340, x10
  csrrw  x8,    0x340, x10
  csrrc  x8,    0x340, x11
  csrrs  x8,    0x340, x11
  csrrw  x8,    0x340, x11
  csrrc  x8,    0x340, x12
  csrrs  x8,    0x340, x12
  csrrw  x8,    0x340, x12
  csrrc  x8,    0x340, x13
  csrrs  x8,    0x340, x13
  csrrw  x8,    0x340, x13
  csrrc  x8,    0x340, x14
  csrrs  x8,    0x340, x14
  csrrw  x8,    0x340, x14
  csrrc  x8,    0x340, x15
  csrrs  x8,    0x340, x15
  csrrw  x8,    0x340, x15
  csrrc  x8,    0x340, x16
  csrrs  x8,    0x340, x16
  csrrw  x8,    0x340, x16
  csrrc  x8,    0x340, x17
  csrrs  x8,    0x340, x17
  csrrw  x8,    0x340, x17
  csrrc  x8,    0x340, x18
  csrrs  x8,    0x340, x18
  csrrw  x8,    0x340, x18
  csrrc  x8,    0x340, x19
  csrrs  x8,    0x340, x19
  csrrw  x8,    0x340, x19
  csrrc  x8,    0x340, x20
  csrrs  x8,    0x340, x20
  csrrw  x8,    0x340, x20
  csrrc  x8,    0x340, x21
  csrrs  x8,    0x340, x21
  csrrw  x8,    0x340, x21
  csrrc  x8,    0x340, x22
  csrrs  x8,    0x340, x22
  csrrw  x8,    0x340, x22
  csrrc  x8,    0x340, x23
  csrrs  x8,    0x340, x23
  csrrw  x8,    0x340, x23
  csrrc  x8,    0x340, x24
  csrrs  x8,    0x340, x24
  csrrw  x8,    0x340, x24
  csrrc  x8,    0x340, x25
  csrrs  x8,    0x340, x25
  csrrw  x8,    0x340, x25
  csrrc  x8,    0x340, x26
  csrrs  x8,    0x340, x26
  csrrw  x8,    0x340, x26
  csrrc  x8,    0x340, x27
  csrrs  x8,    0x340, x27
  csrrw  x8,    0x340, x27
  csrrc  x8,    0x340, x28
  csrrs  x8,    0x340, x28
  csrrw  x8,    0x340, x28
  csrrc  x8,    0x340, x29
  csrrs  x8,    0x340, x29
  csrrw  x8,    0x340, x29
  csrrc  x8,    0x340, x30
  csrrs  x8,    0x340, x30
  csrrw  x8,    0x340, x30
  csrrc  x8,    0x340, x31
  csrrs  x8,    0x340, x31
  csrrw  x8,    0x340, x31

  csrrc  x9,    0x340, x0
  csrrs  x9,    0x340, x0
  csrrw  x9,    0x340, x0
  csrrc  x9,    0x340, x1
  csrrs  x9,    0x340, x1
  csrrw  x9,    0x340, x1
  csrrc  x9,    0x340, x2
  csrrs  x9,    0x340, x2
  csrrw  x9,    0x340, x2
  csrrc  x9,    0x340, x3
  csrrs  x9,    0x340, x3
  csrrw  x9,    0x340, x3
  csrrc  x9,    0x340, x4
  csrrs  x9,    0x340, x4
  csrrw  x9,    0x340, x4
  csrrc  x9,    0x340, x5
  csrrs  x9,    0x340, x5
  csrrw  x9,    0x340, x5
  csrrc  x9,    0x340, x6
  csrrs  x9,    0x340, x6
  csrrw  x9,    0x340, x6
  csrrc  x9,    0x340, x7
  csrrs  x9,    0x340, x7
  csrrw  x9,    0x340, x7
  csrrc  x9,    0x340, x8
  csrrs  x9,    0x340, x8
  csrrw  x9,    0x340, x8
  csrrc  x9,    0x340, x9
  csrrs  x9,    0x340, x9
  csrrw  x9,    0x340, x9
  csrrc  x9,    0x340, x10
  csrrs  x9,    0x340, x10
  csrrw  x9,    0x340, x10
  csrrc  x9,    0x340, x11
  csrrs  x9,    0x340, x11
  csrrw  x9,    0x340, x11
  csrrc  x9,    0x340, x12
  csrrs  x9,    0x340, x12
  csrrw  x9,    0x340, x12
  csrrc  x9,    0x340, x13
  csrrs  x9,    0x340, x13
  csrrw  x9,    0x340, x13
  csrrc  x9,    0x340, x14
  csrrs  x9,    0x340, x14
  csrrw  x9,    0x340, x14
  csrrc  x9,    0x340, x15
  csrrs  x9,    0x340, x15
  csrrw  x9,    0x340, x15
  csrrc  x9,    0x340, x16
  csrrs  x9,    0x340, x16
  csrrw  x9,    0x340, x16
  csrrc  x9,    0x340, x17
  csrrs  x9,    0x340, x17
  csrrw  x9,    0x340, x17
  csrrc  x9,    0x340, x18
  csrrs  x9,    0x340, x18
  csrrw  x9,    0x340, x18
  csrrc  x9,    0x340, x19
  csrrs  x9,    0x340, x19
  csrrw  x9,    0x340, x19
  csrrc  x9,    0x340, x20
  csrrs  x9,    0x340, x20
  csrrw  x9,    0x340, x20
  csrrc  x9,    0x340, x21
  csrrs  x9,    0x340, x21
  csrrw  x9,    0x340, x21
  csrrc  x9,    0x340, x22
  csrrs  x9,    0x340, x22
  csrrw  x9,    0x340, x22
  csrrc  x9,    0x340, x23
  csrrs  x9,    0x340, x23
  csrrw  x9,    0x340, x23
  csrrc  x9,    0x340, x24
  csrrs  x9,    0x340, x24
  csrrw  x9,    0x340, x24
  csrrc  x9,    0x340, x25
  csrrs  x9,    0x340, x25
  csrrw  x9,    0x340, x25
  csrrc  x9,    0x340, x26
  csrrs  x9,    0x340, x26
  csrrw  x9,    0x340, x26
  csrrc  x9,    0x340, x27
  csrrs  x9,    0x340, x27
  csrrw  x9,    0x340, x27
  csrrc  x9,    0x340, x28
  csrrs  x9,    0x340, x28
  csrrw  x9,    0x340, x28
  csrrc  x9,    0x340, x29
  csrrs  x9,    0x340, x29
  csrrw  x9,    0x340, x29
  csrrc  x9,    0x340, x30
  csrrs  x9,    0x340, x30
  csrrw  x9,    0x340, x30
  csrrc  x9,    0x340, x31
  csrrs  x9,    0x340, x31
  csrrw  x9,    0x340, x31

  csrrc  x10,    0x340, x0
  csrrs  x10,    0x340, x0
  csrrw  x10,    0x340, x0
  csrrc  x10,    0x340, x1
  csrrs  x10,    0x340, x1
  csrrw  x10,    0x340, x1
  csrrc  x10,    0x340, x2
  csrrs  x10,    0x340, x2
  csrrw  x10,    0x340, x2
  csrrc  x10,    0x340, x3
  csrrs  x10,    0x340, x3
  csrrw  x10,    0x340, x3
  csrrc  x10,    0x340, x4
  csrrs  x10,    0x340, x4
  csrrw  x10,    0x340, x4
  csrrc  x10,    0x340, x5
  csrrs  x10,    0x340, x5
  csrrw  x10,    0x340, x5
  csrrc  x10,    0x340, x6
  csrrs  x10,    0x340, x6
  csrrw  x10,    0x340, x6
  csrrc  x10,    0x340, x7
  csrrs  x10,    0x340, x7
  csrrw  x10,    0x340, x7
  csrrc  x10,    0x340, x8
  csrrs  x10,    0x340, x8
  csrrw  x10,    0x340, x8
  csrrc  x10,    0x340, x9
  csrrs  x10,    0x340, x9
  csrrw  x10,    0x340, x9
  csrrc  x10,    0x340, x10
  csrrs  x10,    0x340, x10
  csrrw  x10,    0x340, x10
  csrrc  x10,    0x340, x11
  csrrs  x10,    0x340, x11
  csrrw  x10,    0x340, x11
  csrrc  x10,    0x340, x12
  csrrs  x10,    0x340, x12
  csrrw  x10,    0x340, x12
  csrrc  x10,    0x340, x13
  csrrs  x10,    0x340, x13
  csrrw  x10,    0x340, x13
  csrrc  x10,    0x340, x14
  csrrs  x10,    0x340, x14
  csrrw  x10,    0x340, x14
  csrrc  x10,    0x340, x15
  csrrs  x10,    0x340, x15
  csrrw  x10,    0x340, x15
  csrrc  x10,    0x340, x16
  csrrs  x10,    0x340, x16
  csrrw  x10,    0x340, x16
  csrrc  x10,    0x340, x17
  csrrs  x10,    0x340, x17
  csrrw  x10,    0x340, x17
  csrrc  x10,    0x340, x18
  csrrs  x10,    0x340, x18
  csrrw  x10,    0x340, x18
  csrrc  x10,    0x340, x19
  csrrs  x10,    0x340, x19
  csrrw  x10,    0x340, x19
  csrrc  x10,    0x340, x20
  csrrs  x10,    0x340, x20
  csrrw  x10,    0x340, x20
  csrrc  x10,    0x340, x21
  csrrs  x10,    0x340, x21
  csrrw  x10,    0x340, x21
  csrrc  x10,    0x340, x22
  csrrs  x10,    0x340, x22
  csrrw  x10,    0x340, x22
  csrrc  x10,    0x340, x23
  csrrs  x10,    0x340, x23
  csrrw  x10,    0x340, x23
  csrrc  x10,    0x340, x24
  csrrs  x10,    0x340, x24
  csrrw  x10,    0x340, x24
  csrrc  x10,    0x340, x25
  csrrs  x10,    0x340, x25
  csrrw  x10,    0x340, x25
  csrrc  x10,    0x340, x26
  csrrs  x10,    0x340, x26
  csrrw  x10,    0x340, x26
  csrrc  x10,    0x340, x27
  csrrs  x10,    0x340, x27
  csrrw  x10,    0x340, x27
  csrrc  x10,    0x340, x28
  csrrs  x10,    0x340, x28
  csrrw  x10,    0x340, x28
  csrrc  x10,    0x340, x29
  csrrs  x10,    0x340, x29
  csrrw  x10,    0x340, x29
  csrrc  x10,    0x340, x30
  csrrs  x10,    0x340, x30
  csrrw  x10,    0x340, x30
  csrrc  x10,    0x340, x31
  csrrs  x10,    0x340, x31
  csrrw  x10,    0x340, x31

  csrrc  x11,    0x340, x0
  csrrs  x11,    0x340, x0
  csrrw  x11,    0x340, x0
  csrrc  x11,    0x340, x1
  csrrs  x11,    0x340, x1
  csrrw  x11,    0x340, x1
  csrrc  x11,    0x340, x2
  csrrs  x11,    0x340, x2
  csrrw  x11,    0x340, x2
  csrrc  x11,    0x340, x3
  csrrs  x11,    0x340, x3
  csrrw  x11,    0x340, x3
  csrrc  x11,    0x340, x4
  csrrs  x11,    0x340, x4
  csrrw  x11,    0x340, x4
  csrrc  x11,    0x340, x5
  csrrs  x11,    0x340, x5
  csrrw  x11,    0x340, x5
  csrrc  x11,    0x340, x6
  csrrs  x11,    0x340, x6
  csrrw  x11,    0x340, x6
  csrrc  x11,    0x340, x7
  csrrs  x11,    0x340, x7
  csrrw  x11,    0x340, x7
  csrrc  x11,    0x340, x8
  csrrs  x11,    0x340, x8
  csrrw  x11,    0x340, x8
  csrrc  x11,    0x340, x9
  csrrs  x11,    0x340, x9
  csrrw  x11,    0x340, x9
  csrrc  x11,    0x340, x10
  csrrs  x11,    0x340, x10
  csrrw  x11,    0x340, x10
  csrrc  x11,    0x340, x11
  csrrs  x11,    0x340, x11
  csrrw  x11,    0x340, x11
  csrrc  x11,    0x340, x12
  csrrs  x11,    0x340, x12
  csrrw  x11,    0x340, x12
  csrrc  x11,    0x340, x13
  csrrs  x11,    0x340, x13
  csrrw  x11,    0x340, x13
  csrrc  x11,    0x340, x14
  csrrs  x11,    0x340, x14
  csrrw  x11,    0x340, x14
  csrrc  x11,    0x340, x15
  csrrs  x11,    0x340, x15
  csrrw  x11,    0x340, x15
  csrrc  x11,    0x340, x16
  csrrs  x11,    0x340, x16
  csrrw  x11,    0x340, x16
  csrrc  x11,    0x340, x17
  csrrs  x11,    0x340, x17
  csrrw  x11,    0x340, x17
  csrrc  x11,    0x340, x18
  csrrs  x11,    0x340, x18
  csrrw  x11,    0x340, x18
  csrrc  x11,    0x340, x19
  csrrs  x11,    0x340, x19
  csrrw  x11,    0x340, x19
  csrrc  x11,    0x340, x20
  csrrs  x11,    0x340, x20
  csrrw  x11,    0x340, x20
  csrrc  x11,    0x340, x21
  csrrs  x11,    0x340, x21
  csrrw  x11,    0x340, x21
  csrrc  x11,    0x340, x22
  csrrs  x11,    0x340, x22
  csrrw  x11,    0x340, x22
  csrrc  x11,    0x340, x23
  csrrs  x11,    0x340, x23
  csrrw  x11,    0x340, x23
  csrrc  x11,    0x340, x24
  csrrs  x11,    0x340, x24
  csrrw  x11,    0x340, x24
  csrrc  x11,    0x340, x25
  csrrs  x11,    0x340, x25
  csrrw  x11,    0x340, x25
  csrrc  x11,    0x340, x26
  csrrs  x11,    0x340, x26
  csrrw  x11,    0x340, x26
  csrrc  x11,    0x340, x27
  csrrs  x11,    0x340, x27
  csrrw  x11,    0x340, x27
  csrrc  x11,    0x340, x28
  csrrs  x11,    0x340, x28
  csrrw  x11,    0x340, x28
  csrrc  x11,    0x340, x29
  csrrs  x11,    0x340, x29
  csrrw  x11,    0x340, x29
  csrrc  x11,    0x340, x30
  csrrs  x11,    0x340, x30
  csrrw  x11,    0x340, x30
  csrrc  x11,    0x340, x31
  csrrs  x11,    0x340, x31
  csrrw  x11,    0x340, x31

  csrrc  x12,    0x340, x0
  csrrs  x12,    0x340, x0
  csrrw  x12,    0x340, x0
  csrrc  x12,    0x340, x1
  csrrs  x12,    0x340, x1
  csrrw  x12,    0x340, x1
  csrrc  x12,    0x340, x2
  csrrs  x12,    0x340, x2
  csrrw  x12,    0x340, x2
  csrrc  x12,    0x340, x3
  csrrs  x12,    0x340, x3
  csrrw  x12,    0x340, x3
  csrrc  x12,    0x340, x4
  csrrs  x12,    0x340, x4
  csrrw  x12,    0x340, x4
  csrrc  x12,    0x340, x5
  csrrs  x12,    0x340, x5
  csrrw  x12,    0x340, x5
  csrrc  x12,    0x340, x6
  csrrs  x12,    0x340, x6
  csrrw  x12,    0x340, x6
  csrrc  x12,    0x340, x7
  csrrs  x12,    0x340, x7
  csrrw  x12,    0x340, x7
  csrrc  x12,    0x340, x8
  csrrs  x12,    0x340, x8
  csrrw  x12,    0x340, x8
  csrrc  x12,    0x340, x9
  csrrs  x12,    0x340, x9
  csrrw  x12,    0x340, x9
  csrrc  x12,    0x340, x10
  csrrs  x12,    0x340, x10
  csrrw  x12,    0x340, x10
  csrrc  x12,    0x340, x11
  csrrs  x12,    0x340, x11
  csrrw  x12,    0x340, x11
  csrrc  x12,    0x340, x12
  csrrs  x12,    0x340, x12
  csrrw  x12,    0x340, x12
  csrrc  x12,    0x340, x13
  csrrs  x12,    0x340, x13
  csrrw  x12,    0x340, x13
  csrrc  x12,    0x340, x14
  csrrs  x12,    0x340, x14
  csrrw  x12,    0x340, x14
  csrrc  x12,    0x340, x15
  csrrs  x12,    0x340, x15
  csrrw  x12,    0x340, x15
  csrrc  x12,    0x340, x16
  csrrs  x12,    0x340, x16
  csrrw  x12,    0x340, x16
  csrrc  x12,    0x340, x17
  csrrs  x12,    0x340, x17
  csrrw  x12,    0x340, x17
  csrrc  x12,    0x340, x18
  csrrs  x12,    0x340, x18
  csrrw  x12,    0x340, x18
  csrrc  x12,    0x340, x19
  csrrs  x12,    0x340, x19
  csrrw  x12,    0x340, x19
  csrrc  x12,    0x340, x20
  csrrs  x12,    0x340, x20
  csrrw  x12,    0x340, x20
  csrrc  x12,    0x340, x21
  csrrs  x12,    0x340, x21
  csrrw  x12,    0x340, x21
  csrrc  x12,    0x340, x22
  csrrs  x12,    0x340, x22
  csrrw  x12,    0x340, x22
  csrrc  x12,    0x340, x23
  csrrs  x12,    0x340, x23
  csrrw  x12,    0x340, x23
  csrrc  x12,    0x340, x24
  csrrs  x12,    0x340, x24
  csrrw  x12,    0x340, x24
  csrrc  x12,    0x340, x25
  csrrs  x12,    0x340, x25
  csrrw  x12,    0x340, x25
  csrrc  x12,    0x340, x26
  csrrs  x12,    0x340, x26
  csrrw  x12,    0x340, x26
  csrrc  x12,    0x340, x27
  csrrs  x12,    0x340, x27
  csrrw  x12,    0x340, x27
  csrrc  x12,    0x340, x28
  csrrs  x12,    0x340, x28
  csrrw  x12,    0x340, x28
  csrrc  x12,    0x340, x29
  csrrs  x12,    0x340, x29
  csrrw  x12,    0x340, x29
  csrrc  x12,    0x340, x30
  csrrs  x12,    0x340, x30
  csrrw  x12,    0x340, x30
  csrrc  x12,    0x340, x31
  csrrs  x12,    0x340, x31
  csrrw  x12,    0x340, x31

  csrrc  x13,    0x340, x0
  csrrs  x13,    0x340, x0
  csrrw  x13,    0x340, x0
  csrrc  x13,    0x340, x1
  csrrs  x13,    0x340, x1
  csrrw  x13,    0x340, x1
  csrrc  x13,    0x340, x2
  csrrs  x13,    0x340, x2
  csrrw  x13,    0x340, x2
  csrrc  x13,    0x340, x3
  csrrs  x13,    0x340, x3
  csrrw  x13,    0x340, x3
  csrrc  x13,    0x340, x4
  csrrs  x13,    0x340, x4
  csrrw  x13,    0x340, x4
  csrrc  x13,    0x340, x5
  csrrs  x13,    0x340, x5
  csrrw  x13,    0x340, x5
  csrrc  x13,    0x340, x6
  csrrs  x13,    0x340, x6
  csrrw  x13,    0x340, x6
  csrrc  x13,    0x340, x7
  csrrs  x13,    0x340, x7
  csrrw  x13,    0x340, x7
  csrrc  x13,    0x340, x8
  csrrs  x13,    0x340, x8
  csrrw  x13,    0x340, x8
  csrrc  x13,    0x340, x9
  csrrs  x13,    0x340, x9
  csrrw  x13,    0x340, x9
  csrrc  x13,    0x340, x10
  csrrs  x13,    0x340, x10
  csrrw  x13,    0x340, x10
  csrrc  x13,    0x340, x11
  csrrs  x13,    0x340, x11
  csrrw  x13,    0x340, x11
  csrrc  x13,    0x340, x12
  csrrs  x13,    0x340, x12
  csrrw  x13,    0x340, x12
  csrrc  x13,    0x340, x13
  csrrs  x13,    0x340, x13
  csrrw  x13,    0x340, x13
  csrrc  x13,    0x340, x14
  csrrs  x13,    0x340, x14
  csrrw  x13,    0x340, x14
  csrrc  x13,    0x340, x15
  csrrs  x13,    0x340, x15
  csrrw  x13,    0x340, x15
  csrrc  x13,    0x340, x16
  csrrs  x13,    0x340, x16
  csrrw  x13,    0x340, x16
  csrrc  x13,    0x340, x17
  csrrs  x13,    0x340, x17
  csrrw  x13,    0x340, x17
  csrrc  x13,    0x340, x18
  csrrs  x13,    0x340, x18
  csrrw  x13,    0x340, x18
  csrrc  x13,    0x340, x19
  csrrs  x13,    0x340, x19
  csrrw  x13,    0x340, x19
  csrrc  x13,    0x340, x20
  csrrs  x13,    0x340, x20
  csrrw  x13,    0x340, x20
  csrrc  x13,    0x340, x21
  csrrs  x13,    0x340, x21
  csrrw  x13,    0x340, x21
  csrrc  x13,    0x340, x22
  csrrs  x13,    0x340, x22
  csrrw  x13,    0x340, x22
  csrrc  x13,    0x340, x23
  csrrs  x13,    0x340, x23
  csrrw  x13,    0x340, x23
  csrrc  x13,    0x340, x24
  csrrs  x13,    0x340, x24
  csrrw  x13,    0x340, x24
  csrrc  x13,    0x340, x25
  csrrs  x13,    0x340, x25
  csrrw  x13,    0x340, x25
  csrrc  x13,    0x340, x26
  csrrs  x13,    0x340, x26
  csrrw  x13,    0x340, x26
  csrrc  x13,    0x340, x27
  csrrs  x13,    0x340, x27
  csrrw  x13,    0x340, x27
  csrrc  x13,    0x340, x28
  csrrs  x13,    0x340, x28
  csrrw  x13,    0x340, x28
  csrrc  x13,    0x340, x29
  csrrs  x13,    0x340, x29
  csrrw  x13,    0x340, x29
  csrrc  x13,    0x340, x30
  csrrs  x13,    0x340, x30
  csrrw  x13,    0x340, x30
  csrrc  x13,    0x340, x31
  csrrs  x13,    0x340, x31
  csrrw  x13,    0x340, x31

  csrrc  x14,    0x340, x0
  csrrs  x14,    0x340, x0
  csrrw  x14,    0x340, x0
  csrrc  x14,    0x340, x1
  csrrs  x14,    0x340, x1
  csrrw  x14,    0x340, x1
  csrrc  x14,    0x340, x2
  csrrs  x14,    0x340, x2
  csrrw  x14,    0x340, x2
  csrrc  x14,    0x340, x3
  csrrs  x14,    0x340, x3
  csrrw  x14,    0x340, x3
  csrrc  x14,    0x340, x4
  csrrs  x14,    0x340, x4
  csrrw  x14,    0x340, x4
  csrrc  x14,    0x340, x5
  csrrs  x14,    0x340, x5
  csrrw  x14,    0x340, x5
  csrrc  x14,    0x340, x6
  csrrs  x14,    0x340, x6
  csrrw  x14,    0x340, x6
  csrrc  x14,    0x340, x7
  csrrs  x14,    0x340, x7
  csrrw  x14,    0x340, x7
  csrrc  x14,    0x340, x8
  csrrs  x14,    0x340, x8
  csrrw  x14,    0x340, x8
  csrrc  x14,    0x340, x9
  csrrs  x14,    0x340, x9
  csrrw  x14,    0x340, x9
  csrrc  x14,    0x340, x10
  csrrs  x14,    0x340, x10
  csrrw  x14,    0x340, x10
  csrrc  x14,    0x340, x11
  csrrs  x14,    0x340, x11
  csrrw  x14,    0x340, x11
  csrrc  x14,    0x340, x12
  csrrs  x14,    0x340, x12
  csrrw  x14,    0x340, x12
  csrrc  x14,    0x340, x13
  csrrs  x14,    0x340, x13
  csrrw  x14,    0x340, x13
  csrrc  x14,    0x340, x14
  csrrs  x14,    0x340, x14
  csrrw  x14,    0x340, x14
  csrrc  x14,    0x340, x15
  csrrs  x14,    0x340, x15
  csrrw  x14,    0x340, x15
  csrrc  x14,    0x340, x16
  csrrs  x14,    0x340, x16
  csrrw  x14,    0x340, x16
  csrrc  x14,    0x340, x17
  csrrs  x14,    0x340, x17
  csrrw  x14,    0x340, x17
  csrrc  x14,    0x340, x18
  csrrs  x14,    0x340, x18
  csrrw  x14,    0x340, x18
  csrrc  x14,    0x340, x19
  csrrs  x14,    0x340, x19
  csrrw  x14,    0x340, x19
  csrrc  x14,    0x340, x20
  csrrs  x14,    0x340, x20
  csrrw  x14,    0x340, x20
  csrrc  x14,    0x340, x21
  csrrs  x14,    0x340, x21
  csrrw  x14,    0x340, x21
  csrrc  x14,    0x340, x22
  csrrs  x14,    0x340, x22
  csrrw  x14,    0x340, x22
  csrrc  x14,    0x340, x23
  csrrs  x14,    0x340, x23
  csrrw  x14,    0x340, x23
  csrrc  x14,    0x340, x24
  csrrs  x14,    0x340, x24
  csrrw  x14,    0x340, x24
  csrrc  x14,    0x340, x25
  csrrs  x14,    0x340, x25
  csrrw  x14,    0x340, x25
  csrrc  x14,    0x340, x26
  csrrs  x14,    0x340, x26
  csrrw  x14,    0x340, x26
  csrrc  x14,    0x340, x27
  csrrs  x14,    0x340, x27
  csrrw  x14,    0x340, x27
  csrrc  x14,    0x340, x28
  csrrs  x14,    0x340, x28
  csrrw  x14,    0x340, x28
  csrrc  x14,    0x340, x29
  csrrs  x14,    0x340, x29
  csrrw  x14,    0x340, x29
  csrrc  x14,    0x340, x30
  csrrs  x14,    0x340, x30
  csrrw  x14,    0x340, x30
  csrrc  x14,    0x340, x31
  csrrs  x14,    0x340, x31
  csrrw  x14,    0x340, x31

  csrrc  x15,    0x340, x0
  csrrs  x15,    0x340, x0
  csrrw  x15,    0x340, x0
  csrrc  x15,    0x340, x1
  csrrs  x15,    0x340, x1
  csrrw  x15,    0x340, x1
  csrrc  x15,    0x340, x2
  csrrs  x15,    0x340, x2
  csrrw  x15,    0x340, x2
  csrrc  x15,    0x340, x3
  csrrs  x15,    0x340, x3
  csrrw  x15,    0x340, x3
  csrrc  x15,    0x340, x4
  csrrs  x15,    0x340, x4
  csrrw  x15,    0x340, x4
  csrrc  x15,    0x340, x5
  csrrs  x15,    0x340, x5
  csrrw  x15,    0x340, x5
  csrrc  x15,    0x340, x6
  csrrs  x15,    0x340, x6
  csrrw  x15,    0x340, x6
  csrrc  x15,    0x340, x7
  csrrs  x15,    0x340, x7
  csrrw  x15,    0x340, x7
  csrrc  x15,    0x340, x8
  csrrs  x15,    0x340, x8
  csrrw  x15,    0x340, x8
  csrrc  x15,    0x340, x9
  csrrs  x15,    0x340, x9
  csrrw  x15,    0x340, x9
  csrrc  x15,    0x340, x10
  csrrs  x15,    0x340, x10
  csrrw  x15,    0x340, x10
  csrrc  x15,    0x340, x11
  csrrs  x15,    0x340, x11
  csrrw  x15,    0x340, x11
  csrrc  x15,    0x340, x12
  csrrs  x15,    0x340, x12
  csrrw  x15,    0x340, x12
  csrrc  x15,    0x340, x13
  csrrs  x15,    0x340, x13
  csrrw  x15,    0x340, x13
  csrrc  x15,    0x340, x14
  csrrs  x15,    0x340, x14
  csrrw  x15,    0x340, x14
  csrrc  x15,    0x340, x15
  csrrs  x15,    0x340, x15
  csrrw  x15,    0x340, x15
  csrrc  x15,    0x340, x16
  csrrs  x15,    0x340, x16
  csrrw  x15,    0x340, x16
  csrrc  x15,    0x340, x17
  csrrs  x15,    0x340, x17
  csrrw  x15,    0x340, x17
  csrrc  x15,    0x340, x18
  csrrs  x15,    0x340, x18
  csrrw  x15,    0x340, x18
  csrrc  x15,    0x340, x19
  csrrs  x15,    0x340, x19
  csrrw  x15,    0x340, x19
  csrrc  x15,    0x340, x20
  csrrs  x15,    0x340, x20
  csrrw  x15,    0x340, x20
  csrrc  x15,    0x340, x21
  csrrs  x15,    0x340, x21
  csrrw  x15,    0x340, x21
  csrrc  x15,    0x340, x22
  csrrs  x15,    0x340, x22
  csrrw  x15,    0x340, x22
  csrrc  x15,    0x340, x23
  csrrs  x15,    0x340, x23
  csrrw  x15,    0x340, x23
  csrrc  x15,    0x340, x24
  csrrs  x15,    0x340, x24
  csrrw  x15,    0x340, x24
  csrrc  x15,    0x340, x25
  csrrs  x15,    0x340, x25
  csrrw  x15,    0x340, x25
  csrrc  x15,    0x340, x26
  csrrs  x15,    0x340, x26
  csrrw  x15,    0x340, x26
  csrrc  x15,    0x340, x27
  csrrs  x15,    0x340, x27
  csrrw  x15,    0x340, x27
  csrrc  x15,    0x340, x28
  csrrs  x15,    0x340, x28
  csrrw  x15,    0x340, x28
  csrrc  x15,    0x340, x29
  csrrs  x15,    0x340, x29
  csrrw  x15,    0x340, x29
  csrrc  x15,    0x340, x30
  csrrs  x15,    0x340, x30
  csrrw  x15,    0x340, x30
  csrrc  x15,    0x340, x31
  csrrs  x15,    0x340, x31
  csrrw  x15,    0x340, x31

  csrrc  x16,    0x340, x0
  csrrs  x16,    0x340, x0
  csrrw  x16,    0x340, x0
  csrrc  x16,    0x340, x1
  csrrs  x16,    0x340, x1
  csrrw  x16,    0x340, x1
  csrrc  x16,    0x340, x2
  csrrs  x16,    0x340, x2
  csrrw  x16,    0x340, x2
  csrrc  x16,    0x340, x3
  csrrs  x16,    0x340, x3
  csrrw  x16,    0x340, x3
  csrrc  x16,    0x340, x4
  csrrs  x16,    0x340, x4
  csrrw  x16,    0x340, x4
  csrrc  x16,    0x340, x5
  csrrs  x16,    0x340, x5
  csrrw  x16,    0x340, x5
  csrrc  x16,    0x340, x6
  csrrs  x16,    0x340, x6
  csrrw  x16,    0x340, x6
  csrrc  x16,    0x340, x7
  csrrs  x16,    0x340, x7
  csrrw  x16,    0x340, x7
  csrrc  x16,    0x340, x8
  csrrs  x16,    0x340, x8
  csrrw  x16,    0x340, x8
  csrrc  x16,    0x340, x9
  csrrs  x16,    0x340, x9
  csrrw  x16,    0x340, x9
  csrrc  x16,    0x340, x10
  csrrs  x16,    0x340, x10
  csrrw  x16,    0x340, x10
  csrrc  x16,    0x340, x11
  csrrs  x16,    0x340, x11
  csrrw  x16,    0x340, x11
  csrrc  x16,    0x340, x12
  csrrs  x16,    0x340, x12
  csrrw  x16,    0x340, x12
  csrrc  x16,    0x340, x13
  csrrs  x16,    0x340, x13
  csrrw  x16,    0x340, x13
  csrrc  x16,    0x340, x14
  csrrs  x16,    0x340, x14
  csrrw  x16,    0x340, x14
  csrrc  x16,    0x340, x15
  csrrs  x16,    0x340, x15
  csrrw  x16,    0x340, x15
  csrrc  x16,    0x340, x16
  csrrs  x16,    0x340, x16
  csrrw  x16,    0x340, x16
  csrrc  x16,    0x340, x17
  csrrs  x16,    0x340, x17
  csrrw  x16,    0x340, x17
  csrrc  x16,    0x340, x18
  csrrs  x16,    0x340, x18
  csrrw  x16,    0x340, x18
  csrrc  x16,    0x340, x19
  csrrs  x16,    0x340, x19
  csrrw  x16,    0x340, x19
  csrrc  x16,    0x340, x20
  csrrs  x16,    0x340, x20
  csrrw  x16,    0x340, x20
  csrrc  x16,    0x340, x21
  csrrs  x16,    0x340, x21
  csrrw  x16,    0x340, x21
  csrrc  x16,    0x340, x22
  csrrs  x16,    0x340, x22
  csrrw  x16,    0x340, x22
  csrrc  x16,    0x340, x23
  csrrs  x16,    0x340, x23
  csrrw  x16,    0x340, x23
  csrrc  x16,    0x340, x24
  csrrs  x16,    0x340, x24
  csrrw  x16,    0x340, x24
  csrrc  x16,    0x340, x25
  csrrs  x16,    0x340, x25
  csrrw  x16,    0x340, x25
  csrrc  x16,    0x340, x26
  csrrs  x16,    0x340, x26
  csrrw  x16,    0x340, x26
  csrrc  x16,    0x340, x27
  csrrs  x16,    0x340, x27
  csrrw  x16,    0x340, x27
  csrrc  x16,    0x340, x28
  csrrs  x16,    0x340, x28
  csrrw  x16,    0x340, x28
  csrrc  x16,    0x340, x29
  csrrs  x16,    0x340, x29
  csrrw  x16,    0x340, x29
  csrrc  x16,    0x340, x30
  csrrs  x16,    0x340, x30
  csrrw  x16,    0x340, x30
  csrrc  x16,    0x340, x31
  csrrs  x16,    0x340, x31
  csrrw  x16,    0x340, x31

  csrrc  x17,    0x340, x0
  csrrs  x17,    0x340, x0
  csrrw  x17,    0x340, x0
  csrrc  x17,    0x340, x1
  csrrs  x17,    0x340, x1
  csrrw  x17,    0x340, x1
  csrrc  x17,    0x340, x2
  csrrs  x17,    0x340, x2
  csrrw  x17,    0x340, x2
  csrrc  x17,    0x340, x3
  csrrs  x17,    0x340, x3
  csrrw  x17,    0x340, x3
  csrrc  x17,    0x340, x4
  csrrs  x17,    0x340, x4
  csrrw  x17,    0x340, x4
  csrrc  x17,    0x340, x5
  csrrs  x17,    0x340, x5
  csrrw  x17,    0x340, x5
  csrrc  x17,    0x340, x6
  csrrs  x17,    0x340, x6
  csrrw  x17,    0x340, x6
  csrrc  x17,    0x340, x7
  csrrs  x17,    0x340, x7
  csrrw  x17,    0x340, x7
  csrrc  x17,    0x340, x8
  csrrs  x17,    0x340, x8
  csrrw  x17,    0x340, x8
  csrrc  x17,    0x340, x9
  csrrs  x17,    0x340, x9
  csrrw  x17,    0x340, x9
  csrrc  x17,    0x340, x10
  csrrs  x17,    0x340, x10
  csrrw  x17,    0x340, x10
  csrrc  x17,    0x340, x11
  csrrs  x17,    0x340, x11
  csrrw  x17,    0x340, x11
  csrrc  x17,    0x340, x12
  csrrs  x17,    0x340, x12
  csrrw  x17,    0x340, x12
  csrrc  x17,    0x340, x13
  csrrs  x17,    0x340, x13
  csrrw  x17,    0x340, x13
  csrrc  x17,    0x340, x14
  csrrs  x17,    0x340, x14
  csrrw  x17,    0x340, x14
  csrrc  x17,    0x340, x15
  csrrs  x17,    0x340, x15
  csrrw  x17,    0x340, x15
  csrrc  x17,    0x340, x16
  csrrs  x17,    0x340, x16
  csrrw  x17,    0x340, x16
  csrrc  x17,    0x340, x17
  csrrs  x17,    0x340, x17
  csrrw  x17,    0x340, x17
  csrrc  x17,    0x340, x18
  csrrs  x17,    0x340, x18
  csrrw  x17,    0x340, x18
  csrrc  x17,    0x340, x19
  csrrs  x17,    0x340, x19
  csrrw  x17,    0x340, x19
  csrrc  x17,    0x340, x20
  csrrs  x17,    0x340, x20
  csrrw  x17,    0x340, x20
  csrrc  x17,    0x340, x21
  csrrs  x17,    0x340, x21
  csrrw  x17,    0x340, x21
  csrrc  x17,    0x340, x22
  csrrs  x17,    0x340, x22
  csrrw  x17,    0x340, x22
  csrrc  x17,    0x340, x23
  csrrs  x17,    0x340, x23
  csrrw  x17,    0x340, x23
  csrrc  x17,    0x340, x24
  csrrs  x17,    0x340, x24
  csrrw  x17,    0x340, x24
  csrrc  x17,    0x340, x25
  csrrs  x17,    0x340, x25
  csrrw  x17,    0x340, x25
  csrrc  x17,    0x340, x26
  csrrs  x17,    0x340, x26
  csrrw  x17,    0x340, x26
  csrrc  x17,    0x340, x27
  csrrs  x17,    0x340, x27
  csrrw  x17,    0x340, x27
  csrrc  x17,    0x340, x28
  csrrs  x17,    0x340, x28
  csrrw  x17,    0x340, x28
  csrrc  x17,    0x340, x29
  csrrs  x17,    0x340, x29
  csrrw  x17,    0x340, x29
  csrrc  x17,    0x340, x30
  csrrs  x17,    0x340, x30
  csrrw  x17,    0x340, x30
  csrrc  x17,    0x340, x31
  csrrs  x17,    0x340, x31
  csrrw  x17,    0x340, x31

  csrrc  x18,    0x340, x0
  csrrs  x18,    0x340, x0
  csrrw  x18,    0x340, x0
  csrrc  x18,    0x340, x1
  csrrs  x18,    0x340, x1
  csrrw  x18,    0x340, x1
  csrrc  x18,    0x340, x2
  csrrs  x18,    0x340, x2
  csrrw  x18,    0x340, x2
  csrrc  x18,    0x340, x3
  csrrs  x18,    0x340, x3
  csrrw  x18,    0x340, x3
  csrrc  x18,    0x340, x4
  csrrs  x18,    0x340, x4
  csrrw  x18,    0x340, x4
  csrrc  x18,    0x340, x5
  csrrs  x18,    0x340, x5
  csrrw  x18,    0x340, x5
  csrrc  x18,    0x340, x6
  csrrs  x18,    0x340, x6
  csrrw  x18,    0x340, x6
  csrrc  x18,    0x340, x7
  csrrs  x18,    0x340, x7
  csrrw  x18,    0x340, x7
  csrrc  x18,    0x340, x8
  csrrs  x18,    0x340, x8
  csrrw  x18,    0x340, x8
  csrrc  x18,    0x340, x9
  csrrs  x18,    0x340, x9
  csrrw  x18,    0x340, x9
  csrrc  x18,    0x340, x10
  csrrs  x18,    0x340, x10
  csrrw  x18,    0x340, x10
  csrrc  x18,    0x340, x11
  csrrs  x18,    0x340, x11
  csrrw  x18,    0x340, x11
  csrrc  x18,    0x340, x12
  csrrs  x18,    0x340, x12
  csrrw  x18,    0x340, x12
  csrrc  x18,    0x340, x13
  csrrs  x18,    0x340, x13
  csrrw  x18,    0x340, x13
  csrrc  x18,    0x340, x14
  csrrs  x18,    0x340, x14
  csrrw  x18,    0x340, x14
  csrrc  x18,    0x340, x15
  csrrs  x18,    0x340, x15
  csrrw  x18,    0x340, x15
  csrrc  x18,    0x340, x16
  csrrs  x18,    0x340, x16
  csrrw  x18,    0x340, x16
  csrrc  x18,    0x340, x17
  csrrs  x18,    0x340, x17
  csrrw  x18,    0x340, x17
  csrrc  x18,    0x340, x18
  csrrs  x18,    0x340, x18
  csrrw  x18,    0x340, x18
  csrrc  x18,    0x340, x19
  csrrs  x18,    0x340, x19
  csrrw  x18,    0x340, x19
  csrrc  x18,    0x340, x20
  csrrs  x18,    0x340, x20
  csrrw  x18,    0x340, x20
  csrrc  x18,    0x340, x21
  csrrs  x18,    0x340, x21
  csrrw  x18,    0x340, x21
  csrrc  x18,    0x340, x22
  csrrs  x18,    0x340, x22
  csrrw  x18,    0x340, x22
  csrrc  x18,    0x340, x23
  csrrs  x18,    0x340, x23
  csrrw  x18,    0x340, x23
  csrrc  x18,    0x340, x24
  csrrs  x18,    0x340, x24
  csrrw  x18,    0x340, x24
  csrrc  x18,    0x340, x25
  csrrs  x18,    0x340, x25
  csrrw  x18,    0x340, x25
  csrrc  x18,    0x340, x26
  csrrs  x18,    0x340, x26
  csrrw  x18,    0x340, x26
  csrrc  x18,    0x340, x27
  csrrs  x18,    0x340, x27
  csrrw  x18,    0x340, x27
  csrrc  x18,    0x340, x28
  csrrs  x18,    0x340, x28
  csrrw  x18,    0x340, x28
  csrrc  x18,    0x340, x29
  csrrs  x18,    0x340, x29
  csrrw  x18,    0x340, x29
  csrrc  x18,    0x340, x30
  csrrs  x18,    0x340, x30
  csrrw  x18,    0x340, x30
  csrrc  x18,    0x340, x31
  csrrs  x18,    0x340, x31
  csrrw  x18,    0x340, x31

  csrrc  x19,    0x340, x0
  csrrs  x19,    0x340, x0
  csrrw  x19,    0x340, x0
  csrrc  x19,    0x340, x1
  csrrs  x19,    0x340, x1
  csrrw  x19,    0x340, x1
  csrrc  x19,    0x340, x2
  csrrs  x19,    0x340, x2
  csrrw  x19,    0x340, x2
  csrrc  x19,    0x340, x3
  csrrs  x19,    0x340, x3
  csrrw  x19,    0x340, x3
  csrrc  x19,    0x340, x4
  csrrs  x19,    0x340, x4
  csrrw  x19,    0x340, x4
  csrrc  x19,    0x340, x5
  csrrs  x19,    0x340, x5
  csrrw  x19,    0x340, x5
  csrrc  x19,    0x340, x6
  csrrs  x19,    0x340, x6
  csrrw  x19,    0x340, x6
  csrrc  x19,    0x340, x7
  csrrs  x19,    0x340, x7
  csrrw  x19,    0x340, x7
  csrrc  x19,    0x340, x8
  csrrs  x19,    0x340, x8
  csrrw  x19,    0x340, x8
  csrrc  x19,    0x340, x9
  csrrs  x19,    0x340, x9
  csrrw  x19,    0x340, x9
  csrrc  x19,    0x340, x10
  csrrs  x19,    0x340, x10
  csrrw  x19,    0x340, x10
  csrrc  x19,    0x340, x11
  csrrs  x19,    0x340, x11
  csrrw  x19,    0x340, x11
  csrrc  x19,    0x340, x12
  csrrs  x19,    0x340, x12
  csrrw  x19,    0x340, x12
  csrrc  x19,    0x340, x13
  csrrs  x19,    0x340, x13
  csrrw  x19,    0x340, x13
  csrrc  x19,    0x340, x14
  csrrs  x19,    0x340, x14
  csrrw  x19,    0x340, x14
  csrrc  x19,    0x340, x15
  csrrs  x19,    0x340, x15
  csrrw  x19,    0x340, x15
  csrrc  x19,    0x340, x16
  csrrs  x19,    0x340, x16
  csrrw  x19,    0x340, x16
  csrrc  x19,    0x340, x17
  csrrs  x19,    0x340, x17
  csrrw  x19,    0x340, x17
  csrrc  x19,    0x340, x18
  csrrs  x19,    0x340, x18
  csrrw  x19,    0x340, x18
  csrrc  x19,    0x340, x19
  csrrs  x19,    0x340, x19
  csrrw  x19,    0x340, x19
  csrrc  x19,    0x340, x20
  csrrs  x19,    0x340, x20
  csrrw  x19,    0x340, x20
  csrrc  x19,    0x340, x21
  csrrs  x19,    0x340, x21
  csrrw  x19,    0x340, x21
  csrrc  x19,    0x340, x22
  csrrs  x19,    0x340, x22
  csrrw  x19,    0x340, x22
  csrrc  x19,    0x340, x23
  csrrs  x19,    0x340, x23
  csrrw  x19,    0x340, x23
  csrrc  x19,    0x340, x24
  csrrs  x19,    0x340, x24
  csrrw  x19,    0x340, x24
  csrrc  x19,    0x340, x25
  csrrs  x19,    0x340, x25
  csrrw  x19,    0x340, x25
  csrrc  x19,    0x340, x26
  csrrs  x19,    0x340, x26
  csrrw  x19,    0x340, x26
  csrrc  x19,    0x340, x27
  csrrs  x19,    0x340, x27
  csrrw  x19,    0x340, x27
  csrrc  x19,    0x340, x28
  csrrs  x19,    0x340, x28
  csrrw  x19,    0x340, x28
  csrrc  x19,    0x340, x29
  csrrs  x19,    0x340, x29
  csrrw  x19,    0x340, x29
  csrrc  x19,    0x340, x30
  csrrs  x19,    0x340, x30
  csrrw  x19,    0x340, x30
  csrrc  x19,    0x340, x31
  csrrs  x19,    0x340, x31
  csrrw  x19,    0x340, x31

  csrrc  x20,    0x340, x0
  csrrs  x20,    0x340, x0
  csrrw  x20,    0x340, x0
  csrrc  x20,    0x340, x1
  csrrs  x20,    0x340, x1
  csrrw  x20,    0x340, x1
  csrrc  x20,    0x340, x2
  csrrs  x20,    0x340, x2
  csrrw  x20,    0x340, x2
  csrrc  x20,    0x340, x3
  csrrs  x20,    0x340, x3
  csrrw  x20,    0x340, x3
  csrrc  x20,    0x340, x4
  csrrs  x20,    0x340, x4
  csrrw  x20,    0x340, x4
  csrrc  x20,    0x340, x5
  csrrs  x20,    0x340, x5
  csrrw  x20,    0x340, x5
  csrrc  x20,    0x340, x6
  csrrs  x20,    0x340, x6
  csrrw  x20,    0x340, x6
  csrrc  x20,    0x340, x7
  csrrs  x20,    0x340, x7
  csrrw  x20,    0x340, x7
  csrrc  x20,    0x340, x8
  csrrs  x20,    0x340, x8
  csrrw  x20,    0x340, x8
  csrrc  x20,    0x340, x9
  csrrs  x20,    0x340, x9
  csrrw  x20,    0x340, x9
  csrrc  x20,    0x340, x10
  csrrs  x20,    0x340, x10
  csrrw  x20,    0x340, x10
  csrrc  x20,    0x340, x11
  csrrs  x20,    0x340, x11
  csrrw  x20,    0x340, x11
  csrrc  x20,    0x340, x12
  csrrs  x20,    0x340, x12
  csrrw  x20,    0x340, x12
  csrrc  x20,    0x340, x13
  csrrs  x20,    0x340, x13
  csrrw  x20,    0x340, x13
  csrrc  x20,    0x340, x14
  csrrs  x20,    0x340, x14
  csrrw  x20,    0x340, x14
  csrrc  x20,    0x340, x15
  csrrs  x20,    0x340, x15
  csrrw  x20,    0x340, x15
  csrrc  x20,    0x340, x16
  csrrs  x20,    0x340, x16
  csrrw  x20,    0x340, x16
  csrrc  x20,    0x340, x17
  csrrs  x20,    0x340, x17
  csrrw  x20,    0x340, x17
  csrrc  x20,    0x340, x18
  csrrs  x20,    0x340, x18
  csrrw  x20,    0x340, x18
  csrrc  x20,    0x340, x19
  csrrs  x20,    0x340, x19
  csrrw  x20,    0x340, x19
  csrrc  x20,    0x340, x20
  csrrs  x20,    0x340, x20
  csrrw  x20,    0x340, x20
  csrrc  x20,    0x340, x21
  csrrs  x20,    0x340, x21
  csrrw  x20,    0x340, x21
  csrrc  x20,    0x340, x22
  csrrs  x20,    0x340, x22
  csrrw  x20,    0x340, x22
  csrrc  x20,    0x340, x23
  csrrs  x20,    0x340, x23
  csrrw  x20,    0x340, x23
  csrrc  x20,    0x340, x24
  csrrs  x20,    0x340, x24
  csrrw  x20,    0x340, x24
  csrrc  x20,    0x340, x25
  csrrs  x20,    0x340, x25
  csrrw  x20,    0x340, x25
  csrrc  x20,    0x340, x26
  csrrs  x20,    0x340, x26
  csrrw  x20,    0x340, x26
  csrrc  x20,    0x340, x27
  csrrs  x20,    0x340, x27
  csrrw  x20,    0x340, x27
  csrrc  x20,    0x340, x28
  csrrs  x20,    0x340, x28
  csrrw  x20,    0x340, x28
  csrrc  x20,    0x340, x29
  csrrs  x20,    0x340, x29
  csrrw  x20,    0x340, x29
  csrrc  x20,    0x340, x30
  csrrs  x20,    0x340, x30
  csrrw  x20,    0x340, x30
  csrrc  x20,    0x340, x31
  csrrs  x20,    0x340, x31
  csrrw  x20,    0x340, x31

  csrrc  x21,    0x340, x0
  csrrs  x21,    0x340, x0
  csrrw  x21,    0x340, x0
  csrrc  x21,    0x340, x1
  csrrs  x21,    0x340, x1
  csrrw  x21,    0x340, x1
  csrrc  x21,    0x340, x2
  csrrs  x21,    0x340, x2
  csrrw  x21,    0x340, x2
  csrrc  x21,    0x340, x3
  csrrs  x21,    0x340, x3
  csrrw  x21,    0x340, x3
  csrrc  x21,    0x340, x4
  csrrs  x21,    0x340, x4
  csrrw  x21,    0x340, x4
  csrrc  x21,    0x340, x5
  csrrs  x21,    0x340, x5
  csrrw  x21,    0x340, x5
  csrrc  x21,    0x340, x6
  csrrs  x21,    0x340, x6
  csrrw  x21,    0x340, x6
  csrrc  x21,    0x340, x7
  csrrs  x21,    0x340, x7
  csrrw  x21,    0x340, x7
  csrrc  x21,    0x340, x8
  csrrs  x21,    0x340, x8
  csrrw  x21,    0x340, x8
  csrrc  x21,    0x340, x9
  csrrs  x21,    0x340, x9
  csrrw  x21,    0x340, x9
  csrrc  x21,    0x340, x10
  csrrs  x21,    0x340, x10
  csrrw  x21,    0x340, x10
  csrrc  x21,    0x340, x11
  csrrs  x21,    0x340, x11
  csrrw  x21,    0x340, x11
  csrrc  x21,    0x340, x12
  csrrs  x21,    0x340, x12
  csrrw  x21,    0x340, x12
  csrrc  x21,    0x340, x13
  csrrs  x21,    0x340, x13
  csrrw  x21,    0x340, x13
  csrrc  x21,    0x340, x14
  csrrs  x21,    0x340, x14
  csrrw  x21,    0x340, x14
  csrrc  x21,    0x340, x15
  csrrs  x21,    0x340, x15
  csrrw  x21,    0x340, x15
  csrrc  x21,    0x340, x16
  csrrs  x21,    0x340, x16
  csrrw  x21,    0x340, x16
  csrrc  x21,    0x340, x17
  csrrs  x21,    0x340, x17
  csrrw  x21,    0x340, x17
  csrrc  x21,    0x340, x18
  csrrs  x21,    0x340, x18
  csrrw  x21,    0x340, x18
  csrrc  x21,    0x340, x19
  csrrs  x21,    0x340, x19
  csrrw  x21,    0x340, x19
  csrrc  x21,    0x340, x20
  csrrs  x21,    0x340, x20
  csrrw  x21,    0x340, x20
  csrrc  x21,    0x340, x21
  csrrs  x21,    0x340, x21
  csrrw  x21,    0x340, x21
  csrrc  x21,    0x340, x22
  csrrs  x21,    0x340, x22
  csrrw  x21,    0x340, x22
  csrrc  x21,    0x340, x23
  csrrs  x21,    0x340, x23
  csrrw  x21,    0x340, x23
  csrrc  x21,    0x340, x24
  csrrs  x21,    0x340, x24
  csrrw  x21,    0x340, x24
  csrrc  x21,    0x340, x25
  csrrs  x21,    0x340, x25
  csrrw  x21,    0x340, x25
  csrrc  x21,    0x340, x26
  csrrs  x21,    0x340, x26
  csrrw  x21,    0x340, x26
  csrrc  x21,    0x340, x27
  csrrs  x21,    0x340, x27
  csrrw  x21,    0x340, x27
  csrrc  x21,    0x340, x28
  csrrs  x21,    0x340, x28
  csrrw  x21,    0x340, x28
  csrrc  x21,    0x340, x29
  csrrs  x21,    0x340, x29
  csrrw  x21,    0x340, x29
  csrrc  x21,    0x340, x30
  csrrs  x21,    0x340, x30
  csrrw  x21,    0x340, x30
  csrrc  x21,    0x340, x31
  csrrs  x21,    0x340, x31
  csrrw  x21,    0x340, x31

  csrrc  x22,    0x340, x0
  csrrs  x22,    0x340, x0
  csrrw  x22,    0x340, x0
  csrrc  x22,    0x340, x1
  csrrs  x22,    0x340, x1
  csrrw  x22,    0x340, x1
  csrrc  x22,    0x340, x2
  csrrs  x22,    0x340, x2
  csrrw  x22,    0x340, x2
  csrrc  x22,    0x340, x3
  csrrs  x22,    0x340, x3
  csrrw  x22,    0x340, x3
  csrrc  x22,    0x340, x4
  csrrs  x22,    0x340, x4
  csrrw  x22,    0x340, x4
  csrrc  x22,    0x340, x5
  csrrs  x22,    0x340, x5
  csrrw  x22,    0x340, x5
  csrrc  x22,    0x340, x6
  csrrs  x22,    0x340, x6
  csrrw  x22,    0x340, x6
  csrrc  x22,    0x340, x7
  csrrs  x22,    0x340, x7
  csrrw  x22,    0x340, x7
  csrrc  x22,    0x340, x8
  csrrs  x22,    0x340, x8
  csrrw  x22,    0x340, x8
  csrrc  x22,    0x340, x9
  csrrs  x22,    0x340, x9
  csrrw  x22,    0x340, x9
  csrrc  x22,    0x340, x10
  csrrs  x22,    0x340, x10
  csrrw  x22,    0x340, x10
  csrrc  x22,    0x340, x11
  csrrs  x22,    0x340, x11
  csrrw  x22,    0x340, x11
  csrrc  x22,    0x340, x12
  csrrs  x22,    0x340, x12
  csrrw  x22,    0x340, x12
  csrrc  x22,    0x340, x13
  csrrs  x22,    0x340, x13
  csrrw  x22,    0x340, x13
  csrrc  x22,    0x340, x14
  csrrs  x22,    0x340, x14
  csrrw  x22,    0x340, x14
  csrrc  x22,    0x340, x15
  csrrs  x22,    0x340, x15
  csrrw  x22,    0x340, x15
  csrrc  x22,    0x340, x16
  csrrs  x22,    0x340, x16
  csrrw  x22,    0x340, x16
  csrrc  x22,    0x340, x17
  csrrs  x22,    0x340, x17
  csrrw  x22,    0x340, x17
  csrrc  x22,    0x340, x18
  csrrs  x22,    0x340, x18
  csrrw  x22,    0x340, x18
  csrrc  x22,    0x340, x19
  csrrs  x22,    0x340, x19
  csrrw  x22,    0x340, x19
  csrrc  x22,    0x340, x20
  csrrs  x22,    0x340, x20
  csrrw  x22,    0x340, x20
  csrrc  x22,    0x340, x21
  csrrs  x22,    0x340, x21
  csrrw  x22,    0x340, x21
  csrrc  x22,    0x340, x22
  csrrs  x22,    0x340, x22
  csrrw  x22,    0x340, x22
  csrrc  x22,    0x340, x23
  csrrs  x22,    0x340, x23
  csrrw  x22,    0x340, x23
  csrrc  x22,    0x340, x24
  csrrs  x22,    0x340, x24
  csrrw  x22,    0x340, x24
  csrrc  x22,    0x340, x25
  csrrs  x22,    0x340, x25
  csrrw  x22,    0x340, x25
  csrrc  x22,    0x340, x26
  csrrs  x22,    0x340, x26
  csrrw  x22,    0x340, x26
  csrrc  x22,    0x340, x27
  csrrs  x22,    0x340, x27
  csrrw  x22,    0x340, x27
  csrrc  x22,    0x340, x28
  csrrs  x22,    0x340, x28
  csrrw  x22,    0x340, x28
  csrrc  x22,    0x340, x29
  csrrs  x22,    0x340, x29
  csrrw  x22,    0x340, x29
  csrrc  x22,    0x340, x30
  csrrs  x22,    0x340, x30
  csrrw  x22,    0x340, x30
  csrrc  x22,    0x340, x31
  csrrs  x22,    0x340, x31
  csrrw  x22,    0x340, x31

  csrrc  x23,    0x340, x0
  csrrs  x23,    0x340, x0
  csrrw  x23,    0x340, x0
  csrrc  x23,    0x340, x1
  csrrs  x23,    0x340, x1
  csrrw  x23,    0x340, x1
  csrrc  x23,    0x340, x2
  csrrs  x23,    0x340, x2
  csrrw  x23,    0x340, x2
  csrrc  x23,    0x340, x3
  csrrs  x23,    0x340, x3
  csrrw  x23,    0x340, x3
  csrrc  x23,    0x340, x4
  csrrs  x23,    0x340, x4
  csrrw  x23,    0x340, x4
  csrrc  x23,    0x340, x5
  csrrs  x23,    0x340, x5
  csrrw  x23,    0x340, x5
  csrrc  x23,    0x340, x6
  csrrs  x23,    0x340, x6
  csrrw  x23,    0x340, x6
  csrrc  x23,    0x340, x7
  csrrs  x23,    0x340, x7
  csrrw  x23,    0x340, x7
  csrrc  x23,    0x340, x8
  csrrs  x23,    0x340, x8
  csrrw  x23,    0x340, x8
  csrrc  x23,    0x340, x9
  csrrs  x23,    0x340, x9
  csrrw  x23,    0x340, x9
  csrrc  x23,    0x340, x10
  csrrs  x23,    0x340, x10
  csrrw  x23,    0x340, x10
  csrrc  x23,    0x340, x11
  csrrs  x23,    0x340, x11
  csrrw  x23,    0x340, x11
  csrrc  x23,    0x340, x12
  csrrs  x23,    0x340, x12
  csrrw  x23,    0x340, x12
  csrrc  x23,    0x340, x13
  csrrs  x23,    0x340, x13
  csrrw  x23,    0x340, x13
  csrrc  x23,    0x340, x14
  csrrs  x23,    0x340, x14
  csrrw  x23,    0x340, x14
  csrrc  x23,    0x340, x15
  csrrs  x23,    0x340, x15
  csrrw  x23,    0x340, x15
  csrrc  x23,    0x340, x16
  csrrs  x23,    0x340, x16
  csrrw  x23,    0x340, x16
  csrrc  x23,    0x340, x17
  csrrs  x23,    0x340, x17
  csrrw  x23,    0x340, x17
  csrrc  x23,    0x340, x18
  csrrs  x23,    0x340, x18
  csrrw  x23,    0x340, x18
  csrrc  x23,    0x340, x19
  csrrs  x23,    0x340, x19
  csrrw  x23,    0x340, x19
  csrrc  x23,    0x340, x20
  csrrs  x23,    0x340, x20
  csrrw  x23,    0x340, x20
  csrrc  x23,    0x340, x21
  csrrs  x23,    0x340, x21
  csrrw  x23,    0x340, x21
  csrrc  x23,    0x340, x22
  csrrs  x23,    0x340, x22
  csrrw  x23,    0x340, x22
  csrrc  x23,    0x340, x23
  csrrs  x23,    0x340, x23
  csrrw  x23,    0x340, x23
  csrrc  x23,    0x340, x24
  csrrs  x23,    0x340, x24
  csrrw  x23,    0x340, x24
  csrrc  x23,    0x340, x25
  csrrs  x23,    0x340, x25
  csrrw  x23,    0x340, x25
  csrrc  x23,    0x340, x26
  csrrs  x23,    0x340, x26
  csrrw  x23,    0x340, x26
  csrrc  x23,    0x340, x27
  csrrs  x23,    0x340, x27
  csrrw  x23,    0x340, x27
  csrrc  x23,    0x340, x28
  csrrs  x23,    0x340, x28
  csrrw  x23,    0x340, x28
  csrrc  x23,    0x340, x29
  csrrs  x23,    0x340, x29
  csrrw  x23,    0x340, x29
  csrrc  x23,    0x340, x30
  csrrs  x23,    0x340, x30
  csrrw  x23,    0x340, x30
  csrrc  x23,    0x340, x31
  csrrs  x23,    0x340, x31
  csrrw  x23,    0x340, x31

  csrrc  x24,    0x340, x0
  csrrs  x24,    0x340, x0
  csrrw  x24,    0x340, x0
  csrrc  x24,    0x340, x1
  csrrs  x24,    0x340, x1
  csrrw  x24,    0x340, x1
  csrrc  x24,    0x340, x2
  csrrs  x24,    0x340, x2
  csrrw  x24,    0x340, x2
  csrrc  x24,    0x340, x3
  csrrs  x24,    0x340, x3
  csrrw  x24,    0x340, x3
  csrrc  x24,    0x340, x4
  csrrs  x24,    0x340, x4
  csrrw  x24,    0x340, x4
  csrrc  x24,    0x340, x5
  csrrs  x24,    0x340, x5
  csrrw  x24,    0x340, x5
  csrrc  x24,    0x340, x6
  csrrs  x24,    0x340, x6
  csrrw  x24,    0x340, x6
  csrrc  x24,    0x340, x7
  csrrs  x24,    0x340, x7
  csrrw  x24,    0x340, x7
  csrrc  x24,    0x340, x8
  csrrs  x24,    0x340, x8
  csrrw  x24,    0x340, x8
  csrrc  x24,    0x340, x9
  csrrs  x24,    0x340, x9
  csrrw  x24,    0x340, x9
  csrrc  x24,    0x340, x10
  csrrs  x24,    0x340, x10
  csrrw  x24,    0x340, x10
  csrrc  x24,    0x340, x11
  csrrs  x24,    0x340, x11
  csrrw  x24,    0x340, x11
  csrrc  x24,    0x340, x12
  csrrs  x24,    0x340, x12
  csrrw  x24,    0x340, x12
  csrrc  x24,    0x340, x13
  csrrs  x24,    0x340, x13
  csrrw  x24,    0x340, x13
  csrrc  x24,    0x340, x14
  csrrs  x24,    0x340, x14
  csrrw  x24,    0x340, x14
  csrrc  x24,    0x340, x15
  csrrs  x24,    0x340, x15
  csrrw  x24,    0x340, x15
  csrrc  x24,    0x340, x16
  csrrs  x24,    0x340, x16
  csrrw  x24,    0x340, x16
  csrrc  x24,    0x340, x17
  csrrs  x24,    0x340, x17
  csrrw  x24,    0x340, x17
  csrrc  x24,    0x340, x18
  csrrs  x24,    0x340, x18
  csrrw  x24,    0x340, x18
  csrrc  x24,    0x340, x19
  csrrs  x24,    0x340, x19
  csrrw  x24,    0x340, x19
  csrrc  x24,    0x340, x20
  csrrs  x24,    0x340, x20
  csrrw  x24,    0x340, x20
  csrrc  x24,    0x340, x21
  csrrs  x24,    0x340, x21
  csrrw  x24,    0x340, x21
  csrrc  x24,    0x340, x22
  csrrs  x24,    0x340, x22
  csrrw  x24,    0x340, x22
  csrrc  x24,    0x340, x23
  csrrs  x24,    0x340, x23
  csrrw  x24,    0x340, x23
  csrrc  x24,    0x340, x24
  csrrs  x24,    0x340, x24
  csrrw  x24,    0x340, x24
  csrrc  x24,    0x340, x25
  csrrs  x24,    0x340, x25
  csrrw  x24,    0x340, x25
  csrrc  x24,    0x340, x26
  csrrs  x24,    0x340, x26
  csrrw  x24,    0x340, x26
  csrrc  x24,    0x340, x27
  csrrs  x24,    0x340, x27
  csrrw  x24,    0x340, x27
  csrrc  x24,    0x340, x28
  csrrs  x24,    0x340, x28
  csrrw  x24,    0x340, x28
  csrrc  x24,    0x340, x29
  csrrs  x24,    0x340, x29
  csrrw  x24,    0x340, x29
  csrrc  x24,    0x340, x30
  csrrs  x24,    0x340, x30
  csrrw  x24,    0x340, x30
  csrrc  x24,    0x340, x31
  csrrs  x24,    0x340, x31
  csrrw  x24,    0x340, x31

  csrrc  x25,    0x340, x0
  csrrs  x25,    0x340, x0
  csrrw  x25,    0x340, x0
  csrrc  x25,    0x340, x1
  csrrs  x25,    0x340, x1
  csrrw  x25,    0x340, x1
  csrrc  x25,    0x340, x2
  csrrs  x25,    0x340, x2
  csrrw  x25,    0x340, x2
  csrrc  x25,    0x340, x3
  csrrs  x25,    0x340, x3
  csrrw  x25,    0x340, x3
  csrrc  x25,    0x340, x4
  csrrs  x25,    0x340, x4
  csrrw  x25,    0x340, x4
  csrrc  x25,    0x340, x5
  csrrs  x25,    0x340, x5
  csrrw  x25,    0x340, x5
  csrrc  x25,    0x340, x6
  csrrs  x25,    0x340, x6
  csrrw  x25,    0x340, x6
  csrrc  x25,    0x340, x7
  csrrs  x25,    0x340, x7
  csrrw  x25,    0x340, x7
  csrrc  x25,    0x340, x8
  csrrs  x25,    0x340, x8
  csrrw  x25,    0x340, x8
  csrrc  x25,    0x340, x9
  csrrs  x25,    0x340, x9
  csrrw  x25,    0x340, x9
  csrrc  x25,    0x340, x10
  csrrs  x25,    0x340, x10
  csrrw  x25,    0x340, x10
  csrrc  x25,    0x340, x11
  csrrs  x25,    0x340, x11
  csrrw  x25,    0x340, x11
  csrrc  x25,    0x340, x12
  csrrs  x25,    0x340, x12
  csrrw  x25,    0x340, x12
  csrrc  x25,    0x340, x13
  csrrs  x25,    0x340, x13
  csrrw  x25,    0x340, x13
  csrrc  x25,    0x340, x14
  csrrs  x25,    0x340, x14
  csrrw  x25,    0x340, x14
  csrrc  x25,    0x340, x15
  csrrs  x25,    0x340, x15
  csrrw  x25,    0x340, x15
  csrrc  x25,    0x340, x16
  csrrs  x25,    0x340, x16
  csrrw  x25,    0x340, x16
  csrrc  x25,    0x340, x17
  csrrs  x25,    0x340, x17
  csrrw  x25,    0x340, x17
  csrrc  x25,    0x340, x18
  csrrs  x25,    0x340, x18
  csrrw  x25,    0x340, x18
  csrrc  x25,    0x340, x19
  csrrs  x25,    0x340, x19
  csrrw  x25,    0x340, x19
  csrrc  x25,    0x340, x20
  csrrs  x25,    0x340, x20
  csrrw  x25,    0x340, x20
  csrrc  x25,    0x340, x21
  csrrs  x25,    0x340, x21
  csrrw  x25,    0x340, x21
  csrrc  x25,    0x340, x22
  csrrs  x25,    0x340, x22
  csrrw  x25,    0x340, x22
  csrrc  x25,    0x340, x23
  csrrs  x25,    0x340, x23
  csrrw  x25,    0x340, x23
  csrrc  x25,    0x340, x24
  csrrs  x25,    0x340, x24
  csrrw  x25,    0x340, x24
  csrrc  x25,    0x340, x25
  csrrs  x25,    0x340, x25
  csrrw  x25,    0x340, x25
  csrrc  x25,    0x340, x26
  csrrs  x25,    0x340, x26
  csrrw  x25,    0x340, x26
  csrrc  x25,    0x340, x27
  csrrs  x25,    0x340, x27
  csrrw  x25,    0x340, x27
  csrrc  x25,    0x340, x28
  csrrs  x25,    0x340, x28
  csrrw  x25,    0x340, x28
  csrrc  x25,    0x340, x29
  csrrs  x25,    0x340, x29
  csrrw  x25,    0x340, x29
  csrrc  x25,    0x340, x30
  csrrs  x25,    0x340, x30
  csrrw  x25,    0x340, x30
  csrrc  x25,    0x340, x31
  csrrs  x25,    0x340, x31
  csrrw  x25,    0x340, x31

  csrrc  x26,    0x340, x0
  csrrs  x26,    0x340, x0
  csrrw  x26,    0x340, x0
  csrrc  x26,    0x340, x1
  csrrs  x26,    0x340, x1
  csrrw  x26,    0x340, x1
  csrrc  x26,    0x340, x2
  csrrs  x26,    0x340, x2
  csrrw  x26,    0x340, x2
  csrrc  x26,    0x340, x3
  csrrs  x26,    0x340, x3
  csrrw  x26,    0x340, x3
  csrrc  x26,    0x340, x4
  csrrs  x26,    0x340, x4
  csrrw  x26,    0x340, x4
  csrrc  x26,    0x340, x5
  csrrs  x26,    0x340, x5
  csrrw  x26,    0x340, x5
  csrrc  x26,    0x340, x6
  csrrs  x26,    0x340, x6
  csrrw  x26,    0x340, x6
  csrrc  x26,    0x340, x7
  csrrs  x26,    0x340, x7
  csrrw  x26,    0x340, x7
  csrrc  x26,    0x340, x8
  csrrs  x26,    0x340, x8
  csrrw  x26,    0x340, x8
  csrrc  x26,    0x340, x9
  csrrs  x26,    0x340, x9
  csrrw  x26,    0x340, x9
  csrrc  x26,    0x340, x10
  csrrs  x26,    0x340, x10
  csrrw  x26,    0x340, x10
  csrrc  x26,    0x340, x11
  csrrs  x26,    0x340, x11
  csrrw  x26,    0x340, x11
  csrrc  x26,    0x340, x12
  csrrs  x26,    0x340, x12
  csrrw  x26,    0x340, x12
  csrrc  x26,    0x340, x13
  csrrs  x26,    0x340, x13
  csrrw  x26,    0x340, x13
  csrrc  x26,    0x340, x14
  csrrs  x26,    0x340, x14
  csrrw  x26,    0x340, x14
  csrrc  x26,    0x340, x15
  csrrs  x26,    0x340, x15
  csrrw  x26,    0x340, x15
  csrrc  x26,    0x340, x16
  csrrs  x26,    0x340, x16
  csrrw  x26,    0x340, x16
  csrrc  x26,    0x340, x17
  csrrs  x26,    0x340, x17
  csrrw  x26,    0x340, x17
  csrrc  x26,    0x340, x18
  csrrs  x26,    0x340, x18
  csrrw  x26,    0x340, x18
  csrrc  x26,    0x340, x19
  csrrs  x26,    0x340, x19
  csrrw  x26,    0x340, x19
  csrrc  x26,    0x340, x20
  csrrs  x26,    0x340, x20
  csrrw  x26,    0x340, x20
  csrrc  x26,    0x340, x21
  csrrs  x26,    0x340, x21
  csrrw  x26,    0x340, x21
  csrrc  x26,    0x340, x22
  csrrs  x26,    0x340, x22
  csrrw  x26,    0x340, x22
  csrrc  x26,    0x340, x23
  csrrs  x26,    0x340, x23
  csrrw  x26,    0x340, x23
  csrrc  x26,    0x340, x24
  csrrs  x26,    0x340, x24
  csrrw  x26,    0x340, x24
  csrrc  x26,    0x340, x25
  csrrs  x26,    0x340, x25
  csrrw  x26,    0x340, x25
  csrrc  x26,    0x340, x26
  csrrs  x26,    0x340, x26
  csrrw  x26,    0x340, x26
  csrrc  x26,    0x340, x27
  csrrs  x26,    0x340, x27
  csrrw  x26,    0x340, x27
  csrrc  x26,    0x340, x28
  csrrs  x26,    0x340, x28
  csrrw  x26,    0x340, x28
  csrrc  x26,    0x340, x29
  csrrs  x26,    0x340, x29
  csrrw  x26,    0x340, x29
  csrrc  x26,    0x340, x30
  csrrs  x26,    0x340, x30
  csrrw  x26,    0x340, x30
  csrrc  x26,    0x340, x31
  csrrs  x26,    0x340, x31
  csrrw  x26,    0x340, x31

  csrrc  x27,    0x340, x0
  csrrs  x27,    0x340, x0
  csrrw  x27,    0x340, x0
  csrrc  x27,    0x340, x1
  csrrs  x27,    0x340, x1
  csrrw  x27,    0x340, x1
  csrrc  x27,    0x340, x2
  csrrs  x27,    0x340, x2
  csrrw  x27,    0x340, x2
  csrrc  x27,    0x340, x3
  csrrs  x27,    0x340, x3
  csrrw  x27,    0x340, x3
  csrrc  x27,    0x340, x4
  csrrs  x27,    0x340, x4
  csrrw  x27,    0x340, x4
  csrrc  x27,    0x340, x5
  csrrs  x27,    0x340, x5
  csrrw  x27,    0x340, x5
  csrrc  x27,    0x340, x6
  csrrs  x27,    0x340, x6
  csrrw  x27,    0x340, x6
  csrrc  x27,    0x340, x7
  csrrs  x27,    0x340, x7
  csrrw  x27,    0x340, x7
  csrrc  x27,    0x340, x8
  csrrs  x27,    0x340, x8
  csrrw  x27,    0x340, x8
  csrrc  x27,    0x340, x9
  csrrs  x27,    0x340, x9
  csrrw  x27,    0x340, x9
  csrrc  x27,    0x340, x10
  csrrs  x27,    0x340, x10
  csrrw  x27,    0x340, x10
  csrrc  x27,    0x340, x11
  csrrs  x27,    0x340, x11
  csrrw  x27,    0x340, x11
  csrrc  x27,    0x340, x12
  csrrs  x27,    0x340, x12
  csrrw  x27,    0x340, x12
  csrrc  x27,    0x340, x13
  csrrs  x27,    0x340, x13
  csrrw  x27,    0x340, x13
  csrrc  x27,    0x340, x14
  csrrs  x27,    0x340, x14
  csrrw  x27,    0x340, x14
  csrrc  x27,    0x340, x15
  csrrs  x27,    0x340, x15
  csrrw  x27,    0x340, x15
  csrrc  x27,    0x340, x16
  csrrs  x27,    0x340, x16
  csrrw  x27,    0x340, x16
  csrrc  x27,    0x340, x17
  csrrs  x27,    0x340, x17
  csrrw  x27,    0x340, x17
  csrrc  x27,    0x340, x18
  csrrs  x27,    0x340, x18
  csrrw  x27,    0x340, x18
  csrrc  x27,    0x340, x19
  csrrs  x27,    0x340, x19
  csrrw  x27,    0x340, x19
  csrrc  x27,    0x340, x20
  csrrs  x27,    0x340, x20
  csrrw  x27,    0x340, x20
  csrrc  x27,    0x340, x21
  csrrs  x27,    0x340, x21
  csrrw  x27,    0x340, x21
  csrrc  x27,    0x340, x22
  csrrs  x27,    0x340, x22
  csrrw  x27,    0x340, x22
  csrrc  x27,    0x340, x23
  csrrs  x27,    0x340, x23
  csrrw  x27,    0x340, x23
  csrrc  x27,    0x340, x24
  csrrs  x27,    0x340, x24
  csrrw  x27,    0x340, x24
  csrrc  x27,    0x340, x25
  csrrs  x27,    0x340, x25
  csrrw  x27,    0x340, x25
  csrrc  x27,    0x340, x26
  csrrs  x27,    0x340, x26
  csrrw  x27,    0x340, x26
  csrrc  x27,    0x340, x27
  csrrs  x27,    0x340, x27
  csrrw  x27,    0x340, x27
  csrrc  x27,    0x340, x28
  csrrs  x27,    0x340, x28
  csrrw  x27,    0x340, x28
  csrrc  x27,    0x340, x29
  csrrs  x27,    0x340, x29
  csrrw  x27,    0x340, x29
  csrrc  x27,    0x340, x30
  csrrs  x27,    0x340, x30
  csrrw  x27,    0x340, x30
  csrrc  x27,    0x340, x31
  csrrs  x27,    0x340, x31
  csrrw  x27,    0x340, x31

  csrrc  x28,    0x340, x0
  csrrs  x28,    0x340, x0
  csrrw  x28,    0x340, x0
  csrrc  x28,    0x340, x1
  csrrs  x28,    0x340, x1
  csrrw  x28,    0x340, x1
  csrrc  x28,    0x340, x2
  csrrs  x28,    0x340, x2
  csrrw  x28,    0x340, x2
  csrrc  x28,    0x340, x3
  csrrs  x28,    0x340, x3
  csrrw  x28,    0x340, x3
  csrrc  x28,    0x340, x4
  csrrs  x28,    0x340, x4
  csrrw  x28,    0x340, x4
  csrrc  x28,    0x340, x5
  csrrs  x28,    0x340, x5
  csrrw  x28,    0x340, x5
  csrrc  x28,    0x340, x6
  csrrs  x28,    0x340, x6
  csrrw  x28,    0x340, x6
  csrrc  x28,    0x340, x7
  csrrs  x28,    0x340, x7
  csrrw  x28,    0x340, x7
  csrrc  x28,    0x340, x8
  csrrs  x28,    0x340, x8
  csrrw  x28,    0x340, x8
  csrrc  x28,    0x340, x9
  csrrs  x28,    0x340, x9
  csrrw  x28,    0x340, x9
  csrrc  x28,    0x340, x10
  csrrs  x28,    0x340, x10
  csrrw  x28,    0x340, x10
  csrrc  x28,    0x340, x11
  csrrs  x28,    0x340, x11
  csrrw  x28,    0x340, x11
  csrrc  x28,    0x340, x12
  csrrs  x28,    0x340, x12
  csrrw  x28,    0x340, x12
  csrrc  x28,    0x340, x13
  csrrs  x28,    0x340, x13
  csrrw  x28,    0x340, x13
  csrrc  x28,    0x340, x14
  csrrs  x28,    0x340, x14
  csrrw  x28,    0x340, x14
  csrrc  x28,    0x340, x15
  csrrs  x28,    0x340, x15
  csrrw  x28,    0x340, x15
  csrrc  x28,    0x340, x16
  csrrs  x28,    0x340, x16
  csrrw  x28,    0x340, x16
  csrrc  x28,    0x340, x17
  csrrs  x28,    0x340, x17
  csrrw  x28,    0x340, x17
  csrrc  x28,    0x340, x18
  csrrs  x28,    0x340, x18
  csrrw  x28,    0x340, x18
  csrrc  x28,    0x340, x19
  csrrs  x28,    0x340, x19
  csrrw  x28,    0x340, x19
  csrrc  x28,    0x340, x20
  csrrs  x28,    0x340, x20
  csrrw  x28,    0x340, x20
  csrrc  x28,    0x340, x21
  csrrs  x28,    0x340, x21
  csrrw  x28,    0x340, x21
  csrrc  x28,    0x340, x22
  csrrs  x28,    0x340, x22
  csrrw  x28,    0x340, x22
  csrrc  x28,    0x340, x23
  csrrs  x28,    0x340, x23
  csrrw  x28,    0x340, x23
  csrrc  x28,    0x340, x24
  csrrs  x28,    0x340, x24
  csrrw  x28,    0x340, x24
  csrrc  x28,    0x340, x25
  csrrs  x28,    0x340, x25
  csrrw  x28,    0x340, x25
  csrrc  x28,    0x340, x26
  csrrs  x28,    0x340, x26
  csrrw  x28,    0x340, x26
  csrrc  x28,    0x340, x27
  csrrs  x28,    0x340, x27
  csrrw  x28,    0x340, x27
  csrrc  x28,    0x340, x28
  csrrs  x28,    0x340, x28
  csrrw  x28,    0x340, x28
  csrrc  x28,    0x340, x29
  csrrs  x28,    0x340, x29
  csrrw  x28,    0x340, x29
  csrrc  x28,    0x340, x30
  csrrs  x28,    0x340, x30
  csrrw  x28,    0x340, x30
  csrrc  x28,    0x340, x31
  csrrs  x28,    0x340, x31
  csrrw  x28,    0x340, x31

  csrrc  x29,    0x340, x0
  csrrs  x29,    0x340, x0
  csrrw  x29,    0x340, x0
  csrrc  x29,    0x340, x1
  csrrs  x29,    0x340, x1
  csrrw  x29,    0x340, x1
  csrrc  x29,    0x340, x2
  csrrs  x29,    0x340, x2
  csrrw  x29,    0x340, x2
  csrrc  x29,    0x340, x3
  csrrs  x29,    0x340, x3
  csrrw  x29,    0x340, x3
  csrrc  x29,    0x340, x4
  csrrs  x29,    0x340, x4
  csrrw  x29,    0x340, x4
  csrrc  x29,    0x340, x5
  csrrs  x29,    0x340, x5
  csrrw  x29,    0x340, x5
  csrrc  x29,    0x340, x6
  csrrs  x29,    0x340, x6
  csrrw  x29,    0x340, x6
  csrrc  x29,    0x340, x7
  csrrs  x29,    0x340, x7
  csrrw  x29,    0x340, x7
  csrrc  x29,    0x340, x8
  csrrs  x29,    0x340, x8
  csrrw  x29,    0x340, x8
  csrrc  x29,    0x340, x9
  csrrs  x29,    0x340, x9
  csrrw  x29,    0x340, x9
  csrrc  x29,    0x340, x10
  csrrs  x29,    0x340, x10
  csrrw  x29,    0x340, x10
  csrrc  x29,    0x340, x11
  csrrs  x29,    0x340, x11
  csrrw  x29,    0x340, x11
  csrrc  x29,    0x340, x12
  csrrs  x29,    0x340, x12
  csrrw  x29,    0x340, x12
  csrrc  x29,    0x340, x13
  csrrs  x29,    0x340, x13
  csrrw  x29,    0x340, x13
  csrrc  x29,    0x340, x14
  csrrs  x29,    0x340, x14
  csrrw  x29,    0x340, x14
  csrrc  x29,    0x340, x15
  csrrs  x29,    0x340, x15
  csrrw  x29,    0x340, x15
  csrrc  x29,    0x340, x16
  csrrs  x29,    0x340, x16
  csrrw  x29,    0x340, x16
  csrrc  x29,    0x340, x17
  csrrs  x29,    0x340, x17
  csrrw  x29,    0x340, x17
  csrrc  x29,    0x340, x18
  csrrs  x29,    0x340, x18
  csrrw  x29,    0x340, x18
  csrrc  x29,    0x340, x19
  csrrs  x29,    0x340, x19
  csrrw  x29,    0x340, x19
  csrrc  x29,    0x340, x20
  csrrs  x29,    0x340, x20
  csrrw  x29,    0x340, x20
  csrrc  x29,    0x340, x21
  csrrs  x29,    0x340, x21
  csrrw  x29,    0x340, x21
  csrrc  x29,    0x340, x22
  csrrs  x29,    0x340, x22
  csrrw  x29,    0x340, x22
  csrrc  x29,    0x340, x23
  csrrs  x29,    0x340, x23
  csrrw  x29,    0x340, x23
  csrrc  x29,    0x340, x24
  csrrs  x29,    0x340, x24
  csrrw  x29,    0x340, x24
  csrrc  x29,    0x340, x25
  csrrs  x29,    0x340, x25
  csrrw  x29,    0x340, x25
  csrrc  x29,    0x340, x26
  csrrs  x29,    0x340, x26
  csrrw  x29,    0x340, x26
  csrrc  x29,    0x340, x27
  csrrs  x29,    0x340, x27
  csrrw  x29,    0x340, x27
  csrrc  x29,    0x340, x28
  csrrs  x29,    0x340, x28
  csrrw  x29,    0x340, x28
  csrrc  x29,    0x340, x29
  csrrs  x29,    0x340, x29
  csrrw  x29,    0x340, x29
  csrrc  x29,    0x340, x30
  csrrs  x29,    0x340, x30
  csrrw  x29,    0x340, x30
  csrrc  x29,    0x340, x31
  csrrs  x29,    0x340, x31
  csrrw  x29,    0x340, x31

  csrrc  x30,    0x340, x0
  csrrs  x30,    0x340, x0
  csrrw  x30,    0x340, x0
  csrrc  x30,    0x340, x1
  csrrs  x30,    0x340, x1
  csrrw  x30,    0x340, x1
  csrrc  x30,    0x340, x2
  csrrs  x30,    0x340, x2
  csrrw  x30,    0x340, x2
  csrrc  x30,    0x340, x3
  csrrs  x30,    0x340, x3
  csrrw  x30,    0x340, x3
  csrrc  x30,    0x340, x4
  csrrs  x30,    0x340, x4
  csrrw  x30,    0x340, x4
  csrrc  x30,    0x340, x5
  csrrs  x30,    0x340, x5
  csrrw  x30,    0x340, x5
  csrrc  x30,    0x340, x6
  csrrs  x30,    0x340, x6
  csrrw  x30,    0x340, x6
  csrrc  x30,    0x340, x7
  csrrs  x30,    0x340, x7
  csrrw  x30,    0x340, x7
  csrrc  x30,    0x340, x8
  csrrs  x30,    0x340, x8
  csrrw  x30,    0x340, x8
  csrrc  x30,    0x340, x9
  csrrs  x30,    0x340, x9
  csrrw  x30,    0x340, x9
  csrrc  x30,    0x340, x10
  csrrs  x30,    0x340, x10
  csrrw  x30,    0x340, x10
  csrrc  x30,    0x340, x11
  csrrs  x30,    0x340, x11
  csrrw  x30,    0x340, x11
  csrrc  x30,    0x340, x12
  csrrs  x30,    0x340, x12
  csrrw  x30,    0x340, x12
  csrrc  x30,    0x340, x13
  csrrs  x30,    0x340, x13
  csrrw  x30,    0x340, x13
  csrrc  x30,    0x340, x14
  csrrs  x30,    0x340, x14
  csrrw  x30,    0x340, x14
  csrrc  x30,    0x340, x15
  csrrs  x30,    0x340, x15
  csrrw  x30,    0x340, x15
  csrrc  x30,    0x340, x16
  csrrs  x30,    0x340, x16
  csrrw  x30,    0x340, x16
  csrrc  x30,    0x340, x17
  csrrs  x30,    0x340, x17
  csrrw  x30,    0x340, x17
  csrrc  x30,    0x340, x18
  csrrs  x30,    0x340, x18
  csrrw  x30,    0x340, x18
  csrrc  x30,    0x340, x19
  csrrs  x30,    0x340, x19
  csrrw  x30,    0x340, x19
  csrrc  x30,    0x340, x20
  csrrs  x30,    0x340, x20
  csrrw  x30,    0x340, x20
  csrrc  x30,    0x340, x21
  csrrs  x30,    0x340, x21
  csrrw  x30,    0x340, x21
  csrrc  x30,    0x340, x22
  csrrs  x30,    0x340, x22
  csrrw  x30,    0x340, x22
  csrrc  x30,    0x340, x23
  csrrs  x30,    0x340, x23
  csrrw  x30,    0x340, x23
  csrrc  x30,    0x340, x24
  csrrs  x30,    0x340, x24
  csrrw  x30,    0x340, x24
  csrrc  x30,    0x340, x25
  csrrs  x30,    0x340, x25
  csrrw  x30,    0x340, x25
  csrrc  x30,    0x340, x26
  csrrs  x30,    0x340, x26
  csrrw  x30,    0x340, x26
  csrrc  x30,    0x340, x27
  csrrs  x30,    0x340, x27
  csrrw  x30,    0x340, x27
  csrrc  x30,    0x340, x28
  csrrs  x30,    0x340, x28
  csrrw  x30,    0x340, x28
  csrrc  x30,    0x340, x29
  csrrs  x30,    0x340, x29
  csrrw  x30,    0x340, x29
  csrrc  x30,    0x340, x30
  csrrs  x30,    0x340, x30
  csrrw  x30,    0x340, x30
  csrrc  x30,    0x340, x31
  csrrs  x30,    0x340, x31
  csrrw  x30,    0x340, x31

  csrrc  x31,    0x340, x0
  csrrs  x31,    0x340, x0
  csrrw  x31,    0x340, x0
  csrrc  x31,    0x340, x1
  csrrs  x31,    0x340, x1
  csrrw  x31,    0x340, x1
  csrrc  x31,    0x340, x2
  csrrs  x31,    0x340, x2
  csrrw  x31,    0x340, x2
  csrrc  x31,    0x340, x3
  csrrs  x31,    0x340, x3
  csrrw  x31,    0x340, x3
  csrrc  x31,    0x340, x4
  csrrs  x31,    0x340, x4
  csrrw  x31,    0x340, x4
  csrrc  x31,    0x340, x5
  csrrs  x31,    0x340, x5
  csrrw  x31,    0x340, x5
  csrrc  x31,    0x340, x6
  csrrs  x31,    0x340, x6
  csrrw  x31,    0x340, x6
  csrrc  x31,    0x340, x7
  csrrs  x31,    0x340, x7
  csrrw  x31,    0x340, x7
  csrrc  x31,    0x340, x8
  csrrs  x31,    0x340, x8
  csrrw  x31,    0x340, x8
  csrrc  x31,    0x340, x9
  csrrs  x31,    0x340, x9
  csrrw  x31,    0x340, x9
  csrrc  x31,    0x340, x10
  csrrs  x31,    0x340, x10
  csrrw  x31,    0x340, x10
  csrrc  x31,    0x340, x11
  csrrs  x31,    0x340, x11
  csrrw  x31,    0x340, x11
  csrrc  x31,    0x340, x12
  csrrs  x31,    0x340, x12
  csrrw  x31,    0x340, x12
  csrrc  x31,    0x340, x13
  csrrs  x31,    0x340, x13
  csrrw  x31,    0x340, x13
  csrrc  x31,    0x340, x14
  csrrs  x31,    0x340, x14
  csrrw  x31,    0x340, x14
  csrrc  x31,    0x340, x15
  csrrs  x31,    0x340, x15
  csrrw  x31,    0x340, x15
  csrrc  x31,    0x340, x16
  csrrs  x31,    0x340, x16
  csrrw  x31,    0x340, x16
  csrrc  x31,    0x340, x17
  csrrs  x31,    0x340, x17
  csrrw  x31,    0x340, x17
  csrrc  x31,    0x340, x18
  csrrs  x31,    0x340, x18
  csrrw  x31,    0x340, x18
  csrrc  x31,    0x340, x19
  csrrs  x31,    0x340, x19
  csrrw  x31,    0x340, x19
  csrrc  x31,    0x340, x20
  csrrs  x31,    0x340, x20
  csrrw  x31,    0x340, x20
  csrrc  x31,    0x340, x21
  csrrs  x31,    0x340, x21
  csrrw  x31,    0x340, x21
  csrrc  x31,    0x340, x22
  csrrs  x31,    0x340, x22
  csrrw  x31,    0x340, x22
  csrrc  x31,    0x340, x23
  csrrs  x31,    0x340, x23
  csrrw  x31,    0x340, x23
  csrrc  x31,    0x340, x24
  csrrs  x31,    0x340, x24
  csrrw  x31,    0x340, x24
  csrrc  x31,    0x340, x25
  csrrs  x31,    0x340, x25
  csrrw  x31,    0x340, x25
  csrrc  x31,    0x340, x26
  csrrs  x31,    0x340, x26
  csrrw  x31,    0x340, x26
  csrrc  x31,    0x340, x27
  csrrs  x31,    0x340, x27
  csrrw  x31,    0x340, x27
  csrrc  x31,    0x340, x28
  csrrs  x31,    0x340, x28
  csrrw  x31,    0x340, x28
  csrrc  x31,    0x340, x29
  csrrs  x31,    0x340, x29
  csrrw  x31,    0x340, x29
  csrrc  x31,    0x340, x30
  csrrs  x31,    0x340, x30
  csrrw  x31,    0x340, x30
  csrrc  x31,    0x340, x31
  csrrs  x31,    0x340, x31
  csrrw  x31,    0x340, x31

test_done:
    lui a0,print_port>>12
    addi a1,zero,'\n'
    sw a1,0(a0)
    addi a1,zero,'C'
    sw a1,0(a0)
    addi a1,zero,'V'
    sw a1,0(a0)
    addi a1,zero,'3'
    sw a1,0(a0)
    addi a1,zero,'2'
    sw a1,0(a0)
    addi a1,zero,' '
    sw a1,0(a0)
    addi a1,zero,'D'
    sw a1,0(a0)
    addi a1,zero,'O'
    sw a1,0(a0)
    addi a1,zero,'N'
    sw a1,0(a0)
    addi a1,zero,'E'
    sw a1,0(a0)
    addi a1,zero,'\n'
    sw a1,0(a0)
    sw a1,0(a0)

# extraneous, manually added, store (write) and load (read)
extra_store_load:
    li  x18, 0x12345678
    li  x17, 0x000ffffc
    sw  x18, 0(x17)

    li  x15, 0x000ffffc
    lw  x16, 0(x15)
    bne x16, x18, csr_fail

csr_pass:
    li x18, 123456789
    li x17, 0x20000000
    sw x18,0(x17)
    wfi

csr_fail:
    lui a0,print_port>>12
    addi a1,zero,'\n'
    sw a1,0(a0)
    addi a1,zero,'C'
    sw a1,0(a0)
    addi a1,zero,'V'
    sw a1,0(a0)
    addi a1,zero,'3'
    sw a1,0(a0)
    addi a1,zero,'2'
    sw a1,0(a0)
    addi a1,zero,' '
    sw a1,0(a0)
    addi a1,zero,'F'
    sw a1,0(a0)
    addi a1,zero,'A'
    sw a1,0(a0)
    addi a1,zero,'I'
    sw a1,0(a0)
    addi a1,zero,'L'
    sw a1,0(a0)
    addi a1,zero,'\n'
    sw a1,0(a0)
    sw a1,0(a0)

    li x18, 1
    li x17, 0x20000000
    sw x18,0(x17)
    wfi
#
# end
#
